2010-05-22  Release Manager

	* GCC 4.3.5 released.

2009-08-04  Release Manager

	* GCC 4.3.4 released.

2009-01-24  Release Manager

	* GCC 4.3.3 released.

2008-12-04  Janis Johnson  <janis187@us.ibm.com>

	Backport from mainline:
	2008-10-18  Jakub Jelinek  <jakub@redhat.com>
	            Janis Johnson  <janis187@us.ibm.com>

	* Make-lang.in (check-java-subtargets): New target.

contrib/
	* dg-extract-results.sh: New file.
gcc/
	* Makefile.in (lang_checks_parallelized, check_gcc_parallelize,
	check_p_tool, check_p_vars, check_p_subno, check_p_comma,
	check_p_subwork, check_p_numbers, check_p_subdir, check_p_subdirs):
	New variables.
	(check-subtargets, check-%-subtargets, check-parallel-%): New
	targets.
	(check-%): For test targets listed in lang_checks_parallelized
	if -j is used and RUNTESTFLAGS doesn't specify tests to execute,
	run the testing in multiple make goals, possibly parallel, and
	afterwards run dg-extract-results.sh to merge the sum and log files.
gcc/cp/
	* Make-lang.in (check-c++-subtargets): New alias for
	check-g++-subtargets.
	(lang_checks_parallelized): Add check-g++.
	(check_g++_parallelize): New variable.
gcc/fortran/
	* Make-lang.in (check-f95-subtargets, check-fortran-subtargets): New
	aliases for check-gfortran-subtargets.
	(lang_checks_parallelized): Add check-gfortran.
	(check_gfortran_parallelize): New variable.
gcc/ada/
	* Make-lang.in (check-ada-subtargets): Depend on
	check-acats-subtargets and check-gnat-subtargets.
	(check_acats_targets): New variable.
	(check-acats-subtargets, check-acats%): New targets.
	(check-acats): If -j is used and CHAPTERS is empty, run the testing
	in multiple make goals, possibly parallel, and afterwards run
	dg-extract-results.sh to merge the sum and log files.
gcc/java/
	* Make-lang.in (check-java-subtargets): New target.
libstdc++-v3/
	* testsuite/Makefile.am (AUTOMAKE_OPTIONS): Remove dejagnu.
	(RUNTESTDEFAULTFLAGS, EXPECT, check_DEJAGNU_normal_targets): New
	variables.
	(%/site.exp, check-DEJAGNU%): New targets.
	(check-am): Run $(MAKE) check-DEJAGNU.
	* testsuite/Makefile.in: Regenerated.
2008-10-14  Andrew Haley  <aph@redhat.com>

	* constants.c (build_constant_data_ref): Make sure we only build
	one copy of the decl for the constant pool.

2008-08-27  Release Manager

	* GCC 4.3.2 released.

2008-06-14  Tom Tromey  <tromey@redhat.com>

	PR java/36247:
	* class.c (build_class_ref): Initialize this_classdollar when
	needed.

2008-06-06  Release Manager

	* GCC 4.3.1 released.

2008-04-01  Joseph Myers  <joseph@codesourcery.com>

	* gcj.texi: Include gpl_v3.texi instead of gpl.texi
	* Make-lang.in (TEXI_JAVA_FILES): Include gpl_v3.texi instead of
	gpl.texi.

2008-03-06  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (give_name_to_class): Call find_sourcefile to find
	full pathname of source file.

2008-03-05  Release Manager

	* GCC 4.3.0 released.

2008-03-02  Jakub Jelinek  <jakub@redhat.com>

	* jcf-dump.c (version): Update copyright notice dates.

2008-02-06  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	PR other/35107
	* Make-lang.in (jc1): Add $(GMPLIBS).

2008-01-23  David Daney  <ddaney@avtrex.com>

	* class.c (hide)  Rename to...
	(java_hide_decl) ... this throughout, and make public.
	* resource.c (Jr_count): Remove.
	(compile_resource_data): Call java_mangle_resource_name to generate
	decl name.  Make resource decl public and hidden.
	* mangle.c (java_mangle_resource_name): New function.
	* java-tree.h (java_hide_decl, java_mangle_resource_name): Declare
	functions.

2008-01-04  Andrew Haley  <aph@redhat.com>

	PR java/17779
	* jcf-parse.c (parse_zip_file_entries): Move decl to compile on
	C90.

2008-01-03  Andrew Haley  <aph@redhat.com>

	PR java/17779
	* jcf-parse.c (parse_zip_file_entries): Unset TYPE_ALIAS_SET if
	we're about to re-layout the type.

2007-12-20  Alexandre Oliva  <aoliva@redhat.com>

	* lang.c (java_classify_record): Don't return
	RECORD_IS_INTERFACE for now.

2007-12-18  Andrew Haley  <aph@redhat.com>

	PR java/27643
	* jcf-parse.c (java_parse_file): Remove call to
	java_mark_class_local.
	(parse_class_file): Reinstate call to java_mark_class_local here.
	* decl.c (java_mark_cni_decl_local): If the ASSEMBLER_NAME is
	already set, call java_mangle_decl() and make_decl_rtl() to
	rewrite its name as a hidden alias.

2007-12-15  Alexandre Oliva  <aoliva@redhat.com>

	PR debug/7081
	* lang.c (java_classify_record): New.
	(LANG_HOOKS_CLASSIFY_RECORD): Override.

2007-11-26  Andreas Krebbel  <krebbel1@de.ibm.com>

	PR 34081/C++
	* decl.c (finish_method): Pass 'false' for the new
	allocate_struct_function parameter.

2007-11-26  Alexandre Oliva  <aoliva@redhat.com>

	* expr.c (build_jni_stub): Use the computed jni func type for
	variable meth.

2007-11-26  Alexandre Oliva  <aoliva@redhat.com>

	* class.c (JAVA_TREEHASHHASH_H): Use TYPE_UID.

2007-11-26  Alexandre Oliva  <aoliva@redhat.com>

	* expr.c (type_assertion_hash): Hash type uids rather than
	tree pointers.

2007-11-17  David Daney  <ddaney@avtrex.com>
	    Andrew Haley  <aph@redhat.com>

	* constants.c (build_constants_constructor):  Use POINTER_SIZE
	insead of BITS_PER_WORD in big-endian work around.

2007-11-07  Tom Tromey  <tromey@redhat.com>

	PR java/34019:
	* gcj.texi (Input Options): Add missing noun.

2007-11-02  Tom Tromey  <tromey@redhat.com>

	PR java/33765:
	* jcf-parse.c (java_parse_file): Ignore ZIPEMPTYMAGIC files.
	* zipfile.h (ZIPEMPTYMAGIC): New define.

2007-11-01  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (java/jcf-dump.o): Depend on zipfile.h.
	(java/jcf-parse.o): Depend on jcf-reader.c, zipfile.h, and jcf.h.
	(java/jcf-io.o): Depend on zipfile.h.

2007-10-17  Richard Guenther  <rguenther@suse.de>

	* Make-lang.in (java/builtins.o): Add $(OPTABS_H) and $(EXPR_H)
	dependencies.

2007-10-03  Andrew Haley  <aph@redhat.com>

	PR java/33639
	* class.c (mangled_classname): Detect and replace illegal
	characters in assembly language symbols.
	(gen_indirect_dispatch_tables): Call mangled_classname() on
	the type.

2007-09-27  Jakub Jelinek  <jakub@redhat.com>

	* lang.c (java_print_error_function): Add third argument.

2007-09-15  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (struct lang_decl_func) <function_decl_body>:
	Remove.
	<init_final>: Likewise.
	* lang.c (java_dump_tree): Update.
	* java-tree.h (DECL_FUNCTION_BODY): Remove.

2007-09-11  Jan Hubicka <jh@suse.cz>

	* decl.c (java_expand_body): Kill.
	(LANG_HOOKS_CALLGRAPH_EXPAND_FUNCTION): Kill.

2007-09-06  Tom Tromey  <tromey@redhat.com>

	* jcf-parse.c (parse_class_file): Re-enter the current file.

2007-09-07  Roman Zippel  <zippel@linux-m68k.org>

	* boehm.c (mark_reference_fields): Move misaligned pointer check
	after JREFERENCE_TYPE_P test

2007-09-06  Roman Zippel  <zippel@linux-m68k.org>

	* boehm.c (mark_reference_fields): Don't use bitmap as gc_descr
	if pointer is misaligned.

2007-09-06  Tom Tromey  <tromey@redhat.com>

	* lang.c (java_post_options): Update.
	* jcf-parse.c (set_source_filename): Update.
	(give_name_to_class): Update.
	(jcf_parse): Update.
	(duplicate_class_warning): Update.
	(parse_class_file): Update.
	(java_parse_file): Update.
	* expr.c (expand_byte_code): Update.

2007-09-05  Sandra Loosemore  <sandra@codesourcery.com>

	* decl.c (finish_method): Use set_cfun.

2007-09-04  Andrew Haley  <aph@redhat.com>

	* decl.c (java_init_decl_processing): Call "__cxa_end_cleanup"
	when using the ARM EABI.

2007-09-03  Daniel Jacobowitz  <dan@codesourcery.com>

	* Make-lang.in (jvspec.o): Remove SHLIB_MULTILIB.

2007-09-03  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jcf-parse.c (read_class, java_parse_file): Supply a TYPE for
	CONST_CAST.
	* jcf.h (JCF_FINISH): Likewise.

2007-08-28  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (java.tags): Don't tag '*.y' files.

2007-08-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* lang.c (java_decl_ok_for_sibcall): Likewise.

2007-08-21  Paul Brook  <paul@codesourcery.com>
	    Nathan Sidwell  <nathan@codesourcery.com>
	    Mark Mitchell  <mark@codesourcery.com>
	    Joseph Myers  <joseph@codesourcery.com>

	* jcf-dump.c (version): Use pkgversion_string.  Update copyright
	date.

2007-08-20  Richard Guenther  <rguenther@suse.de>

	* lang.c (java_tree_inlining_walk_subtrees): Remove.
	(LANG_HOOKS_TREE_INLINING_WALK_SUBTREES): Remove.

2007-08-17  Tom Tromey  <tromey@redhat.com>

	* typeck.c (find_method_in_interfaces): Update.
	* jcf-parse.c (load_class): Update.
	* java-gimplify.c (java_gimplify_component_ref): Removed.
	(java_gimplify_modify_expr): Update.  Removed pre_p and post_p
	arguments.
	(java_gimplify_expr): Update.
	* decl.c (java_init_decl_processing): Update.
	* class.c (set_constant_value): Update.
	(make_class_data): Update.
	(finish_class): Update.
	(build_static_field_ref): Update.
	(is_compiled_class): Update.
	(maybe_layout_super_class): Update.
	(layout_class): Update.
	(layout_class_method): Update.
	* java-tree.h (CAN_COMPLETE_NORMALLY): Removed.
	(lang_decl_var) <am, final_iud, cif>: Removed fields.
	(lang_decl_func) <init_calls_this>: Removed field.
	(lang_type) <dot_class, verify_method>: Removed fields.
	(FIELD_NESTED_ACCESS): Removed.
	(FIELD_NESTED_ACCESS_P): Removed.
	(DECL_FIELD_FINAL_IUD): Removed.
	(DECL_LOCAL_FINAL_IUD): Removed
	(LOCAL_FINAL_P): Removed.
	(FINAL_VARIABLE_P): Removed.
	(CLASS_FINAL_VARIABLE_P): Removed.
	(DECL_BIT_INDEX): Removed.
	(DECL_INIT_CALLS_THIS): Removed.
	(FIELD_LOCAL_ALIAS): Removed.
	(FIELD_LOCAL_ALIAS_USED): Removed.
	(FIELD_THISN): Removed.
	(DECL_FUNCTION_INIT_TEST_CLASS): Removed.
	(LOCAL_CLASS_INITIALIZATION_FLAG): Removed.
	(LOCAL_CLASS_INITIALIZATION_FLAG_P): Removed.
	(TYPE_DOT_CLASS): Removed.
	(TYPE_VERIFY_METHOD): Removed.
	(ID_CLASSDOLLAR_P): Removed.
	(enum java_tree_index) <JTI_CLASSDOLLAR_IDENTIFIER_NODE>:
	Removed.
	(classdollar_identifier_node): Removed.
	(TYPE_UNKNOWN): Removed.
	(CLASS_FROM_SOURCE_P): Removed.
	* expr.c (build_jni_stub): Update.
	(force_evaluation_order): Update.
	(build_java_empty_stmt): Update.
	(build_class_init): Update.
	(java_stack_swap): Update.
	(build_jni_stub): Update.

2007-08-17  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (LABEL_TYPE_STATE): Removed.
	(load_type_state): Removed.
	(LABEL_PC): Removed.
	(LABEL_VERIFIED): Removed.
	(type_states): Declare.
	* expr.c (type_states): New global.
	(load_type_state): Now static.  Use type_states.  Changed
	argument.
	(lookup_label): Don't set LABEL_PC.
	(expand_byte_code): Don't use LABEL_VERIFIED.
	(note_instructions): Initialize type_states.
	* verify-glue.c (vfy_note_stack_depth): Rewrote.
	(vfy_note_stack_type): Use type_states.
	(vfy_note_local_type): Likewise.

2007-08-10  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jcf-parse.c (read_class, java_parse_file): Use CONST_CAST.
	* jcf.h (JCF_FINISH): Likewise.

2007-07-31  Nick Clifton  <nickc@redhat.com>

	* java-gimplify.c: Change copyright header to refer to version 3
	of the GNU General Public License and to point readers at the
	COPYING3 file and the FSF's license web page.
	* typeck.c, lang-specs.h, mangle_name.c, jcf-dump.c, class.c,
	decl.c, config-lang.in, jcf-parse.c, constants.c, Make-lang.in,
	resource.c, except.c, builtins.c, jvspec.c, java-tree.def,
	javaop.def, jcf-path.c, verify-glue.c, jcf-depend.c, lang.opt,
	jcf-reader.c, mangle.c, zextract.c, jcf-io.c, jcf.h, zipfile.h,
	verify.h, java-except.h, win32-host.c, expr.c, jvgenmain.c,
	parse.h, lang.c, java-tree.h, javaop.h, boehm.c: Likewise.

2007-07-30  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jcf-io.c (find_class): Fix -Wcast-qual warnings.

2007-07-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* lang.c (java_get_callee_fndecl): Constify.

2007-07-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mangle.c (set_type_package_list): Constify.
	* verify-glue.c (vfy_make_string): Delete.
	* verify.h (vfy_make_string): Likewise.

2007-07-26  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (push_labeled_block, pop_labeled_block): Remove.
	(LABELED_BLOCK_LABEL, LABELED_BLOCK_BODY,
	EXIT_BLOCK_LABELED_BLOCK): Likewise.
	* lang.c (java_tree_inlining_walk_subtrees): Update.
	(java_dump_tree): Likewise.
	* java-tree.def (LABELED_BLOCK_EXPR, EXIT_BLOCK_EXPR, TRY_EXPR):
	Remove.
	* decl.c (push_labeled_block, pop_labeled_block): Remove.
	* java-gimplify.c (java_gimplify_labeled_block_expr,
	java_gimplify_exit_block_expr, java_gimplify_try_expr): Remove.
	(java_gimplify_expr): Update.

2007-07-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c (java_treetreehash_hash, java_treetreehash_compare):
	Constify. 
	* expr.c (type_assertion_eq): Likewise.
	* jcf-io.c (compare_path): Likewise.
	* jcf-parse.c (cmpstringp): Likewise.
	* verify-impl.c (get_one_type, compute_argument_types,
	compute_return_type): Likewise. 

2007-07-16  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	PR target/32462
	PR libgcj/32465
	* class.c (hide): Wrap in HAVE_GAS_HIDDEN.

2007-07-12  Richard Guenther  <rguenther@suse.de>

	* expr.c (expand_java_return): RETURN_EXPR has void type.
	(build_jni_stub): Likewise.  Use a comparison against zero
	for null-pointer test in COND_EXPR.
	(build_field_ref): Build POINTER_PLUS_EXPR with correct
	type.  Convert result instead.
	(build_invokevirtual): Likewise.

2007-07-09  Geoffrey Keating  <geoffk@apple.com>

	PR 32617
	* lang.c (java_init): Remove setting of force_align_functions_log.
	* class.c (add_method_1): Set DECL_ALIGN of non-static method
	to cope with ptrmemfunc_vbit_in_pfn.

2007-07-03  David Daney  <ddaney@avtrex.com>

	* java/Make-lang.in (doc/gcj.info): Add $(gcc_docdir) to 
	include path.
	(doc/gcj.dvi): Same.
	(doc/gcj.pdf): Same.
	(java/index.html): Same.

2007-06-15 Andrew Pinski  <andrew_pinski@playstation.sony.com>

	* class.c (make_class_data): Build the index in sizetype.
	Use POINTER_PLUS_EXPR instead of PLUS_EXPR when
	adding to a pointer type.
	(build_symbol_entry): Likewise.
	* expr.c (build_java_arrayaccess): Likewise.
	(build_field_ref): Likewise.
	(build_known_method_ref): Likewise.
	(build_invokevirtual): Likewise.
	* except.c (build_exception_object_ref): Do a
	NEGATIVE and then a POINTER_PLUS_EXPR instead
	of a MINUS_EXPR.

2007-06-11  Rafael Avila de Espindola  <espindola@google.com>

	* typeck.c (java_signed_type): Remove.
	* lang.c (LANG_HOOKS_SIGNED_TYPE): Remove.
	* java-tree.h (java_signed_type): Remove.

2007-05-18  Geoffrey Keating  <geoffk@apple.com>

	* jcf-dump.c (HANDLE_MAGIC): Use 'unsigned long' for %lx.
	(print_constant): Likewise.

2007-05-14  Rafael Avila de Espindola  <espindola@google.com>

	* expr.c (build_java_binop): Use unsigned_type_for instead of
	java_unsigned_type.
	* java-tree.h (java_unsigned_type): Remove.
	* lang.c (LANG_HOOKS_UNSIGNED_TYPE): Remove.
	* typeck.c (java_unsigned_type): Remove.

2007-04-21  Andrew Pinski  <andrew_pinski@playstation.sony.com>

	* java-tree.h (lang_tree_node): Use GENERIC_NEXT
	instead of checking GIMPLE_STMT_P in chain_next.

2007-04-06  Colin Walters  <walters@redhat.com>

	https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=161701
	* jcf-io.c (open_class): Copy 'filename'.

2007-04-03  Andrew Haley  <aph@redhat.com>

        * jvgenmain.c (main): Change main to use class$, not class$$.
        (do_mangle_classname): Likewise.
        * class.c (hide): New function.
        (add_field): Hide everything that shouldn't be visible outside a
        DSO.
        (build_static_class_ref): Likewise.
        (build_classdollar_field): Likewise.
        (make_class_data): Likewise.
        (layout_class_method): Likewise.
        * expr.c (special_method_p): New function.

	* class.c (push_class): Don't bogusly guess the source filename.
	* jcf-parse.c (give_name_to_class): Don't set input_location from
	DECL_ARTIFICIAL decls.

2007-03-30  Rafael Avila de Espindola  <espindola@google.com>

	* typeck.c (java_signed_or_unsigned_type): Removed.
	(java_signed_type): use get_signed_or_unsigned_type instead of
	java_signed_or_unsigned_type.
	(java_unsigned_type): Ditto.
	* lang.c (LANG_HOOKS_SIGNED_OR_UNSIGNED_TYPE): Removed.
	* java-tree.h (java_signed_or_unsigned_type): Removed.

2007-03-26  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (JAVA_MANFILES): Removed grmiregistry.1.
	(java.maintainer-clean): Likewise.
	(java.install-man): Likewise.
	(.INTERMEDIATE): Removed grmiregistry.pod.
	(grmiregistry.pod): Removed.
	* gcj.texi (Invoking gcjh): Removed.
	(Invoking gjnih): Likewise.
	(Invoking grmiregistry): Likewise.
	(direntry): Updated.
	(Top): Likewise.
	(which-gcj): Removed.

2007-03-01  Brooks Moses  <brooks.moses@codesourcery.com>

	* Make-lang.in: Add install-pdf target as copied from
	automake v1.10 rules.

2007-02-27  Brooks Moses  <brooks.moses@codesourcery.com>

	* gcj.texi: Standardize title page.

2007-02-18  Kazu Hirata  <kazu@codesourcery.com>

	* class.c: Fix a comment typo.

2007-02-15  Sandra Loosemore  <sandra@codesourcery.com>
	    Brooks Moses  <brooks.moses@codesourcery.com>
	    Lee Millward  <lee.millward@codesourcery.com>

	* java-tree.h (BUILD_MONITOR_ENTER): Use build_call_nary instead
	of build3.
	(BUILD_MONITOR_EXIT): Likewise.

	* java-gimplify.c (java_gimplify_component_ref): Use build_call_expr.
	(java_gimplify_modify_expr): Likewise.

	* class.c (cache_this_class_ref): Use build_call_expr.
	(build_static_field_ref): Likewise.
	(emit_indirect_register_classes): Likewise.
	(emit_register_classes): Likewise.

	* resource.c (write_resource_constructor): Use build_call_expr.

	* builtins.c (builtin_creator_function): Change interpretation of
	the second parameter to be the whole CALL_EXPR instead of the arglist.
	(max_builtin): Tweak parameter list.  Use new CALL_EXPR accessors.
	(min_builtin): Likewise.
	(abs_builtin): Likewise.
	(java_build_function_call_expr): Likewise.
	(convert_real): Likewise.
	(UNMARSHAL3): Likewise.
	(UNMARSHAL4): Likewise.
	(UNMARSHAL5): Likewise.
	(build_arglist_for_builtin): Delete.  Fix callers to use
	build_call_expr instead.
	(putObject_builtin): Tweak parameter list.  Use new CALL_EXPR
	accessors.
	(compareAndSwapInt_builtin): Likewise.
	(compareAndSwapLong_builtin): Likewise.
	(compareAndSwapObject_builtin): Likewise.
	(putVolatile_builtin): Likewise.
	(getVolatile_builtin): Likewise.
	(VMSupportsCS8_builtin): Likewise.
	(check_for_builtin): Pass entire CALL_EXPR to builtin expander
	instead of arglist.

	* expr.c (build_java_athrow): Use build_call_nary instead of build3.
	(build_java_throw_out_of_bounds_exception): Likewise.
	(java_check_reference): Likewise.
	(build_java_arraystore_check): Likewise.
	(build_newarray): Likewise.
	(build_anewarray): Likewise.
	(expand_java_multinewarray): Use build_call_list instead of build3.
	(build_java_monitor): Use build_call_nary instead of build3.
	(java_create_object): Likewise.
	(expand_java_NEW): Likewise.
	(build_instanceof): Likewise.
	(expand_java_CHECKCAST): Likewise.
	(build_java_soft_divmod): Likewise.
	(build_java_binop): Likewise.
	(build_field_ref): Likewise.
	(build_class_init): Likewise.
	(rewrite_arglist_getcaller): Use build_call_expr.
	(build_invokeinterface):  Use build_call_nary instead of build3.
	(expand_invoke): Use build_call_list instead of build3.
	(build_jni_stub): Use build_call_nary, build_call_list, or
	build_call_expr instead	of build3.
	(expand_java_field_op): Use build_call_expr instead of build3.
	(force_evaluation_order): Use new CALL_EXPR accessors.

	* lang.c (java_get_callee_fndecl): Use new CALL_EXPR accessors.

2007-02-15  David Daney  <ddaney@avtrex.com>

	* Make-lang.in (JAVA_MANFILES): Add doc/gc-analyze.1.
	(java.maintainer-clean):Add gc-analyze.1.
	(.INTERMEDIATE): Add gc-analyze.pod.
	(gc-analyze.pod): New rule.
	(java.install-man): Install gc-analyze.1
	* gcj.texi: Add new section for the gc-analyze program.

2007-02-07  Andrew Haley  <aph@redhat.com>

	* class.c (uncache_this_class_ref): New.
	* expr.c (build_jni_stub): Initialize the class.
	(expand_byte_code): Call uncache_this_class_ref after generating
	code.

2007-02-06  Tom Tromey  <tromey@redhat.com>

	PR java/30714:
	* jvspec.c (lang_specific_driver): Check for the '-' in '-I'.

2007-02-03  Kazu Hirata  <kazu@codesourcery.com>

	* java-tree.h, javaop.def, jcf-parse.c: Fix comment typos.

2007-02-02  Andrew Haley  <aph@redhat.com>

	* expr.c (expand_byte_code): Call cache_this_class_ref() and
	cache_cpool_data_ref().
	Set TYPE_CPOOL_DATA_REF.
	(cache_cpool_data_ref): New function.
	* constants.c (build_ref_from_constant_pool): Remove special-case
	code for flag_indirect_classes.
	(build_constant_data_ref): Move special-case code for
	flag_indirect_classes here from build_ref_from_constant_pool.
	* decl.c (finish_method): Move class initialization from here to
	cache_this_class_ref.
	* class.c (cache_this_class_ref): New function.
	(build_class_ref): Use this_classdollar for the ouput class.

2007-02-02  David Daney  <ddaney@avtrex.com>

	* class.c (is_compiled_class): Move check to avoid reloading
	current class.
	(layout_class_method): Don't calculate DECL_EXTERNAL if it is
	already set.

2007-02-01  Andrew Haley  <aph@redhat.com>

	PR java/30641
	* jcf-parse.c (jcf_parse): Clear the field_offsets bitmap.

2007-01-31  Kazu Hirata  <kazu@codesourcery.com>

	* class.c, jcf-parse.c: Fix comment typos.

2007-01-30  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Strings): Fix documentation for JvNewString.

2007-01-30  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	* gcj.texi (Invoking gcjh, Invoking gjnih, Arrays): Fix some
	typos.

2007-01-30  Ben Elliston  <bje@au.ibm.com>

	* jvspec.c (lang_specific_driver): Remove unused classpath_args.

2007-01-29  Tom Tromey  <tromey@redhat.com>

	PR java/30607:
	* jvspec.c (lang_specific_driver): Handle separate -I argument.
	* lang.opt (-I): Add 'Separate'.

2007-01-29  Andrew Haley  <aph@redhat.com>

	* class.c (add_method_1): Mark fndecl as external unless we are
	compiling it into this object file.

2007-01-24  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (HANDLE_SYNTHETIC_ATTRIBUTE): current_class is a
	type node, not a decl, so use TYPE_SYNTHETIC not CLASS_SYNTHETIC.

2007-01-22  Andrew Haley  <aph@redhat.com>

	* builtins.c (VMSupportsCS8_builtin): New function.

2007-01-23  Andrew Pinski  <pinskia@gmail.com>

	PR java/30454
	* jcf-io.c (opendir_in_zip): Close the file
	and free zipf before returning after an error.

2007-01-16  Tom Tromey  <tromey@redhat.com>

	* java-tree.def: Added copyright header.

2007-01-15  Tom Tromey  <tromey@redhat.com>

	* lang.c (dump_compound_expr) <EXPR_WITH_FILE_LOCATION>: Removed
	case.
	* java-gimplify.c (java_gimplify_expr) <EXPR_WITH_FILE_LOCATION>:
	Removed case.
	* java-tree.h (EXPR_WFL_EMIT_LINE_NOTE): Removed.
	(EXPR_WFL_NODE): Likewise.
	(EXPR_WFL_LINECOL): Likewise.
	(EXPR_WFL_FILENAME): Likewise.
	(EXPR_WFL_LINENO): Likewise.
	(build_expr_wfl, expr_add_location): Don't declare.
	(build_unknown_wfl): Removed.
	(EXPR_WFL_FILENAME_NODE): Removed.
	(EXPR_WFL_COLNO): Removed.
	(EXPR_WFL_SET_LINECOL): Removed.
	(DECL_FUNCTION_WFL): Removed.
	(DECL_FIELD_FINAL_WFL): Removed.
	(struct lang_decl_func) <wfl>: Removed field.
	<called_constructor>: Likewise.
	<inner_access>: Likewise.
	(struct lang_decl_var) <wfl>: Removed field.
	(DECL_CONSTRUCTOR_CALLS): Removed.
	(DECL_FUNCTION_ACCESS_DECL): Likewise.
	(DECL_FUNCTION_INNER_ACCESS): Likewise.
	(DECL_SPECIFIC_COUNT): Likewise.
	* java-tree.def (EXPR_WITH_FILE_LOCATION): Removed.
	* expr.c (build_expr_wfl): Removed.
	(expr_add_location): Likewise.

2007-01-12  Tom Tromey  <tromey@redhat.com>

	* jcf-dump.c (main): Updated call to find_class.
	* lang.c (java_init): Removed dead code.
	* jcf-parse.c (read_class): Don't use java_source field.  Removed
	dead code.
	(parse_zip_file_entries): Don't use java_source field.
	(process_zip_dir): Likewise.
	(jcf_parse): Removed dead code.
	(java_parse_file): Likewise.
	(read_class): Updated call to find_class.
	* jcf-io.c (find_class): Don't use java_source field.  Removed
	'source_ok' argument, .java logic.
	* jcf.h (JCF) <java_source>: Removed field.
	(JCF_ZERO): Updated.	(find_class): Updated.
	* decl.c: Removed dead code.
	* class.c: Removed dead code.

2007-01-11  Tom Tromey  <tromey@redhat.com>

	* typeck.c (convert): Don't use flag_emit_class_files.
	* lang.c (java_post_options): Don't use flag_emit_class_files.
	(java_handle_option): Don't use flag_extraneous_semicolon or
	flag_redundant.
	* jcf-parse.c (HANDLE_CONSTANTVALUE): Don't use
	flag_emit_class_files.
	(load_class): Likewise.
	* java-tree.h (flag_emit_class_files): Don't declare.
	(STATIC_CLASS_INIT_OPT_P): Don't use flag_emit_class_files.
	(flag_extraneous_semicolon): Don't declare.
	(flag_not_overriding): Likewise.
	(flag_static_local_jdk1_1): Likewise.
	(flag_redundant): Likewise.
	* expr.c (build_newarray): Don't use flag_emit_class_files.
	* class.c (DEFAULT_ENABLE_ASSERT): Don't use
	flag_emit_class_files.
	(build_class_ref): Likewise.
	* builtins.c (check_for_builtin): Don't use
	flag_emit_class_files.

2007-01-10  Tom Tromey  <tromey@redhat.com>

	* lang.c (java_can_use_bit_fields_p): Removed.
	(LANG_HOOKS_CAN_USE_BIT_FIELDS_P): Removed.

2007-01-09  Andrew Haley  <aph@redhat.com>

	* expr.c (build_java_arrayaccess): Rewrite to generate array
	access in canonical form.
	(expand_java_arraystore): Use build_fold_addr_expr() on address of
	array access.

2007-01-03  Andrew Haley  <aph@redhat.com>

	PR java/28754
	* expr.c (expand_java_field_op): If we're initializing a field's
	declaring interface we should not also initialize the class
	context in which it was referenced.

2007-01-02  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (compiling_from_source, current_encoding,
	JTI_FINIT_IDENTIFIER_NODE, JTI_INSTINIT_IDENTIFIER_NODE,
	JTI_LENGTH_IDENTIFIER_NODE, JTI_SUPER_IDENTIFIER_NODE,
	JTI_CONTINUE_IDENTIFIER_NODE, JTI_ACCESS0_IDENTIFIER_NODE,
	JTI_WFL_OPERATOR): Removed
	(finit_identifier_node, instinit_identifier_node,
	length_identifier_node, super_identifier_node,
	continue_identifier_node, access0_identifier_node, wfl_operator):
	Removed.
	(cyclic_inheritance_report,
	DECL_FUNCTION_STATIC_METHOD_INVOCATION_COMPOUND,
	DECL_FUNCTION_NAP, DECL_FUNCTION_SYNTHETIC_CTOR,
	DECL_FIXED_CONSTRUCTOR_P): Removed.
	(struct lang_decl_func) <smic, nap, synthetic_ctor, fixed_ctor>:
	Removed.
	(TYPE_FINIT_STMT_LIST, TYPE_CLINIT_STMT_LIST, TYPE_II_STMT_LIST,
	TYPE_IMPORT_LIST, TYPE_IMPORT_DEMAND_LIST): Removed.
	(struct lang_type) <finit_stmt_list, clinit_stmt_list, ii_block,
	import_list, import_demand_list>: Removed.
	(java_layout_seen_class_methods, init_jcf_parse, init_src_parse,
	cxx_keyword_p): Removed.
	(DECL_FINIT_P, DECL_INSTINIT_P, ID_FINIT_P, ID_INSTINIT_P,
	TYPE_UNUSED, TYPE_UNDERFLOW, TYPE_UNEXPECTED,
	CLASS_ACCESS0_GENERATED_P, CLASS_HAS_FINIT_P,
	IS_A_SINGLE_IMPORT_CLASSFILE_NAME_P, IS_A_CLASSFILE_NAME,
	IS_AN_IMPORT_ON_DEMAND_P, COMPOUND_ASSIGN_P, SWITCH_HAS_DEFAULT,
	PRIMARY_P, MODIFY_EXPR_FROM_INITIALIZATION_P,
	CLASS_METHOD_CHECKED_P, FOR_LOOP_P, ANONYMOUS_CLASS_P,
	LOCAL_CLASS_P, ARG_FINAL_P, SUPPRESS_UNREACHABLE_ERROR,
	RESOLVE_PACKAGE_NAME_P, RESOLVE_TYPE_NAME_P, IS_BREAK_STMT_P,
	IS_CRAFTED_STRING_BUFFER_P, IS_INIT_CHECKED, CALL_USING_SUPER,
	NESTED_FIELD_ACCESS_IDENTIFIER_P, TOPLEVEL_CLASS_DECL_P,
	PURE_INNER_CLASS_TYPE_P, TOPLEVEL_CLASS_TYPE_P,
	CALL_CONSTRUCTOR_P, CALL_EXPLICIT_CONSTRUCTOR_P,
	CALL_THIS_CONSTRUCTOR_P, CALL_SUPER_CONSTRUCTOR_P,
	FINALLY_EXPR_LABEL, FINALLY_EXPR_BLOCK, BLOCK_IS_IMPLICIT,
	BLOCK_EMPTY_P, IS_UNCHECKED_EXCEPTION_P, java_error_count,
	java_parse_abort_on_error, extract_field_decl): Removed.
	(finput): Declare.
	* lang.c: (compiling_from_source, current_encoding): Removed.
	(java_handle_option): Ignore -fencoding.
	* parse.h: Don't include lex.h.
	(java_error_count, int_fits_type_p, stabilize_reference, RULE,
	RECOVERED, DRECOVERED, RECOVER, DRECOVER, YYERROR_NOW,
	YYNOT_TWICE, CLASS_MODIFIERS, FIELD_MODIFIERS, METHOD_MODIFIERS,
	INTERFACE_MODIFIERS, INTERFACE_INNER_MODIFIERS,
	INTERFACE_METHOD_MODIFIERS, INTERFACE_FIELD_MODIFIERS,
	MODIFIER_WFL, THIS_MODIFIER_ONLY, parse_error_context,
	ABSTRACT_CHECK, JCONSTRUCTOR_CHECK, exit_java_complete_class,
	CLASS_OR_INTERFACE, GET_REAL_TYPE, GET_TYPE_NAME,
	OBSOLETE_MODIFIER_WARNING, OBSOLETE_MODIFIER_WARNING2,
	BUILD_PTR_FROM_NAME, INCOMPLETE_TYPE_P,
	JAVA_MAYBE_GENERATE_DEBUG_INFO, JBSC_TYPE_P, JSTRING_P,
	JNULLP_TYPE_P, JDECL_P, TYPE_INTERFACE_P, TYPE_CLASS_P,
	IDENTIFIER_INNER_CLASS_OUTER_FIELD_ACCESS,
	MANGLE_OUTER_LOCAL_VARIABLE_NAME,
	MANGLE_ALIAS_INITIALIZER_PARAMETER_NAME_ID,
	MANGLE_ALIAS_INITIALIZER_PARAMETER_NAME_STRING,
	SKIP_THIS_AND_ARTIFICIAL_PARMS, MARK_FINAL_PARMS,
	UNMARK_FINAL_PARMS, CRAFTED_PARAM_LIST_FIXUP,
	AIPL_FUNCTION_CREATION, AIPL_FUNCTION_DECLARATION,
	AIPL_FUNCTION_CTOR_INVOCATION, AIPL_FUNCTION_FINIT_INVOCATION,
	ERROR_CANT_CONVERT_TO_BOOLEAN, ERROR_CANT_CONVERT_TO_NUMERIC,
	ERROR_CAST_NEEDED_TO_INTEGRAL, ERROR_VARIABLE_NOT_INITIALIZED,
	LOOP_EXPR_BODY_MAIN_BLOCK, LOOP_EXPR_BODY_UPDATE_BLOCK,
	LOOP_EXPR_BODY_CONDITION_EXPR, LOOP_EXPR_BODY_LABELED_BODY,
	LOOP_EXPR_BODY_BODY_EXPR, PUSH_LABELED_BLOCK, POP_LABELED_BLOCK,
	PUSH_LOOP, POP_LOOP, PUSH_EXCEPTIONS, POP_EXCEPTIONS,
	IN_TRY_BLOCK_P, EXCEPTIONS_P, ANONYMOUS_ARRAY_BASE_TYPE,
	ANONYMOUS_ARRAY_DIMS_SIG, ANONYMOUS_ARRAY_INITIALIZER,
	INVOKE_STATIC, INVOKE_NONVIRTUAL, INVOKE_SUPER, INVOKE_INTERFACE,
	INVOKE_VIRTUAL, jdep_code, struct _jdep, JDEP_DECL, JDEP_DECL_WFL,
	JDEP_KIND, JDEP_WFL, JDEP_MISC, JDEP_ENCLOSING, JDEP_CLASS,
	JDEP_APPLY_PATCH, JDEP_GET_PATCH, JDEP_CHAIN, JDEP_TO_RESOLVE,
	JDEP_RESOLVED_DECL, JDEP_RESOLVED, JDEP_RESOLVED_P, struct
	jdeplist_s, jdeplists, CLASSD_FIRST, CLASSD_LAST, CLASSD_CHAIN,
	JDEP_INSERT, SET_TYPE_FOR_RESOLUTION, WFL_STRIP_BRACKET,
	STRING_STRIP_BRACKETS, PROMOTE_RECORD_IF_COMPLETE,
	BLOCK_CHAIN_DECL, GET_CURRENT_BLOCK, EXPR_WFL_GET_LINECOL,
	EXPR_WFL_QUALIFICATION, QUAL_WFL, QUAL_RESOLUTION, QUAL_DECL_TYPE,
	GET_SKIP_TYPE, COMPLETE_CHECK_OP, COMPLETE_CHECK_OP_0,
	COMPLETE_CHECK_OP_1, COMPLETE_CHECK_OP_2, BUILD_APPEND,
	BUILD_STRING_BUFFER, BUILD_THROW, SET_WFL_OPERATOR,
	PATCH_METHOD_RETURN_ERROR, CHECK_METHODS, CLEAR_DEPRECATED,
	CHECK_DEPRECATED_NO_RESET, CHECK_DEPRECATED, REGISTER_IMPORT,
	CURRENT_OSB, struct parser_ctxt, GET_CPC_LIST, CPC_INNER_P,
	GET_CPC, GET_CPC_UN, GET_CPC_UN_MODE, GET_CPC_DECL_NODE,
	GET_ENCLOSING_CPC, GET_NEXT_ENCLOSING_CPC,
	GET_ENCLOSING_CPC_CONTEXT, INNER_ENCLOSING_SCOPE_CHECK, PUSH_CPC,
	PUSH_ERROR, POP_CPC, DEBUG_CPC, CPC_INITIALIZER_LIST,
	CPC_STATIC_INITIALIZER_LIST, CPC_INSTANCE_INITIALIZER_LIST,
	CPC_INITIALIZER_STMT, CPC_STATIC_INITIALIZER_STMT,
	CPC_INSTANCE_INITIALIZER_STMT, SET_CPC_INITIALIZER_STMT,
	SET_CPC_STATIC_INITIALIZER_STMT,
	SET_CPC_INSTANCE_INITIALIZER_STMT, JAVA_NOT_RADIX10_FLAG,
	java_complete_class, java_check_circular_reference,
	java_fix_constructors, java_layout_classes, java_reorder_fields,
	java_method_add_stmt, java_get_line_col, reset_report,
	java_init_lex, yyparse, java_parse, yyerror, java_expand_classes,
	java_finish_classes, ctxp, ctxp_for_generation,
	ctxp_for_generation_last): Removed.
	* expr.c (force_evaluation_order): Don't mention NEW_CLASS_EXPR.
	* mangle.c (utf8_cmp): New function.
	(cxx_keywords): New global.
	(cxx_keyword_p): New function.
	* jvspec.c (JAVA_START_CHAR): Removed obsolete comment.
	* java-tree.def (UNARY_PLUS_EXPR, NEW_ARRAY_EXPR,
	NEW_ANONYMOUS_ARRAY_EXPR, NEW_CLASS_EXPR, THIS_EXPR,
	CASE_EXPR, DEFAULT_EXPR, JAVA_CATCH_EXPR, SYNCHRONIZED_EXPR,
	THROW_EXPR, CONDITIONAL_EXPR, INSTANCEOF_EXPR, NEW_ARRAY_INIT,
	CLASS_LITERAL, JAVA_EXC_OBJ_EXPR): Removed.
	* Make-lang.in (java.srcextra): Do nothing.
	(parse.c, keyword.h, gt-java-parse.h): Removed targets.
	(JAVA_OBJS): Don't mention deleted files.
	(java.mostlyclean): Likewise.
	(java.clean): Likewise.
	(JAVA_LEX_C): Removed.
	(buffer.o, check-init.o, parse.o): Remove unused targets.
	(typeck.o): Updated.
	* jcf-parse.c (read_class): Comment out unused code.
	(java_layout_seen_class_methods): New function.
	(parse_source_file_1, parse_source_file_2, parse_source_file_3):
	Removed.
	(java_parse_file): Comment out unused code.  Don't use 'ctxp'.
	(init_jcf_parse): Removed.
	* config-lang.in (gtfiles): Remove deleted files.
	* decl.c (java_init_decl_processing): Don't initialize
	finit_identifier_node, instinit_identifier_node,
	length_identifier_node, super_identifier_node,
	continue_identifier_node, access0_identifier_node.  Don't call
	init_jcf_parse.
	* class.c (cyclic_inheritance_report): New global.
	(add_method_1): Don't use
	DECL_FUNCTION_STATIC_METHOD_INVOCATION_COMPOUND.
	(maybe_layout_super_class): Comment out code.
	(safe_layout_class): New function.
	* java-gimplify.c (java_gimplify_expr): Removed CASE_EXPR,
	DEFAULT_EXPR, NEW_ARRAY_INIT, JAVA_CATCH_EXPR, JAVA_EXC_OBJ_EXPR,
	UNARY_PLUS_EXPR, NEW_ARRAY_EXPR, NEW_ANONYMOUS_ARRAY_EXPR,
	NEW_CLASS_EXPR, SYNCHRONIZED_EXPR, CONDITIONAL_EXPR,
	INSTANCEOF_EXPR, CLASS_LITERAL, THIS_EXPR.
	(java_gimplify_case_expr): Removed.
	(java_gimplify_default_expr): Likewise.
	(java_gimplify_new_array_init): Likewise.
	* parse.y: Removed.
	* keyword.gperf, keyword.h: Removed.
	* chartables.h: Removed.
	* check-init.c: Removed.
	* buffer.c, buffer.h: Removed.
	* convert.h: Removed.
	* gen-table.pl: Removed.
	* lex.c, lex.h: Removed.

2007-01-02  Andrew Haley  <aph@redhat.com>

	* expr.c (expand_java_arraystore): Make sure we perform a bounds
	check at runtime before we perform a type check.

2006-12-19  Andrew Haley  <aph@redhat.com>

	* decl.c: Bump minor BC ABI version.

2006-12-13  Gary Benson  <gbenson@redhat.com>

	* jcf-depend.c (jcf_dependency_add_file): Mark filename unused.

2006-12-12  Tom Tromey  <tromey@redhat.com>

	* lang-specs.h: Pass -M options to jc1.
	* jcf-depend.c (jcf_dependency_add_file): Don't emit
	dependencies.

2006-12-07  Mohan Embar  <gnustuff@thisiscool.com>

	* jcf-path.c (jcf_path_compute): Use platform PATH_SEPARATOR.

2006-12-06  Mohan Embar  <gnustuff@thisiscool.com>

	* lang-specs.h: Pass '%U'-based options as separate arguments.

2006-12-05  Tom Tromey  <tromey@redhat.com>

	PR java/29495:
	* jcf-parse.c (HANDLE_SYNTHETIC_ATTRIBUTE): Mark fields and
	classes as well.
	* class.c (add_field): Handle ACC_SYNTHETIC.
	(add_method_1): Likewise.  Handle bridge and varargs.
	(get_access_flags_from_decl): Handle synthetic, bridge, varargs,
	annotation.
	(set_class_decl_access_flags): Handle synthetic and annotation.
	* java-tree.h (METHOD_BRIDGE): New macro.
	(METHOD_VARARGS): Likewise.
	(TYPE_SYNTHETIC): Likewise.
	(TYPE_ANNOTATION): Likewise.
	(lang_type): New fields 'synthetic' and 'annotation'.
	(lang_decl_func): New fields 'varargs' and 'bridge'.

2006-12-04  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (rewrite_reflection_indexes): Don't do anything if
	there's no map.

2006-11-29  Gary Benson  <gbenson@redhat.com>

	* expr.c (rewrite_arglist_getcaller): Reorder.

2006-11-29  Andrew Haley  <aph@redhat.com>

	* expr.c (rewrite_arglist_getcaller): Remove DECL_INLINE.
	* lang.c (java_decl_ok_for_sibcall): Check for DECL_INLINE.

2006-11-23  Andrew Haley  <aph@redhat.com>

	* expr.c (rewrite_arglist_getcaller): New.
	(rewrite_arglist_getclass): Fix indentation.
	(rules): Add gnu.classpath.VMStackWalker.getCallingClass() and 
	gnu.classpath.VMStackWalker.getCallingClassLoader().
	* builtins.c (initialize_builtins): Remove duplicate def'n of
	__sync_synchronize.
	Add __builtin_return_address.

2006-11-22  Andrew Haley  <aph@redhat.com>

	* jcf-reader.c (get_attribute): Mark attr_type unused.

	* builtins.c (compareAndSwapObject_builtin): Fix declaration.

2007-01-08  Richard Guenther  <rguenther@suse.de>

	* lex.c (do_java_lex): Use build_int_cst_wide_type.
	* jcf-parse.c (get_constant): Likewise.

2006-11-12  Jan Hubicka  <jh@suse.cz>

	* resource.c (compile_resource_data): Update for new varpool names.
	* java/class.c (build_utf8_ref): Likewise.

2006-11-12  David Daney  <ddaney@avtrex.com>

	PR java/29805
	* typeck.c (build_java_array_type): Increase buffer sizes.

2006-11-11  Richard Guenther  <rguenther@suse.de>

	* check-init.c (check_init): Remove handling of FIX_CEIL_EXPR,
	FIX_FLOOR_EXPR and FIX_ROUND_EXPR.

2006-11-06  Andrew Haley  <aph@redhat.com>

	* java-tree.h (CONSTANT_LazyFlag): New.
	* constants.c (build_constants_constructor): Mask CONSTANT_LazyFlag.
	* jcf-parse.c (handle_innerclass_attribute): Write attribute to
	reflection_data.
	(handle_constant): Return 0 for dummy cpool entries.
	Handle constants of kind Class.
	Handle constants of kind NameAndType.
	(handle_enclosingmethod_attribute): New.
	(handle_signature_attribute): New.
	(HANDLE_ENCLOSINGMETHOD_ATTRIBUTE): New.
	(HANDLE_SIGNATURE_ATTRIBUTE): New.
	(handle_constant): Use unmangle_classname()rather than calling
	identifier_subst() directly.

2006-11-02  Andrew Haley  <aph@redhat.com>

	* java-tree.h (FIELD_ENUM): New.
	(lang_decl_var.field_enum): New.
	(lang_type.enum_class): New.
	(CLASS_ENUM): New.
	* class.c (set_class_decl_access_flags): Handle enum types.
	(add_field): Handle enum fields.
	(get_access_flags_from_decl): Likewise.

	* class.c (make_class_data): Put reflection_data into rodata.

2006-11-01  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (field_offsets, bit_obstack): New variables.
	(jcf_parse): Write end marker to annotation_data.
	(java_parse_file): Create field_offsets bitmap.  Destroy it.
	(annotation_grow, annotation_rewrite_byte) 
	(annotation_rewrite_short, annotation_rewrite_int) 
	(annotation_read_short, annotation_write_byte) 
	(annotation_write_short, annotation_write_int) 
	(handle_long_constant, handle_constant, handle_element_value) 
	(handle_annotation, handle_annotations) 
	(handle_annotation_attribute, rewrite_reflection_indexes) 
	(handle_member_annotations, handle_parameter_annotations) 
	(handle_default_annotation): New functions.
	(HANDLE_RUNTIMEVISIBLEANNOTATIONS_ATTRIBUTE) 
	(HANDLE_RUNTIMEINVISIBLEANNOTATIONS_ATTRIBUTE) 
	(HANDLE_RUNTIMEVISIBLEPARAMETERANNOTATIONS_ATTRIBUTE) 
	(HANDLE_RUNTIMEINVISIBLEPARAMETERANNOTATIONS_ATTRIBUTE) 
	(HANDLE_ANNOTATIONDEFAULT_ATTRIBUTE): New definitions.
	* java-tree.h (enum jv_attr_type, enum jv_attr_kind): New. 
	(TYPE_REFLECTION_DATA): New.
	(TYPE_REFLECTION_DATASIZE): New.
	* jcf.h (enum cpool_tag): Convert a bunch of #define constants to
	an enum.
	* jcf-reader.c (get_attribute): Pass field/method index and
	attribute type to get_attribute().
	* constants.c (find_class_or_string_constant): Make nonstatic.
	(cpool_for_class): Likewise.
	(build_constants_constructor): Separate string and scalar types.
	* class.c (make_class_data): Generate field_indexes permutation.
	Pass it to rewrite_reflection_indexes().
	(make_class_data): Generate constructor for reflection_data field.

2006-10-20  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Top): Don't mention jv-scan.
	(Invoking gcj): Likewise.
	(Invoking gcjh): Likewise.
	(Invoking gjnih): Likewise.
	(Invoking gij): Likewise.
	(Invoking gcj-dbtool): Likewise.
	(Invoking jv-scan): Removed.
	* parse-scan.y: Removed.
	* jv-scan.c: Removed.
	* config-lang.in (stagestuff): Don't mention jv-scan.
	* Make-lang.in (java): Removed jv-scan.
	(JAVA_TARGET_INDEPENDENT_BIN_TOOLS): Likewise.
	(JVSCAN_OBJS): Removed.
	(jv-scan$(exeext)): Likewise.
	(JAVA_MANFILES): Removed jv-scan.1.
	(java.uninstall): Don't mention jv-scan.
	(java.mostlyclean): Likewise.
	(java.maintainer-clean): Likewise.
	(.INTERMEDIATE): Likewise.
	(java/jv-scan.o): Removed.
	(jv-scan.pod): Likewise.
	(java.srcextra): Don't mention parse-scan.c.
	(java.mostlyclean): Likewise.
	(java/parse-scan.c): Removed.
	(java/parse-scan.o-warn): Removed.
	(java/parse-scan.o): Removed.

2006-10-20  Tom Tromey  <tromey@redhat.com>

	* lang.c (java_handle_option): Don't use
	jcf_write_base_directory.
	* jcf.h (jcf_write_base_directory): Removed.
	* parse.y (java_expand_classes): Don't call write_classfile.
	* config-lang.in (gtfiles): Removed jcf-write.c.
	* Make-lang.in (JAVA_OBJS): Removed jcf-write.o.
	(java/jcf-write.o): Removed.
	* jcf-parse.c (parse_class_file): Don't call write_classfile.
	* java-tree.h (write_classfile): Removed declaration.
	* jcf-write.c: Removed.

2006-10-20  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (java): Removed gjnih, gcjh.
	(JAVA_TARGET_INDEPENDENT_BIN_TOOLS): Likewise.
	(GCJH_OBJS): Removed.
	(GJNIH_OBJS): Likewise.
	(gjnih$(exeext)): Likewise.
	(gcjh$(exeext)): Likewise.
	(JAVA_MANFILES): Removed gcjh.1, gjnih.1.
	(java.install-common): Don't special case gcjh.
	(java.uninstall): Don't mention gcjh, gjnih.
	(java.mostlyclean): Likewise.
	(java.maintainer-clean): Likewise.
	(.INTERMEDIATE): Likewise.
	(gcjh.pod): Removed.
	(gjnih.pod): Likewise.
	(GCJH_TARGET_INSTALL_NAME): Removed.
	(java/gjavah-jni.o): Removed.
	(java/gjavah.o): Likewise.
	* config-lang.in (stagestuff): Removed gjnih, gcjh.
	* gjavah.c: Removed.

2006-10-17  Tom Tromey  <tromey@redhat.com>

	* jcf-dump.c (print_element_value): Expect a utf8 constant in the
	"string" case.

2006-10-17  Tom Tromey  <tromey@redhat.com>

	* jvgenmain.c (main): Handle -findirect-dispatch.
	* jvspec.c (jvgenmain_spec): Pass -findirect-dispatch to
	jvgenmain.

2006-10-06  Andrew Haley  <aph@redhat.com>

	* builtins.c (compareAndSwapInt_builtin): Check that we really do
	have a compare_and_swap builtin.
	(compareAndSwapLong_builtin): Likewise.
	(compareAndSwapObject_builtin): Likewise.

2006-10-04  Andrew Haley  <aph@redhat.com>

	* builtins.c (java_builtins): Add compareAndSwapInt,
	compareAndSwapLong, compareAndSwapObject, putOrderedInt,
	putOrderedLong, putOrderedObject, putIntVolatile, putLongVolatile,
	putObjectVolatile, getObjectVolatile, getIntVolatile,
	getLongVolatile, getLong.
	(UNMARSHAL3): New macro.
	(UNMARSHAL4): Likewise.
	(UNMARSHAL5): Likewise.
	(build_arglist_for_builtin): New function.
	(build_addr_sum, build_check_this): New functions.
	(putObject_builtin. compareAndSwapInt_builtin,
	compareAndSwapLong_builtin, compareAndSwapObject_builtin,
	putVolatile_builtin, getVolatile_builtin): New builtins.

2006-06-08  Andrew Haley  <aph@redhat.com>
 
	* expr.c (build_field_ref): Pass NULL_TREE as SPECIAL arg to
	get_symbol_table_index().
	(maybe_rewrite_invocation): Set SPECIAL if we need to access a
	private method.
	(build_known_method_ref): New arg: special.  Pass it to
	get_symbol_table_index.
	(get_symbol_table_index): Put SPECIAL in the TREE_PURPOSE field of
	the method list.
	(build_invokevirtual): New arg: special.  Pass it to
	get_symbol_table_index.
	(expand_invoke): New variable: special.
	Pass it to maybe_rewrite_invocation().
	Pass it to build_known_method_ref().
	* class.c (build_symbol_entry): Add new arg: special.  Use it to
	build the symbol table conbstructor.
	(emit_symbol_table): Extract SPECIAL from the method list and pass
	it to build_symbol_entry().
	* parse.y (patch_invoke): Call maybe_rewrite_invocation() and set
	special accordingly.
 
2006-09-08  Andrew Haley  <aph@redhat.com>

	* class.c (layout_class_method): Use build_java_signature, not
	build_java_argument_signature.  Use lookup_java_method, not
	lookup_argument_method.

2006-08-16  Jakub Jelinek  <jakub@redhat.com>
	    Bryce McKinlay  <bryce@mckinlay.net.nz>

	* jvspec.c (lang_specific_driver): Add -s-bc-abi when needed.

2006-07-18  Tom Tromey  <tromey@redhat.com>

	* lang.opt: Added missing -W options.

2006-07-12  Tom Tromey  <tromey@redhat.com>

	PR java/28329:
	* lang-specs.h: Pass '%U'-based options as separate arguments.
	Use -faux-classpath.
	* lang.c (java_handle_option): Handle OPT_faux_classpath.
	* lang.opt (faux-classpath): New option.

2006-07-07  Tom Tromey  <tromey@redhat.com>

	* class.c (make_class_data): Set value for reflection_data field.
	* decl.c (java_init_decl_processing): Add reflection_data field.

2006-07-07  Tom Tromey  <tromey@redhat.com>

	* jcf-dump.c (HANDLE_ENCLOSINGMETHOD_ATTRIBUTE): Declare locals
	earlier.
	(HANDLE_SIGNATURE_ATTRIBUTE): Likewise.

2006-07-07  Andrew Haley  <aph@redhat.com>

        * jcf-parse.c (set_source_filename): Don't check for
	CLASS_FROM_CURRENTLY_COMPILED_P.
        Remove // comments.

2006-07-07  Andrew Haley  <aph@redhat.com>

	* java-tree.h (java_read_sourcefilenames): Declare.
	* lang.c (java_handle_option): Call java_read_sourcefilenames().
	* lang.opt (fsource-filename): New opt.
	* lang-specs.h: Add -fsource-filename.
	* jcf-parse.c (num_files, filenames): New variables.
	(reverse, cmpstringp, java_read_sourcefilenames,
	find_sourcefile): New.
	(set_source_filename): Call find_sourcefile to find the real name
	of a source file.

2006-06-27  Tom Tromey  <tromey@redhat.com>

	* jcf-reader.c (get_attribute): Handle EnclosingMethod,
	Signature, LocalVariableTypeTable, annotation attributes.
	* jcf-dump.c (HANDLE_ENCLOSINGMETHOD_ATTRIBUTE): New macro.
	(HANDLE_SIGNATURE_ATTRIBUTE): Likewise.
	(HANDLE_START_FIELD): Mention 'descriptor', not 'signature'.
	(HANDLE_METHOD): Likewise.
	(HANDLE_LOCALVARIABLETYPETABLE_ATTRIBUTE): New macro.
	(print_annotation): New function.
	(print_element_value): Likewise.
	(indent): Likewise.
	(HANDLE_RUNTIMEVISIBLEANNOTATIONS_ATTRIBUTE): New macro.
	(HANDLE_RUNTIMEINVISIBLEANNOTATIONS_ATTRIBUTE): Likewise.
	(print_parameter_annotations): New function.
	(HANDLE_RUNTIMEVISIBLEPARAMETERANNOTATIONS_ATTRIBUTE): New macro.
	(HANDLE_RUNTIMEINVISIBLEPARAMETERANNOTATIONS_ATTRIBUTE):
	Likewise.
	(HANDLE_ANNOTATIONDEFAULT_ATTRIBUTE): Likewise.
	(print_annotations): New function.

2006-06-23  Tom Tromey  <tromey@redhat.com>

	* lang-specs.h: Default -fsource and -ftarget to 1.5.  If
	emitting class files, always use 1.5.
	* gcj.texi (Input Options): Document -fsource.
	(Code Generation): Document -ftarget.

2006-06-21  Tom Tromey  <tromey@redhat.com>

	PR java/28089:
	* expr.c (expand_java_field_op): Initialize field's declaring
	class.

2006-06-20  Tom Tromey  <tromey@redhat.com>

	* expr.c (push_value): Always flush quick stack.

2006-06-19  Tom Tromey  <tromey@redhat.com>

	* expr.c (push_value): Also flush quick stack if value is a
	component_ref.

2006-06-19  Tom Tromey  <tromey@redhat.com>

	* expr.c (push_value): Flush quick stack if value has side
	effects.

2006-06-13  Tom Tromey  <tromey@redhat.com>

	* class.c (is_compiled_class): Explicitly check for current
	class.

2006-06-09  Tom Tromey  <tromey@redhat.com>

	* gjavah.c (decompile_method): Don't decompile a static field
	accessor method.

2006-06-06  Tom Tromey  <tromey@redhat.com>

	* lang-specs.h <jc1>: Add .jar file to command line if
	-fsaw-java-file.  Also, remove -ffilelist-file in this case.

2006-06-05  Tom Tromey  <tromey@redhat.com>

	* jcf-dump.c (print_access_flags): Handle varargs, bridge,
	synthetic, enum, annotation.
	* jcf.h (ACC_BRIDGE): New macro.
	(ACC_VARARGS): Likewise.
	(ACC_SYNTHETIC): Likewise.
	(ACC_ENUM): Likewise.
	(ACC_ANNOTATION): Likewise.

2006-06-04  Tom Tromey  <tromey@redhat.com>

	* lang.opt (-fsaw-java-file, -fsource, -ftarget): New options.
	* jvspec.c (jvgenmain_spec): Remove -fsaw-java-file, -fsource,
	and -ftarget.
	(lang_specific_driver): Removed dead code.  Add -fsaw-java-file
	when needed.  Handle classpath-setting.
	* Make-lang.in ($(GCJ)$(exeext)): Link in jcf-path.o.
	* lang-specs.h: Rewrote.

2006-06-04  Tom Tromey  <tromey@redhat.com>

	* jcf-io.c (find_class): Set source_ok to 0.
	* jcf-parse.c (jcf_parse): Disable gnu.gcj.gcj-compiled warning.
	(parse_class_file): Don't call java_mark_class_local.
	(java_parse_file): Skip .java files.  Call java_mark_class_local
	before lowering any code.
	(parse_zip_file_entries): Don't call duplicate_class_warning
	here.
	(process_zip_dir): ... call it here.
	* class.c (add_field): Don't mark field external if it is being
	compiled into this object.
	(make_class_data): Handle situation where class_dtable_decl is
	created before Class is compiled.
	(is_compiled_class): Don't assume files in zip are compiled into
	this object.
	(layout_class_method): Don't mark method external if it is being
	compiled into this object.

2006-06-04  Tom Tromey  <tromey@redhat.com>

	* jcf-path.c (jcf_path_compute): New function.
	* jcf.h (jcf_path_compute): Declare.

2006-10-23 Rafael Avila de Espindola  <rafael.espindola@gmail.com>

	* decl.c: Include langhooks.h.
	(builtin_function): Remove.
	(java_init_decl_processing): Replace calls to builtin_function
	with add_builtin_function.
	* Make-lang.in (jc1$(exeext)): Depend on and link with attribs.o.
	(java/decl.o): Depend on langhooks.h.
	* java-tree.h (builtin_function): Remove.

2006-10-10  Brooks Moses  <bmoses@stanford.edu>

	* Make-lang.in: Added "java.pdf", "gcj.pdf" target support.

2006-09-12  Tom Tromey  <tromey@redhat.com>

	* expr.c (push_value): Always flush quick stack.

2006-09-12  Tom Tromey  <tromey@redhat.com>

	PR java/29013:
	* jcf-write.c (generate_bytecode_insns) <CALL_EXPR>: Always note
	the push of the called method's return result.

2006-09-12  Tom Tromey  <tromey@redhat.com>

	* jvspec.c (lang_specific_driver): Read spec file even if
	-fsyntax-only.

2006-09-12  Tom Tromey  <tromey@redhat.com>

	PR java/28754:
	* expr.c (expand_java_field_op): Initialize field's declaring
	interface if necessary.

2006-09-12  Tom Tromey  <tromey@redhat.com>

	PR java/28892:
	* expr.c (expand_java_field_op): No error for assignments not in
	class initializer or constructor.

2006-08-22  Andrew Haley  <aph@redhat.com>

	* decl.c (java_add_stmt): Give the statement list a type.

2006-08-16  Jakub Jelinek  <jakub@redhat.com>
	    Bryce McKinlay  <bryce@mckinlay.net.nz>

	* jvspec.c (lang_specific_driver): Add -s-bc-abi when needed.

2006-08-10  Simon Martin  <simartin@users.sourceforge.net>

	PR java/8923
	* parse.y (build_incdec): Emit an error instead of an ICE if '++'
	or '--' is used with a constant operand.
	(java_complete_lhs): When processing a '++' or '--' expression,
	don't call java_complete_tree but java_complete_lhs, so that a
	static final variable operand is never replaced by its value. This
	avoids an ICE later on.
	(patch_unaryop): Fixed typo in comment.

2006-07-28  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* Make-lang.in: Use $(HEADER_H) instead of header.h in dependencies.

2006-07-12  Bryce McKinlay  <mckinlay@redhat.com>

	* builtins.c (check_for_builtin): If a builtin could result in a
	direct call being generated, don't use it if flag_indirect_dispatch
	is set.

2006-07-12  Bryce McKinlay  <mckinlay@redhat.com>

	* gcj.texi (Invocation): Corrections for Invocation API example.

2006-07-04  Andrew Haley  <aph@redhat.com>

	* class.c (build_fieldref_cache_entry): Set DECL_IGNORED_P on the
	entry.

2006-06-21  Andrew Haley  <aph@redhat.com>

	* java-tree.h (update_aliases): Remove
	* expr.c (expand_iinc): Remove call to update_aliases().
	(STORE_INTERNAL): Likewise.
	* decl.c (update_aliases, initialize_local_variable) 
	(maybe_pushlevels): Set DECL_VALUE_EXPR for debugging decls.

2006-06-19  Andrew Haley  <aph@redhat.com>

	PR java/1305
	PR java/27908
	* expr.c (java_modify_addr_for_volatile): New function.
	(expand_java_field_op): Handle volatile fields.
	* java-gimplify.c (java_gimplify_component_ref): Call
	java_modify_addr_for_volatile to give the field_ref the correct
	volatile type.
	(java_gimplify_modify_expr): Likewise.
	* java-tree.h (java_modify_addr_for_volatile): New decl.

2006-06-17  Karl Berry  <karl@gnu.org>

	* gcj.texi (@dircategory): Use "Software development" instead
	of "Programming", following the Free Software Directory.

2006-06-16  Andrew Haley  <aph@redhat.com>

	* class.c (make_class_data): When using flag_indirect_classes,
	don't initialize the vtable of Class instances.

2006-06-09  Andrew Haley  <aph@redhat.com>

	PR java/1305
	PR java/27908
	* builtins.c (initialize_builtins): Add __sync_synchronize().
	* class.c (add_field): Mark volatile fields.
	* java-gimplify.c (java_gimplify_expr): Call new functions to
	handle self-modifying exprs and COMPONENT_REFs.
	(java_gimplify_component_ref): New.
	(java_gimplify_modify_expr): Add handling for volatiles.

2006-06-08  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (libgcj Runtime Properties): Document
	gnu.gcj.user.realname.

2006-06-08  Andrew Haley  <aph@redhat.com>

	* expr.c (build_field_ref): Pass NULL_TREE as SPECIAL arg to
	get_symbol_table_index().
	(maybe_rewrite_invocation): Set SPECIAL if we need to access a
	private method.
	(build_known_method_ref): New arg: special.  Pass it to
	get_symbol_table_index.
	(get_symbol_table_index): Put SPECIAL in the TREE_PURPOSE field of
	the method list.
	(build_invokevirtual): New arg: special.  Pass it to
	get_symbol_table_index.
	(expand_invoke): New variable: special.
	Pass it to maybe_rewrite_invocation().
	Pass it to build_known_method_ref().
	* class.c (build_symbol_entry): Add new arg: special.  Use it to
	build the symbol table conbstructor.
	(emit_symbol_table): Extract SPECIAL from the method list and pass
	it to build_symbol_entry().
	* parse.y (patch_invoke): Call maybe_rewrite_invocation() and set
	special accordingly.

2006-06-06  David Daney  <ddaney@avtrex.com>

	* gcj.texi (libgcj Runtime Properties): Document
	gnu.gcj.runtime.NameFinder.show_raw and
	gnu.gcj.runtime.NameFinder.remove_unknown.

2006-06-06  Tom Tromey  <tromey@redhat.com>

	* jcf-dump.c (print_access_flags): Handle varargs, bridge,
	synthetic, enum, annotation.
	* jcf.h (ACC_BRIDGE): New macro.
	(ACC_VARARGS): Likewise.
	(ACC_SYNTHETIC): Likewise.
	(ACC_ENUM): Likewise.
	(ACC_ANNOTATION): Likewise.

2006-06-06  Mike Stump  <mrs@apple.com>

	* Make-lang.in: Rename to htmldir to build_htmldir to avoid
	installing during build.

2006-05-31  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gcj.texi (Extensions): Document the new gcj-dbtool-based
	classname-to-library resolution mechanism.
	Declare the old gnu.gcj.runtime.VMClassLoader.library_control
	mechanism deprecated.
	(libgcj Runtime Properties): Document
	gnu.gcj.runtime.VMClassLoader.library_control's new default.

2006-05-29  Jakub Jelinek  <jakub@redhat.com>

	* javaop.h (int16, int32, int64): Define to exactly 16 (resp. 32, 64)
	bit wide type.
	(jword): Define to uint64 on 64-bit arches.
	* jcf-dump.c (print_constant): Cast JPOOL_UINT to long.

2006-05-28  Kazu Hirata  <kazu@codesourcery.com>

	* class.c, except.c, expr.c, java-gimplify.c: Fix comment
	typos.

2006-05-26  Tom Tromey  <tromey@redhat.com>

	* expr.c (java_push_constant_from_pool): Handle 'ldc class'.
	* verify-glue.c (vfy_class_type): New function.
	* verify-impl.c (check_constant): Allow 'ldc class'.
	* verify.h (vfy_class_type): Declare.

2006-05-25  Andrew Haley  <aph@redhat.com>

	PR java/27756
	* decl.c (maybe_pushlevels): When variable ranges are non-nested
	update all lifetimes, not just the first one.

2006-05-24  Tom Tromey  <tromey@redhat.com>

	* java-tree.h: Fixed flag documentation.

2006-05-24  Tom Tromey  <tromey@redhat.com>

	PR libgcj/27729:
	* jcf.h (ACC_INVISIBLE): Changed value.

2006-05-24  Andrew Haley  <aph@redhat.com>

	PR java/27754
	* decl.c (java_add_stmt): Use a STATEMENT_LIST rather than a
	COMPOUND_EXPR.

2006-05-16  H.J. Lu  <hongjiu.lu@intel.com>

	* lang.opt (femit-class-file): Remove VarExists.

2006-05-16  Tom Tromey  <tromey@redhat.com>

	* verify-impl.c (verify_instructions_0) <op_return>: Special case
	for Object.<init>.

2006-05-16  H.J. Lu  <hongjiu.lu@intel.com>

	PR driver/26885
	* Make-lang.in ($(GCJ)$(exeext)): Replace gcc.o with
	$(GCC_OBJS).

2006-05-14  H.J. Lu  <hongjiu.lu@intel.com>

	* Make-lang.in (java/decl.o): Add dependency on $(TARGET_H).
	(java/expr.o): Replace target.h with $(TARGET_H).
	(java/parse.o): Likewise.

2006-05-10  Andrew Haley  <aph@redhat.com>

	* class.c (emit_indirect_register_classes): Fix comment.

2006-05-04  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (uses_jv_markobj_p): Declare.
	* class.c (uses_jv_markobj_p): Removed.
	* boehm.c (PROCEDURE_OBJECT_DESCRIPTOR): New define.
	(get_boehm_type_descriptor): Use it.
	(uses_jv_markobj_p): Moved from class.c.  Return bool.

2006-05-04  Tom Tromey  <tromey@redhat.com>

	* java-tree.def (THIS_EXPR): Now a tcc_expression.

2006-05-04  Andrew Haley  <aph@redhat.com>

	* class.c (make_field_value): Always build_address_of fdecl if
	there is an initializer.

2006-05-03  Andrew Haley  <aph@redhat.com>

	PR libgcj/27352
	* expr.c (maybe_rewrite_invocation): New function.
	(rewrite_arglist_getclass): Likewise.
	(rules): New.
	(expand_invoke): Call maybe_rewrite_invocation.
	* parse.y (patch_invoke): Likewise.
	* java-tree.h: (maybe_rewrite_invocation): New function.

2006-04-21  Andrew Haley  <aph@redhat.com>

	* lang.c (java_init): Handle flag_indirect_classes.
	* jvgenmain.c: Use "class$$" instead of "class$".
	* mangle.c (java_mangle_decl): Accept RECORD_TYPEs sw well as
	DECLs.
	(mangle_class_field): Special case "class$$" as well as "class$".
	* constants.c (build_ref_from_constant_pool): If
	flag_indirect_classes, generate a ref into the heap.
	* decl.c (constants_field_decl_node,
	constants_data_field_decl_node): New.
	* class.c (build_static_class_ref): New.
	(build_classdollar_field): Factor out from build_class_ref().
	(make_field_value): Handle static fields in heap.
	(make_class_data): Make sure we get a static ref to class.
	Make class initializer const if flag_indirect_classes.
	(register_class): Build a class_ref for initialization if
	flag_indirect_classes.
	(emit_indirect_register_classes): New.

2006-04-08  Kazu Hirata  <kazu@codesourcery.com>

	* expr.c, gjavah.c: Fix comment typos.

2006-04-03  Andrew Haley  <aph@redhat.com>

	PR java/26858
	* expr.c (build_field_ref): Don't check the field offset if
	flag_syntax_only.

2006-03-30  Andrew Haley  <aph@redhat.com>

	PR java/26858
	* lang.c (java_attribute_table): New.
	(LANG_HOOKS_ATTRIBUTE_TABLE): Define.
	* expr.c (build_field_ref): Add a null pointer check for all
	fields of offset > 4k.  Don't do so for accesses via the this
	pointer, which we know can never be null.
	* class.c (build_java_method_type): Mark arg 1 of all nonstatic
	methods nonnull.

2006-03-30  Carlos O'Donell  <carlos@codesourcery.com>

	* Make-lang.in: Rename docdir to gcc_docdir.

2006-03-30  Tom Tromey  <tromey@redhat.com>

	PR java/26042:
	* parse.y (java_reorder_fields): Reset superclass field's size as
	well.

2006-03-28  Tom Tromey  <tromey@redhat.com>

	PR java/26390:
	* parse.y (find_most_specific_methods_list): Added 'class'
	argument.
	(lookup_method_invoke): Updated.

2006-03-15  Tom Tromey  <tromey@redhat.com>

	* jcf-write.c (generate_bytecode_insns): Use qualifying type for
	non-static method calls.

2006-03-15  David Daney  <ddaney@avtrex.com>

	* java-tree.h : Moved comment for TYPE_DOT_CLASS adjacent to its
	declaration.

2006-03-15  David Daney  <ddaney@avtrex.com>

	* lang.opt (-freduced-reflection): New option.
	* lang.c (java_post_options): Generate an error if
	-freduced-reflection used with -fjni or -findirect-dispatch.
	* java-tree.h (flag_reduced_reflection): Declare new variable.
	* boehm.c (get_boehm_type_descriptor): Indicate all pointers
	if bitmap overflows and flag_reduced_reflection set.
	* class.c (uses_jv_markobj_p): New function.
	(make_class_data): Moved generation of vtable to before
	reflection data, generate less reflection data if
	flag_reduced_reflection set.
	* gcj.texi: Document -freduced-reflection.

2006-03-15  Tom Tromey  <tromey@redhat.com>

	PR java/26638:
	* class.c (get_interface_method_index): Don't put <clinit> into
	interface table.

2006-03-15  Tom Tromey  <tromey@redhat.com>

	* parse.y (analyze_clinit_body): Ignore empty statements.

2006-03-08  David Daney  <ddaney@avtrex.com>

	* gcj.texi: Document -static-libgcj option.

2006-02-20  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (parse_class_file): Set input_location from
	current_class.

2006-02-15  Andrew Haley  <aph@redhat.com>

	* class.c (GEN_TABLE): Don't pushdecl *_SYMS_DECL here.
	(make_class_data): pushdecl_top_level TYPE_OTABLE_SYMS_DECL,
	TYPE_ATABLE_SYMS_DECL, TYPE_ITABLE_SYMS_DECL here.

2006-02-09  Andrew Haley  <aph@redhat.com>

	PR java/26192
	* expr.c (expand_invoke): Allow methods in arrays to be resolved
	in their superclass.

	* typeck.c (build_java_array_type): Generate TYPE_STUB_DECLs for
	array types.
	
2006-02-08  Tom Tromey  <tromey@redhat.com>

	PR java/22578:
	* check-init.c (check_init): Handle VIEW_CONVERT_EXPR.
	* builtins.c (convert_real): New function.
	(java_builtins): Handle Float.intBitsToFloat,
	Float.floatToRawIntBits, Double.longBitsToDouble,
	Double.doubleToRawLongBits.

2006-02-07  Andrew Haley  <aph@redhat.com>

	* expr.c (expand_invoke): (BC mode.)  If we find a method in a
	class other than the one in which we expected to find it, ignore
	the result.

	PR java/25535
	* constants.c (build_constants_constructor): move initializer into
	first halfword on a 64-bit big-endian machine.

2006-02-04  Tom Tromey  <tromey@redhat.com>

	PR java/25676:
	* builtins.c (max_builtin): Skip floating point 'max'.
	(min_builtin): Skip floating point 'min'.
	(check_for_builtin): Never return NULL_TREE.

2006-02-04  Tom Tromey  <tromey@redhat.com>

	PR java/26097:
	* expr.c (push_type): Avoid side effect in gcc_assert.

2006-02-04  Roger Sayle  <roger@eyesopen.com>

	* decl.c (java_init_decl_processing): Create char_type_node as a
	regular INTEGER_TYPE node.
	(push_promoted_type): Preserve TYPE_STRING_FLAG on types.
	* typeck.c (convert): No longer check for CHAR_TYPEs but instead
	test for char_type_node and promoted_char_type_node as special
	instances of INTEGER_TYPE tree codes.
	(promote_type,build_java_signature): Likewise.
	* jcf-write.c (adjust_typed_op): Likewise.
	* mangle.c (mangle_type): Likewise.
	* parse.y (do_unary_numeric_promotion): No longer handle CHAR_TYPE.
	* parse.h (JINTEGRAL_TYPE_P): Likewise.

2006-02-04  Andreas Tobler  <a.tobler@schweiz.ch>

	* expr.c (java_stack_swap): Revert gcc_assert patch.

2006-02-03  Ben Elliston  <bje@au.ibm.com>

	* java-gimplify.c: Use gcc_assert and gcc_unreachable throughout.
	* typeck.c: Likewise.
	* verify-impl.c: Likewise.
	* class.c: Likewise.
	* decl.c: Likewise.
	* jcf-parse.c: Likewise.
	* constants.c: Likewise.
	* check-init.c: Likewise.
	* jcf-write.c: Likewise.
	* verify-glue.c: Likewise.
	* mangle.c: Likewise.
	* expr.c: Likewise.
	* lang.c: Likewise.
	* boehm.c: Likewise.

2006-02-01  Jan Hubicka  <jh@suse.cz>

	* decl.c (end_java_method): Kill hack disabling unit-at-a-time.
	* lang.c (java_init_options): Set no_unit_at_a_time_default.

2006-01-30  Andrew Haley  <aph@redhat.com>

	PR java/21428
	* parse.y: (source_start_java_method): Mark DECL_ARTIFICIAL("this").

2006-01-21  Joseph S. Myers  <joseph@codesourcery.com>

	* jv-scan.c (version), jcf-dump.c (version), gjavah.c (version):
	Update copyright notice dates.

2006-01-16  Rafael Ávila de Espíndola  <rafael.espindola@gmail.com>

	* jvspec.c (lang_specific_spec_functions): Remove.

2006-01-06  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Arrays): Added more documentation for
	JvNewObjectArray.
	(Primitive types): Correct information about primitive classes.
	(Reference types): New node.
	(Index): New node.

2005-12-16  Alexandre Oliva  <aoliva@redhat.com>

	* jcf-parse.c (set_source_filename): Set the decl source location
	even when returning early.

2005-12-15  Tom Tromey  <tromey@redhat.com>
	    Andrew Haley  <aph@redhat.com>

	PR java/25429
	* parse.y (resolve_expression_name): Don't generate accessor
	methods for constant fields.

2005-12-13  Andrew Haley  <aph@redhat.com>

	PR java/25366
	PR java/25368
	* class.c (maybe_layout_super_class): Update current_class before
	calling do_resolve_class.

2005-12-12  H.J. Lu  <hongjiu.lu@intel.com>

	PR java/25330
	* jcf-write.c (write_classfile): Use PID in temporary class
	file. Save/restore errno when reporting error.

2005-12-10  Terry Laurenzo  <tlaurenzo@gmail.com>

	PR java/9861
	* mangle.c (mangle_method_decl): Mangle Java methods by prepending 'J'
	to bare_function_type and including the return type
	* builtins.c (initialize_builtins) : Change builtin mangled name
	constants to conform to new mangling scheme

2005-12-08  Andrew Haley  <aph@redhat.com>

	PR libgcj/25265
	* java-tree.h (enum java_tree_index): Add JTI_SOFT_NOSUCHFIELD_NODE.
	(soft_abstractmethod_node): New.
	* expr.c (build_field_ref): Add in-line check for missing field.
	* decl.c (java_init_decl_processing): Add soft_nosuchfield_node.

2005-12-07  Rafael Ávila de Espíndola  <rafael.espindola@gmail.com>

	* Make-lang.in (java.all.build, java.install-normal): Remove.

2005-12-07  Rafael Ávila de Espíndola  <rafael.espindola@gmail.com>

	* Make-lang.in: Remove all dependencies on s-gtype, except for
	gt-java-parse.h.

2005-12-07  Richard Sandiford  <richard@codesourcery.com>

	* class.c (build_utf8_ref, emit_register_classes): Use
	switch_to_section and get_section.

2005-12-06  Tom Tromey  <tromey@redhat.com>

	PR java/25283:
	* parse.y (patch_new_array_init): Revert previous patch.
	(lookup_method_invoke): Use size-less array type when creating an
	anonymous constructor.

2005-12-05  Tom Tromey  <tromey@redhat.com>

	* parse.y (patch_new_array_init): Don't set length on array.

2005-12-02  Richard Guenther  <rguenther@suse.de>

	* java-gimplify.c (java_gimplify_labeled_block_expr): Use
	buildN instead of build.
	* class.c (finish_class): Likewise.
	* expr.c (java_create_object): Likewise.

2005-11-28  Tom Tromey  <tromey@redhat.com>

	PR java/18278:
	* expr.c (build_jni_stub): Unwrap the return value.
	* java-tree.h (soft_unwrapjni_node): New define.
	(enum java_tree_index): Added JTI_SOFT_UNWRAPJNI_NODE.
	* decl.c (java_init_decl_processing): Initialize
	soft_unwrapjni_node.

2005-11-24  Bryce McKinlay  <mckinlay@redhat.com>

	* gcj.texi (gij options): Add -Xss documentation.

2005-11-08  Wil Mahan  <wmahan@gmail.com>

	PR java/23617
	* zextract.c (read_zip_archive): Fix out of memory error when
	reading jar files with zip-style comments.

2005-11-07   Terry Laurenzo   <tlaurenzo@gmail.com>

	* gjavah.c (HANDLE_CODE_ATTRIBUTE): Only define for ELF Object
	formats.
	* gjavah.c (decompile_method): Add ATTRIBUTE_UNUSED

2005-10-12  Nathan Sidwell  <nathan@codesourcery.com>
	    Wil Mahan <wmahan@gmail.com>

	PR java/23620
	* class.c (make_class): Create empty binfo here.
	(set_super_info): Only create binfo if we have superclasses.

2005-10-03  Ranjit Mathew  <rmathew@gcc.gnu.org>

	PR java/24127
	* parse.y (method_header): Make the result of the rule a NULL_TREE
	when a parsing error occurs.

2005-09-29  Tom Tromey  <tromey@redhat.com>

	PR java/24120:
	* jcf-io.c (memoized_dirlist_hash): New function.
	(caching_stat): Use it.

2005-09-21  Ranjit Mathew  <rmathew@gcc.gnu.org>

	PR java/21418
	* class.c (inherits_from_p): Try to lay out super class
	if it is not already laid out.
	(maybe_layout_super_class): Handle the case where SUPER_CLASS
	is a NULL_TREE.

2005-09-18  James A. Morrison  <phython@gcc.gnu.org>

	* builtins.c (max_builtin, min_builtin, abs_builtin,
	java_build_function_call_expr): Use fold_buildN.
	* class.c (layout_class_method): Likewise.
	* expr.c (java_truthvalue_conversion, build_java_jsr,
	build_java_arrayaccess, expand_java_arrayload, expand_iinc,
	build_java_binop, build_field_ref, expand_compare,
	build_known_method_ref, build_invokevirtual,
	process_jvm_instruction): Likewise.
	* parse.y (patch_binop, patch_exit_expr): Likewise.
	* typeck.c (convert_ieee_real_to_integer): Likewise.
	(convert): Don't call fold after convert_ieee_real_to_integer.

2005-09-14  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/23891
	* parse.y (maybe_create_class_interface_decl): Set TYPE_PACKAGE for
	the newly created type. Set import lists here, not in create_class.
	(jdep_resolve_class): Set current_class.
	(do_resolve_class): Use current_class's TYPE_PACKAGE to determine 
	the current package context, not ctxp->package.
	(cicp_cache): Removed.
	(class_in_current_package): Simplify implementation using TYPE_PACKAGE.
	* jcf-parse.c (give_name_to_class): Set TYPE_PACKAGE.
	* java-tree.h (TYPE_PACKAGE): New macro.
	(struct lang_type): New member 'package'.

2005-09-09  Andrew Haley  <aph@redhat.com>

	PR libgcj/23182 
	* expr.c (pop_type_0): If the expected type is object or ptr
	(i.e. void*), return the type of the object we just popped from
	the stack.

2005-09-06  Andrew Pinski  <pinskia@physics.uc.edu>

	* java-gimplify.c (java_gimplify_block): NULL out the old BLOCK's
	BLOCK_EXPR_BODY before returning the new BIND_EXPR.

2005-09-06  Kazu Hirata  <kazu@codesourcery.com>

	* check-init.c, decl.c, expr.c, gcj.texi, java-tree.h,
	jcf-parse.c, jcf.h, parse.h, parse.y, typeck.c: Fix comment
	typos.  Follow spelling conventions.

2005-09-05  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/23431
	* typeck.c (lookup_do): Look up interfaces for the original class,
	not the base class.
	* parse.y (java_check_regular_methods): Fix diagnostic message for
	more restrictive overriding of a method from an interface.

2005-08-16  Tom Tromey  <tromey@redhat.com>

	* class.c (make_class_data): Always emit JV_STATE_PRELOADING for
	class' initial state.

2005-08-16  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/22113
	* lex.c (do_java_lex): Define MAX_TOKEN_LEN. Avoid overflowing
	`literal_token' for large numeric input tokens.

2005-08-16  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/19870
	* parse.y (nested_field_access_p): Rename to nested_member_access_p
	and expand to handle method accesses across nested classes.
	(build_outer_method_access_method): Rename to
	build_nested_method_access_method.  Minor adjustments to comments.
	(resolve_expression_name): Use the newly-renamed
	nested_member_access_p method.
	(resolve_qualified_expression_name): Likewise.
	(patch_method_invocation): Also consider static methods for access
	method generation.  Minor adjustments to comments.
	(maybe_use_access_method): Use the more general
	nested_memeber_access_p to determine access across nested class
	boundaries.  Allow THIS_ARG to be NULL (for static methods).

2005-08-15  Tom Tromey  <tromey@redhat.com>

	PR java/23300.
	* expr.c (build_field_ref): Don't generate otable reference when
	DECL_FIELD_OFFSET is 0.
	* class.c (maybe_layout_super_class): Pass outer class to
	do_resolve_class.

2005-08-15  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (LABEL_IN_SUBR): Removed.
	(LABEL_IN_SUBR): Likewise.
	(LABEL_IS_SUBR_START): Likewise.
	(LABEL_SUBR_START): Likewise.
	(LABEL_SUBR_CONTEXT): Likewise.
	(LABEL_CHANGED): Likewise.
	(LABEL_RETURN_LABEL): Likewise.
	(LABEL_RETURN_TYPE_STATE): Likewise.
	(LABEL_RETURN_LABELS): Likewise.
	(RETURN_MAP_ADJUSTED): Likewise.
	(LABEL_PENDING_CHAIN): Likewise.

2005-08-15  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (JAVA_OBJS): Removed verify.o
	(java/verify.o): Removed.
	* verify.c: Removed.
	* lang.c (flag_new_verifier): Removed.
	(java_post_options): Updated.
	* java-tree.h (flag_new_verifier): Removed.
	(verify_jvm_instructions): Removed.
	* expr.c (pop_type_0): Assume flag_new_verifier is true.
	(build_java_check_indexed_type): Likewise.
	(expand_java_arraystore): Likewise.
	(expand_java_arrayload): Likewise.
	(pop_arguments): Likewise.
	(expand_byte_code): Likewise.
	(process_jvm_instruction): Likewise.

2005-08-10  Andrew Haley  <aph@redhat.com>

	* java-gimplify.c (java_gimplify_modify_expr): Fix any pointer
	type mismatches to make legal GIMPLE.

2005-08-10  Robin Green <greenrd@greenrd.org>

	PR java/23230:
	* parse.y (maybe_use_access_method): Generalize check from
	java.lang.Object to any superclass of current_class

2005-08-08  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (build_class_ref): Wrap the primary class type in a
	NOP_EXPR.
	* parse.y (java_complete_lhs) <COMPONENT_REF case>: Extract the
	primary class type from the NOP_EXPR in which it was placed.

2005-07-28  Diego Novillo  <dnovillo@redhat.com>

	* expr.c (expand_load_internal): Fix missing parens in
	predicate.

2005-07-28  Andrew Haley  <aph@redhat.com>

	* expr.c (expand_load_internal): Convert to destination type.

2005-07-22  Manfred Hollstein  <mh@suse.com>

	* verify-impl.c (check_class_constant): Fix uninitialised warnings.
	(check_constant): Likewise.
	(check_wide_constant): Likewise.

2005-07-20  Giovanni Bajo  <giovannibajo@libero.it>

	Make CONSTRUCTOR use VEC to store initializers.
	* check-init.c (check_init): Update to cope with VEC in
	CONSTRUCTOR_ELTS.
	* class.c (make_field_value, make_method_value, get_dispatch_table,
	make_class_data, emit_symbol_table, emit_catch_table,
	emit_assertion_table): Use build_constructor_from_list instead of
	build_constructor.
	* constants.c (build_constants_constructor): Likewise.
	* java-gimplify.c (java_gimplify_new_array_init): Update to cope with
	VEC in CONSTRUCTOR_ELTS.
	* java-tree.h (START_RECORD_CONSTRUCTOR, PUSH_SUPER_VALUE,
	PUSH_FIELD_VALUE, FINISH_RECORD_CONSTRUCTOR): Create a VEC instead
	of a TREE_LIST.
	* jcf-write.c (generate_bytecode_insns): Update to cope with VEC in
	CONSTRUCTOR_ELTS.
	* parse.y (build_new_array_init): Use build_constructor_from_list
	instead of build_constructor.
	(patch_new_array_init): Update to cope with VEC in
	CONSTRUCTOR_ELTS.
	(array_constructor_check_entry): Likewise.

2005-07-12  Tom Tromey  <tromey@redhat.com>

	* jvspec.c (lang_specific_driver): Put filelist_filename first on
	command line.

2005-07-12  Tom Tromey  <tromey@redhat.com>

	PR java/19674:
	* parse-scan.y (interface_member_declaration): Added
	empty_statement.

2005-07-08  Daniel Berlin  <dberlin@dberlin.org>
	
	* java-tree.h (LABEL_RETURN_LABELS): Use decl_non_common.
	(LABEL_PENDING_CHAIN): Ditto.
	(LABEL_PC): Ditto.
	(DECL_BIT_INDEX): Ditto.	

2005-07-07  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/18119
	* parse.y (inner_class_accessible): New function. Logic moved from
	check_inner_class_access.
	(check_inner_class_access): Use inner_class_accessible.
	(resolve_inner_class): Simplify arguments. Create circularity hash
	here. Keep looking for classes if we found one that was inaccessible. 
	Return the inaccessible class only if there is no other match.
	(do_resolve_class): Update for new resolve_inner_class arguments.
	Don't create circularity_hash here.

2005-07-07  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/21045
	* parse.y (add_exception_to_throws): New function.
	(purge_unchecked_exceptions): Removed.
	(get_constructor_super): Renamed from verify_constructor_super. Now
	returns the super constructor after verification.
	(java_complete_expand_method): Don't use purge_unchecked_exceptions
	or save/restore the exception list.
	(check_thrown_exceptions): Add uncaught exceptions in anonymous
	class initializers and constructors to the throws clause of the method.	

2005-07-05  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/19674
	* parse.y (interface_member_declaration): Allow empty statements in
	interface declarations.

2005-07-05  Paolo Bonzini  <bonzini@gnu.org>

	* Makefile.in (parse.o): Adjust dependencies.
	* parse.y: Include tree-dump.h.

2005-07-02  Joseph S. Myers  <joseph@codesourcery.com>

	* class.c, decl.c, expr.c: Use '+' flag instead of %J.  Use 'q'
	flag for quoting.

2005-07-01  Andrew Pinski  <pinskia@physics.uc.edu>

	* parse.y (issue_warning_error_from_context): Call
	pp_output_formatted_text to be able to get the buffer.

2005-06-30  Andrew Pinski  <pinskia@physics.uc.edu>

	* parse.y (issue_warning_error_from_context): Update for the
	renaming of pp_format_text to pp_format.

2005-06-28  Paul Brook  <paul@codesourcery.com>

	* decl.c (java_init_decl_processing): Call
	default_init_unwind_resume_libfunc.

2005-06-27  Tom Tromey  <tromey@redhat.com>

	PR java/21540, PR java/13788:
	* parse.y (java_complete_lhs) <CASE_EXPR>: Use
	fold_constant_for_init.
	(patch_binop): Added 'folding' argument.  Updated all callers.
	(patch_unaryop) <NOP_EXPR>: New case.
	(fold_constant_for_init) <NOP_EXPR>: Likewise.
	(fold_constant_for_init) <COND_EXPR>: Fix sense of test.

2005-06-25  Jan Hubicka  <jh@suse.cz>

	* builtins.c (define_builtin): Accept new flags parameter.
	(initialize_builtins): Mark the builtins const and nothrow accordingly.

2005-06-25  Kelley Cook  <kcook@gcc.gnu.org>

	* all files: Update FSF address in copyright headers.

2005-06-24  Tom Tromey  <tromey@redhat.com>

	* verify-impl.c (verify_instructions_0): Correctly handle
	situation where PC falls off end.

2005-06-23  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/20697
	* parse.y (find_most_specific_methods_list): Remove special case for
	inner classes.

2005-06-15  Tom Tromey  <tromey@redhat.com>

	PR libgcj/21906:
	* class.c (make_method_value): Use soft_abstractmethod_node for
	abstract method.
	* java-tree.h (soft_abstractmethod_node): New define.
	(JTI_SOFT_ABSTRACTMETHOD_NODE): New enum constant.
	* decl.c (java_init_decl_processing): Initialize
	soft_abstractmethod_node.

2005-06-13  Geoffrey Keating  <geoffk@apple.com>

	* Make-lang.in (rule for installing gcj.1): Depends on installdirs.

2005-06-13  Per Bothner  <per@bothner.com>

	* expr.c (int highest_label_pc_this_method,
	start_label_pc_this_method): New globals.
	(lookup_label): Add start_label_pc_this_method to pc for label, and
	update highest_label_pc_this_method.  This prevents conflicts between
	labels from different methods.
	* java-tree.h: Declare new globals.
	* jcf-parse.c (parse_class_file): If needed bump
	start_label_pc_this_method and reset highest_label_pc_this_method.

2005-06-13  Tom Tromey  <tromey@redhat.com>

	PR java/21844:
	* parse.y (nested_field_access_p): Handle case where outer field
	is inherited by enclosing class.

2005-06-12  Per Bothner  <per@bothner.com>

	* class.c (inherits_from_p): Do load_class if needed.

2005-06-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gjavah.c (error): Add ATTRIBUTE_PRINTF_1.
	* java-tree.h (parse_error_context): Move...
	* parse.h (parse_error_context): ... here, add ATTRIBUTE_GCC_DIAG.
	* parse.y (parse_warning_context): Add ATTRIBUTE_GCC_DIAG.
	* verify-impl.c (debug_print): Add ATTRIBUTE_PRINTF_1.

2005-06-08  Roger Sayle  <roger@eyesopen.com>

	* typeck.c (convert): Only clear TREE_OVERFLOW on INTEGER_CST nodes.

2005-06-06  Jakub Jelinek  <jakub@redhat.com>

	* jv-scan.c (fatal_error, warning, warning0): Use gmsgid instead of
	msgid for argument name.
	* gjavah.c (error): Likewise.
	* java-tree.h (parse_error_context): Likewise.
	* parse.y (parse_error_context, parse_warning_context,
	issue_warning_error_from_context): Likewise.

2005-06-01  Tom Tromey  <tromey@redhat.com>

	PR java/21722:
	* class.c (build_static_field_ref): Don't fold constant fields if
	current class is from a .class file and we're using indirect
	dispatch.

2005-05-31  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* java/verify-glue.c: Don't include errors.h and include toplev.h.
	* java/Make-lang.in: Updates dependencies.

2005-05-26  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/19870.
	* java-tree.h (OUTER_FIELD_ACCESS_IDENTIFIER_P): Rename to
	NESTED_FIELD_ACCESS_IDENTIFIER_P.
	(FIELD_INNER_ACCESS): Rename to FIELD_NESTED_ACCESS.
	(FIELD_INNER_ACCESS_P): Rename to FIELD_NESTED_ACCESS_P.
	* jcf-write.c (generate_classfile): Use
	NESTED_FIELD_ACCESS_IDENTIFIER_P instead of
	OUTER_FIELD_ACCESS_IDENTIFIER_P.
	* parse.y (build_outer_field_access): Rename to
	build_nested_field_access. Support static fields and outer-to-inner
	class accesses.
	(outer_field_access_p): Rename to nested_field_access_p. Support
	static fields and generalise to outer-to-inner class and sibling
	inner class accesses.
	(outer_field_expanded_access_p): Rename to
	nested_field_expanded_access_p and support static fields.
	(outer_field_access_fix): Rename to nested_field_access_fix and
	support static fields.
	(build_outer_field_access_expr): Rename to
	build_nested_field_access_expr and support static fields.
	(build_outer_field_access_methods): Rename to
	build_nested_field_access_methods and support static fields. For
	static fields, generate accessors without class instance parameters.
	(build_outer_field_access_method): Rename to
	build_nested_field_access_method and support static fields.
	(build_outer_method_access_method): Use
	NESTED_FIELD_ACCESS_IDENTIFIER_P instead of
	OUTER_FIELD_ACCESS_IDENTIFIER_P.
	(resolve_expression_name): Consider static field accesses across
	nested classes.
	(resolve_qualified_expression_name): Likewise.
	(java_complete_lhs): Use nested_field_access_fix instead of
	outer_field_access_fix.
	(patch_unary_op): Rename outer_field_flag to nested_field_flag.
	Use nested_field_expanded_access_p instead of
	outer_field_expanded_access_p. Use nested_field_access_fix instead
	of outer_field_access_fix.
	(check_thrown_exceptions): Use NESTED_FIELD_ACCESS_IDENTIFIER_P
	instead of OUTER_FIELD_ACCESS_IDENTIFIER_P.

2005-05-26  Bryce McKinlay  <mckinlay@redhat.com>

	* decl.c (GCJ_BINARYCOMPAT_ADDITION, 
	GCJ_BOOTSTRAP_LOADER_ADDITION): Removed.
	(FLAG_BINARYCOMPAT_ABI, FLAG_BOOTSTRAP_LOADER,
	MINOR_BINARYCOMPAT_ABI_VERSION): New.
	(GCJ_CURRENT_BC_ABI_VERSION): Use new method to calculate version ID.
	(parse_version): Calculate version ID using new method. Use bit-flags
	for flag_indirect_dispatch and flag_bootstrap_classes.

2005-05-25  Richard Henderson  <rth@redhat.com>

	PR libgcj/21692
	* Make-lang.in (java/mangle.o): Depend on LANGHOOKS_DEF_H.
	* class.c (build_class_ref): Set DECL_CLASS_FIELD_P and
	DECL_CONTEXT; avoid pushdecl_top_level.
	(build_dtable_decl): Set DECL_VTABLE_P and DECL_CONTEXT.
	(layout_class): Don't SET_DECL_ASSEMBLER_NAME.
	(layout_class_method): Likewise.
	* decl.c (java_mark_cni_decl_local): New.
	(java_mark_class_local): Use it.
	* java-tree.h (DECL_LOCAL_CNI_METHOD_P): New.
	(DECL_CLASS_FIELD_P, DECL_VTABLE_P): New.
	(struct lang_decl_func): Add local_cni;
	(struct lang_decl_var): Add class_field, vtable.
	(java_mangle_decl): Declare.
	* lang.c (LANG_HOOKS_SET_DECL_ASSEMBLER_NAME): New.
	* mangle.c: Remove dup obstack.h; include langhooks-def.h.
	(mangle_obstack_1): New.
	(java_mangle_decl): Remove obstack argument.  Call mangle_class_field,
	mangle_vtable, and mangle_local_cni_method_decl.  Fall back to
	lhd_set_decl_assembler_name for things that don't need mangling.
	(mangle_class_field): Rename from java_mangle_class_field, make
	static, don't call init_mangling or finish_mangling.
	(mangle_vtable): Similarly.
	(mangle_local_cni_method_decl): New.
	(init_mangling): Remove obstack argument.  Use &mangle_obstack_1,
	gcc_assert, and MANGLE_RAW_STRING.
	(finish_mangling): Use gcc_assert, remove if 0 debugging code.

2005-05-25  DJ Delorie  <dj@redhat.com>

	* class.c (set_constant_value): Move warning control from if() to
	warning(OPT_*).

2005-05-24  Richard Henderson  <rth@redhat.com>

	* builtins.c (define_builtin): Don't call make_decl_rtl.
	* constants.c (build_constant_data_ref): Likewise.
	* class.c (build_utf8_ref): Likewise.
	(build_fieldref_cache_entry, build_static_field_ref): Likewise.
	(get_dispatch_table, layout_class_method): Likewise.
	(build_class_ref): Likewise. Don't set DECL_SIZE or DECL_SIZE_UNIT
	by hand.
	(make_local_function_alias): Don't SET_DECL_ASSEMBLER_NAME.
	(make_method_value): Use METHOD_ABSTRACT instead of DECL_RTL_SET_P
	to determine if we need a non-zero address.
	* decl.c (builtin_function): Don't call make_decl_rtl.
	(give_name_to_locals): Don't SET_DECL_ASSEMBLER_NAME.
	* expr.c (build_known_method_ref): Don't call make_decl_rtl.
	* resource.c (compile_resource_data): Likewise.
	* parse.y (resolve_field_access): Re-word comment to avoid
	building DECL_RTL.

2005-05-24  Richard Henderson  <rth@redhat.com>

	* class.c (registered_class): Take it out of class_roots; turn into
	a vec of trees.
	(register_class): Make static.  Don't duplicate decl node.  Use
	VEC_safe_push.
	(emit_register_classes): Use VEC_iterate.  Use output_constant
	instead of assemble_integer.  Don't call mark_decl_referenced
	directly.
	* java-tree.h (register_class): Remove decl.

2005-05-19  Paolo Bonzini  <bonzini@gnu.org>

	PR java/17845

	* parse.y (register_package, package_list): Remove.
	(package_declaration): Do not call register_package.
	(do_resolve_class): Do not use package_list.

2005-05-15  Gerald Pfeifer  <gerald@pfeifer.com>

	* jcf-write.c (generate_bytecode_insns) <SAVE_EXPR>: Remove
	unused variable.

2005-05-15  Tom Tromey  <tromey@redhat.com>

	PR java/21519:
	* jcf-write.c (generate_bytecode_insns) <SAVE_EXPR>: Don't call
	NOTE_PUSH.

2005-05-12  Aaron Luchko <aluchko@redhat.com>

	* gcj.texi: Add '-verify', '-noverify', and '-verifyremote'.

2005-05-11  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Code Generation): Document -fbootstrap-classes.
	* decl.c (GCJ_BOOTSTRAP_LOADER_ADDITION): New macro.
	(parse_version): Use it.
	* lang.opt (-fbootstrap-classes): New option.

2005-05-10  Paolo Bonzini  <bonzini@gnu.org>

	PR java/21436
	* class.c (maybe_layout_super_class): Look for imports in this_class.
	* parse.h (ctxp_for_generation_last): New.
	(do_resolve_class): Add a parameter.
	* parse.y (ctxp_for_generation_last): New.
	(java_pop_parser_context): Add at end of list.
	(find_in_imports, find_in_imports_on_demand): Look in ctxp
	if the TYPE_IMPORT_LIST or respectively the TYPE_IMPORT_DEMAND_LIST of
	the given type are NULL.
	(do_resolve_class): Look into the imports of the new second parameter.
	Adjust recursive calls.
	(resolve_class, resolve_inner_class, find_as_inner_class): Adjust
	calls to do_resolve_class.
	(create_class): Set the TYPE_IMPORT_LIST and TYPE_IMPORT_DEMAND_LIST.
	(java_complete_class): Do not do that here.

2005-05-03  Thomas Fitzsimmons  <fitzsim@redhat.com>

	PR java/20309
	* Make-lang.in (java): Add gjnih.
	(JAVA_TARGET_INDEPENDENT_BIN_TOOLS): Likewise.
	(GJNIH_OBJS): New variable.
	(gjnih$(exeext)): New target.
	(JAVA_MANFILES): Add gjnih.1.
	(java.uninstall): Add gjnih.1.
	(java.mostlyclean): Add gjnih.
	(java.maintainer-clean): Add gjnih.1.
	(java/gjavah-jni.o): New target.
	(.INTERMEDIATE): Add gjnih.pod.
	(gjnih.pod): New target.
	* config-lang.in (stagestuff): Add gjnih.
	* gcj.texi (Top): Add gjnih node.
	(Invoking gcjh): Add descriptions of -force, -old, -trace, -J and
	-bootclasspath options.
	(Invoking gjnih): New node.
	* gjavah.c Initialize flag_jni to 1 if JNI_DEFAULT is defined.
	(TOOLNAME): New macro.
	(error): Replace hard-coded gcjh with TOOLNAME.
	(process_file): Likewise.
	(usage): Likewise.
	(version): Likewise.
	(help): Likewise.  Add help output for -force, -old, -trace and -J
	options.
	(OPT_FORCE, OPT_OLD, OPT_TRACE): New macros.
	(options): Add force, old, trace and J fields.
	(main): Handle -force, -old, -trace and -J options.

2005-05-03  Tom Tromey  <tromey@redhat.com>

	PR java/21245:
	* gjavah.c (main): Unlink output file on error.

2005-05-03  Kazu Hirata  <kazu@cs.umass.edu>

	* constants.c, jvgenmain.c, lang.opt, resource.c: Update
	copyright.

2005-04-29  Tom Tromey  <tromey@redhat.com>

	* expr.c (build_jni_stub): Updated for change to build_block.

2005-04-29  Andrew Pinski  <pinskia@gcc.gnu.org>

	* expr.c (force_evaluation_order): Declare 'saved' earlier.

2005-04-28  Andrew Haley  <aph@redhat.com>

	PR java/19285
	* java-tree.h (soft_resolvepoolentry_node): New.
	(alloc_constant_fieldref): Declare.
	* expr.c (expand_java_field_op): Don't call class_init for
	accesses to static fields with indirect dispatch.
	* builtins.c (initialize_builtins): Add "__builtin_expect".
	* decl.c (soft_resolvepoolentry_node): New variable.
	(java_init_decl_processing): Create a decl for
	"_Jv_ResolvePoolEntry".
	* class.c (build_fieldref_cache_entry): New function.
	(build_static_field_ref): Rewrite for indirect dispatch.
	* constants.c (find_name_and_type_constant_tree): New function.
	(alloc_constant_fieldref): Likewise.
	(build_constants_constructor): Handle CONSTANT_Fieldref and
	CONSTANT_NameAndType.

	PR java/21115
	* expr.c (force_evaluation_order): Convert outgoing args smaller
	than integer.

2005-04-27  Bryce McKinlay  <mckinlay@redhat.com>

	* gcj.texi (libgcj Runtime Properties): Remove obsolete
	gnu.gcj.runtime.NameFinder.* system properties. Update documentation 
	for gnu.gcj.runtime.NameFinder.use_addr2line and gnu.gcj.progname.

2005-04-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gjavah.c, jcf-dump.c, jv-scan.c, jvgenmain.c: Replace calls
	to `unlock_stream' with `unlock_std_streams'.

2005-04-25  Jakub Jelinek  <jakub@redhat.com>

	* Make-lang.in (java/decl.o, java/resource.o): Depend on $(EXPR_H)
	instead of just expr.h.

2005-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* gjavah.c (main): Unlock the stdio streams.
	* jcf-dump.c (main): Likewise.
	* jv-scan.c (main): Likewise.
	* jvgenmain.c (main): Likewise.

2005-04-23  DJ Delorie  <dj@redhat.com>

	* class.c, decl.c, expr.c, jcf-io.c, jcf-parse.c, jv-scan.c,
	parse.y: Adjust warning() callers.

2005-04-21  Bryce McKinlay  <mckinlay@redhat.com>

	* gcj.texi (Object fields): Change "Integer" to "Int" in example
	contructor.

2005-04-20  Bryce McKinlay  <mckinlay@redhat.com>

	* gcj.texi: Fix typos and bogus example.

2005-04-19  Kazu Hirata  <kazu@cs.umass.edu>

	* except.c: Fix a comment typo.

2005-04-19  Julian Brown  <julian@codesourcery.com>

	* decl.c (finish_method): Revert patch from 2005-04-13 for breaking
	indirect dispatch with PIC.

2005-04-18  Andrew Haley  <aph@redhat.com>

	* java-except.h (struct eh_range.handler): Remove unused field.
	(handle_nested_ranges): Remove function declaration.
	(sanity_check_exception_range): Add function declaration.	
	* verify.c (verify_jvm_instructions): Remove call to
	handle_nested_ranges.
	* verify-glue.c (verify_jvm_instructions_new): Call
	sanity_check_exception_range.
	* except.c (link_handler, eh_range_freelist, link_handler,
	handle_nested_ranges): Remove.
	(add_handler): Rewrite.
	(sanity_check_exception_range): New function.
	(print_ranges): New function.

2005-04-13  Julian Brown  <julian@codesourcery.com>

	* decl.c (finish_method): Give methods once-only linkage.

2005-04-11  Richard Sandiford  <rsandifo@redhat.com>

	* lang.opt: Refer to the GCC internals documentation instead of c.opt.

2005-04-07  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* java-tree.h: Don't use PARAMS().

2005-04-07  Per Bothner  <per@bothner.com>

	* class.c (push_class): By default, suppress debug output.
	(finish_class): Enable debug output for classes we're emitting.

2005-04-07  Andrew Haley  <aph@redhat.com>

	* gcj.texi: Correct gcj-dbtool instructions.

2005-04-04  Kazu Hirata  <kazu@cs.umass.edu>

	* gcj.texi: Fix a typo.
	* lang.c: Fix a comment typo.

2005-04-01  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* gcj.texi (Invoking gij): Add descriptions of new -X options.
	Mention recognized-and-ignored compatibility options.
	(Memory allocation): Add descriptions of JvMalloc, JvRealloc and
	JvFree.
	(About CNI): Add Memory allocation section.

2005-04-01  Tom Tromey  <tromey@redhat.com>

	* decl.c (java_init_decl_processing): Fix types of
	_Jv_MonitorEnter, _Jv_MonitorExit, _Jv_AllocObject,
	_Jv_AllocObjectNoFinalizer, _Jv_Throw, _Jv_NewPrimArray,
	_Jv_JNI_PopSystemFrame, _Jv_divI, _Jv_remI, _Jv_divJ, _Jv_remJ.

2005-03-31  Jan Hubicka  <jh@suse.cz>

	* Make-lang.in (class.o, decl.o): Depend on cgraph.h.
	* class.c: Include cgraph.h
	(make_local_functoin_alias): Mark aslias as needed.
	* resource.c: Include cgraph.h
	(compile_resource_data): Go via cgraph interface.

2005-03-30  Ian Lance Taylor  <ian@airs.com>

	* parse.y (maybe_yank_clinit): Don't crash if bbody is NULL.

2005-03-30  Tom Tromey  <tromey@redhat.com>

	* jcf-dump.c (HANDLE_INNERCLASSES_ATTRIBUTE): Handle cases where
	inner_class_info_index==0 or outer_class_info_index==0.

2005-03-29  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (libgcj Runtime Properties): Document
	gnu.gcj.runtime.endorsed.dirs.

2005-03-24  Anthony Green  <green@redhat.com>

	* gcj.texi (Invoking gcj-dbtool): Document new LIBDIR option to
	'gcj-dbtool -p'.

2005-03-23  Tom Tromey  <tromey@redhat.com>

	* decl.c (GCJ_CURRENT_BC_ABI_VERSION): New define.
	(parse_version): Use it.

2005-03-23  Joseph S. Myers  <joseph@codesourcery.com>

	* lang.c (LANG_HOOKS_TRUTHVALUE_CONVERSION): Remove.

2005-03-18  Andrew Haley  <aph@redhat.com>

	PR java/20522
	* decl.c (update_aliases): Don't update variables that are about
	to die.
	(maybe_poplevels): Add comment.

2005-03-17  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/20502
	* jcf-parse.c (duplicate_class_warning): New function.
	(java_parse_file): Call duplicate_class_warning if 
	CLASS_FROM_CURRENTLY_COMPILED_P is already set.
	(parse_zip_file_entries): Likewise. Also set
	CLASS_FROM_CURRENTLY_COMPILED_P.

2005-03-16  Andrew Haley  <aph@redhat.com>

	* expr.c (expand_java_arrayload): Don't generate a
	NullPointerException based on the type of the node.
	(build_java_array_length_access): Likewise.

2005-03-15  Zack Weinberg  <zack@codesourcery.com>

	* Make-lang.in (TEXI_JAVA_FILES): Add gcc-vers.texi.

2005-03-11  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Invoking gcj-dbtool): Document 'gcj-dbtool -p'.
	(libgcj Runtime Properties): Document the default .db.

2005-03-10  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/20312
	* parse.y (checks_throws_clauses): Check exceptions list even when
	the base class does not come from a source file being compiled.
	(java_complete_lhs): Remove unused variable 'wfl'.

2005-03-09  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/20338
	* decl.c (finish_method): Emit _Jv_InitClass for private static
	methods inside inner classes as well.

2005-03-08  Julian Brown  <julian@codesourcery.com>
	* Revert patch from 2005-03-08 for causing bootstrap failure on
	ppc-darwin.

2005-03-08  Julian Brown  <julian@codesourcery.com>

	* decl.c (finish_method): Give methods once-only linkage.

2005-03-07  Ranjit Mathew  <rmathew@hotmail.com>

	* lang.c (flag_new_verifier): Enable by default, regardless of ABI.

2005-03-07  Bryce McKinlay  <mckinlay@redhat.com>

	* verify-glue.c (vfy_is_assignable_from): Perform static check using
	can_widen_reference_to if the C++ ABI is in use.
	(vfy_get_interface_count, vfy_get_interface): Remove unused functions.
	* verify-impl.c (debug_print, make_utf8_const, init_type, copy_type,
	type_isresolved, init_state, set_pc, state_get_pc,
	_Jv_BytecodeVerifier): Clean up unused and disabled functions.
	(verify_fail): Report the current PC from the verifier context.
	(free_state): Remove #if 0 block to enable this function.
	(free_verifier_context): Call free_state on state_list iterator
	values before freeing them.
	* expr.c (pop_type_0): Pop correct type for error message when stack
	contains a multi-word type.

2005-03-07  Ranjit Mathew  <rmathew@hotmail.com>

	* expr.c (build_java_array_length_access): Remove !flag_new_verifier
	for known NULL array length access.

2005-03-07  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Invoking gcj-dbtool): Document '-f'.

2005-03-06  Kazu Hirata  <kazu@cs.umass.edu>

	* jcf-dump.c, jcf-io.c, jcf-reader.c, lang.c, parse.h,
	typeck.c: Update copyright.

2005-03-06  Ranjit Mathew  <rmathew@hotmail.com>

	Remove xref code.
	* xref.c, xref.h: Remove file.
	* Make-lang.in (java/xref.o): Remove.
	* java-tree.h (flag_emit_xref, do_not_fold): Remove declaration.
	* lang.c (flag_emit_xref): Remove definition.
	* parse.h (DECL_END_SOURCE_LINE, DECL_INHERITED_SOURCE_LINE): Remove.
	* typeck.c (convert): Remove use of do_not_fold.
	* parse.y (do_not_fold): Remove definition.
	(parser grammar): Remove xref code.
	(maybe_create_class_interface_decl, create_class): Likewise.
	(register_fields, method_header, finish_method_declaration): Likewise.
	(declare_local_variables, source_end_java_method): Likewise.
	(java_complete_expand_classes): Do not set do_not_fold.
	(java_complete_expand_method): Remove xref code.
	(java_expand_classes, resolve_field_access, patch_invoke): Likewise.
	(java_complete_tree, java_complete_lhs, patch_assignment): Likewise.
	(patch_binop, build_string_concatenation, patch_array_ref): Likewise.
	(patch_synchronized_statement, patch_throw_statement): Likewise.
	(maybe_build_class_init_for_field): Likewise.

2005-03-05  Kazu Hirata  <kazu@cs.umass.edu>

	* expr.c (build_expr_wfl, expr_add_location): Use TYPE_P
	instead of IS_NON_TYPE_CODE_CLASS.

2005-03-04  Andrew Haley  <aph@redhat.com>

	PR java/18362
	* class.c (set_method_index): Don't set method_index if it is
	NULL_TREE.
	(layout_class_method): Don't complain about "non-static method foo
	overrides static method" in the case of indirect dispatch.

2005-03-02  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jcf-io.c (caching_stat): Use __extension__ to avoid pedantic
	warning.
	* Make-lang.in: Don't elide warnings in jcf-io.c.

2005-03-01  Per Bothner  <per@bothner.com>

	PR java/8608
	* check-init.c (wfl): Remove static.
	(final_assign_error, check_init): Replace calls to parse_error_context
	by plain error.
	(check_init): Save, set, and restore input_location for each exp.

2005-03-01  Per Bothner  <per@bothner.com>

	* jcf-reader.c (get_attribute): Handle SourceDebugExtension (JSR 45)
	if HANDLE_SOURCEDEBUGEXTENSION_ATTRIBUTE is defined.
	* jcf-dump.c (HANDLE_SOURCEDEBUGEXTENSION_ATTRIBUTE): Print contents.

2005-03-01  Per Bothner  <per@bothner.com>

	* java-tree.h (IDENTIFIER_HANDLECLASS_VALUE): Remove ancient macro.

2005-02-23  Thomas Fitzsimmons  <fitzsim@redhat.com>

	PR libgcj/16923
	* gcj.texi (Invocation): Add descriptions of JvVMInitArgs and
	JvVMOption.

2005-02-22  Tom Tromey  <tromey@redhat.com>

	PR java/20056:
	* verify-impl.c (EITHER): New define.
	(types_compatible): Handle it.
	(check_field_constant): Use it.

2005-02-18  Tom Tromey  <tromey@redhat.com>

	PR java/20056:
	* verify-impl.c (types_equal): Fixed test.

	PR java/20056:
	* verify-glue.c (vfy_class_has_field): New function.
	* verify.h (vfy_class_has_field): Declare.
	* verify-impl.c (check_field_constant): Added 'putfield'
	argument.
	(verify_instructions_0): Updated.
	(types_equal): New function.

2005-02-14  Tom Tromey  <tromey@redhat.com>

	PR java/19921:
	* jcf-write.c (generate_bytecode_insns) <CALL_EXPR>: Note the
	stack effect of multianewarray.

2005-02-14  Andrew Haley  <aph@redhat.com>

	PR java/19907
	* expr.c (expand_byte_code): Call promote_arguments().
	(promote_arguments): New function.
	* decl.c (check_local_unnamed_variable): Remove special case for
	new verifier.
	(find_local_variable): Promote all boolean types to int
	when searching for local variable decls.

2005-02-12  Kazu Hirata  <kazu@cs.umass.edu>

	* builtins.c, java-except.h, jcf-parse.c, jv-scan.c, lex.c,
	parse-scan.y: Update copyright.

2005-02-11  Per Bothner  <per@bothner.com>

	PR java/15543
	* parse-scan.y (input_location): Remove variable.
	(main_input_filename): New - replaces input_filename, which isn't
	settable if USE_MAPPED_LOCATION.
	* lex.c (java_init_lex): Wrap some more places in #ifndef JC1-LITE,
	so we don't reference input_location or wfl_operator in that case.
	* jv-scan.c (expand_location): Remove - no longer used.
	(main): Set main_input_filename rather than input_filename.

2005-02-09  Richard Henderson  <rth@redhat.com>

	* builtins.c (initialize_builtins): Call build_common_builtin_nodes.
	* decl.c (java_init_decl_processing): Initialize const_ptr_type_node.

2005-02-08  Marcin Dalecki  <martin@dalecki.de>

	* expr.c (add_type_assertion): Use the proper enumeration type,
	since this is what htab_find_slot() is expecting.

2005-02-06  Joseph S. Myers  <joseph@codesourcery.com>

	* gcj.texi: Update copyright dates.

2005-02-02  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (libgcj Runtime Properties): Default library_control
	to 'cache'.

2005-02-02  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/15543
	* parse-scan.y (formal_parameter): Use $2 (type) instead of $$
	(modifiers) when square brackets are present in a declaration for
	a final paramter.
	* jv-scan.c (main): Set input_filename and input_line.

2005-02-01  Tom Tromey  <tromey@redhat.com>

	PR java/19742:
	* gjavah.c (get_field_name): Don't override name for JNI header.

2005-02-01  Roger Sayle  <roger@eyesopen.com>

	* jcf-write.c (generate_bytecode_insns): Implement RSHIFT_EXPR
	of unsigned types using iushr and lushr JVM bytecodes.

2005-02-01  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/19738
	* gjavah.c (jni_print_float): Do not emit floating-point
	initialiser for a static final field.
	(jni_print_double): Likewise.

2005-02-01  Mark Mitchell  <mark@codesourcery.com>

	Revert:
	2005-01-31  Mark Mitchell  <mark@codesourcery.com>
	* gjavah.c (print_field_info): Mark static data members of
	floating-point type with "__extension__".

2005-01-31  Mark Mitchell  <mark@codesourcery.com>

	* gjavah.c (print_field_info): Mark static data members of
	floating-point type with "__extension__".

2005-02-01  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/9157
	* parse.y (build_string_concatenation): Remove redundant if.
	(patch_conditional_expr): Attempt to patch_string() the condition
	of a ?: as well, in addition to its other operands.

2005-01-25  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (java/java-tree-inline.o): Removed.

2005-01-25  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/19070
	* parse.y (patch_binop): Allow comparisons against NULL only
	if the other operand is of a reference type.

2005-01-24  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (gcj_abi_version): Declare.
	* class.c (make_class_data): Push gcj_abi_version into "next"
	field.  Renamed field.
	* decl.c (gcj_abi_version): New global.
	(parse_version): New function.
	(java_init_decl_processing): Call it.  Renamed 'next' field.
	Include version.h.
	(GCJ_BINARYCOMPAT_ADDITION): New define.

2005-01-24  Roger Sayle  <roger@eyesopen.com>

	PR java/19295
	* jcf-write.c (generate_bytecode_insns): Conversions between
	integer types of the same precision shouldn't generate widening
	or narrowing conversion bytecodes.

2005-01-22  Kazu Hirata  <kazu@cs.umass.edu>

	* java-except.h, java-tree.h: Remove unused prototypes.

2005-01-20  Andrew Pinski  <pinskia@gcc.gnu.org>

	PR java/18091:
	* jcf-write.c (perform_relocations): Don't call memcpy if source
	and destination are the same.

2005-01-17  Tom Tromey  <tromey@redhat.com>

	* verify-impl.c (get_short): Sign extend.
	(get_int): Likewise.

2005-01-12  Ranjit Mathew  <rmathew@hotmail.com>

	* expr.c (build_jni_stub): Replace mistaken use of TYPE_SIZE_UNIT
	with TYPE_SIZE.

2005-01-10  Ranjit Mathew  <rmathew@hotmail.com>

	* verify.c: Revert to the version before the BC-ABI merge.

2005-01-10  Ranjit Mathew  <rmathew@hotmail.com>

	PR java/19277
	* check-init.c (check_init): Take care of references that do not
	have an explicit final variable declaration (e.g. array length
	access) for pre/post in/de-crement operators.

2005-01-08  Mark Wielaard  <mark@klomp.org>

	* parse.y (process_imports): Allocate (and free) original_name only
	when not already defined.
	* jcf-parse.c (read_class): Free results of find_class() and
	lrealpath().
	(java_parse_file): Keep pointer to head of file_list and free when
	done. Free result of lrealpath().

2005-01-05  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Standard Properties): java.ext.dirs is now used.

2004-12-20  Andrew Haley  <aph@redhat.com>

	* typeck.c: Use fold_convert for ints and booleans.

2004-12-17  Andrew Haley  <aph@redhat.com>

	PR java/18931
	* typeck.c (convert): Use a CONVERT_EXPR when converting to
	BOOLEAN_TYPE or CHAR_TYPE.
	(convert_to_boolean, convert_to_char) : Remove.
	* convert.h (convert_to_boolean, convert_to_char) : Remove.
	* expr.c (expand_load_internal): Do type conversion if type is not
	as required.

2004-12-13  Danny Smith  <dannysmith@users.sourceforge.net>

	PR target/18459
	* class.c (emit_register_classes): Use TARGET_USE_JCR_SECTION.
	Update comment.

2004-12-07  Andrew Haley  <aph@redhat.com>

	PR java/18811:
	* jcf-parse.c (load_class): Remove sanity test for missing inner
	class file.

2004-12-06  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (JAVA_MANFILES): Added gcj-dbtool.
	(java.uninstall): Likewise.
	(java.maintainer-clean): Likewise.
	(.INTERMEDIATE): Likewise.
	(java.install-man): Likewise.
	(gcj-dbtool.pod): New target.
	* gcj.texi (Code Generation): Document -findirect-dispatch.
	(libgcj Runtime Properties): Document
	gnu.gcj.precompiled.db.path.
	(Top): Link to "Invoking gcj-dbtool".

2004-12-06  Tom Tromey  <tromey@redhat.com>

	PR java/14853:
	* java-tree.h (extract_field_decl): Declare.
	* parse.y (extract_field_decl): Renamed from
	strip_out_static_field_access_decl.  No longer static.
	* check-init.c (get_variable_decl): Unwrap COMPOUND_EXPRs.

2004-12-03  Tom Tromey  <tromey@redhat.com>

	* lang.c (flag_new_verifier): Define.
	(java_post_options): Set flag_new_verifier if indirect dispatch
	is being used.
	* lang.opt (fnew-verifier): Removed.

2004-12-03  Tom Tromey  <tromey@redhat.com>

	PR bootstrap/14614:
	* Make-lang.in (java.install-common): Only install transformed
	gcjh if gcj-cross exists.

2004-12-03  Andrew Haley  <aph@redhat.com>

	PR java/18812
	* except.c (link_handler): Patch 'outer' field of siblings of the
	range we're demoting.

2004-12-03  Andrew Haley  <aph@redhat.com>

	PR java/18697
	* class.c (layout_class_method): Don't fail to override a method
	simply because it has DECL_ARTIFICIAL set.

2004-12-02  Tom Tromey  <tromey@redhat.com>

	PR java/16675:
	* parse.y (craft_constructor): Special case null_pointer_node.

2004-12-02  Tom Tromey  <tromey@redhat.com>

	PR java/18741:
	* java-gimplify.c (java_gimplify_expr): Don't call
	SET_EXPR_LOCATION unless wrapped tree is an expression.

2004-11-27  Per Bothner  <per@bothner.com>

	* jcf-parse.c (set_source_filename):  Improvement to Andrew's fix:
	Fix fencepost error in 'i', which got executed one too many times.
	Also, fold memcpy into explicit loop, as originally intended.
	Also, free temporary 'buf' which otherwise leaks.

2004-11-27  Per Bothner  <per@bothner.com>

	* expr.c (build_expr_wfl): Only declare last_file and last_filenode
	local static variables if not USE_MAPPED_LOCATION.

2004-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* class.c, decl.c, expr.c: Fix comment typos.

2004-11-26  Andrew Pinski  <pinskia@physics.uc.edu>

	PR java/18305
	* decl.c (end_java_method): Call
	attach_init_test_initialization_flags on all the init_decls.
	* parse.y (attach_init_test_initialization_flags): Move to ...
	* expr.c (attach_init_test_initialization_flags): here and
	support BIND_EXPR also.
	* java-tree.h (attach_init_test_initialization_flags): Prototype.
	* jcf-parse.c (parse_class_file): Don't disable class init
	optimization.

2004-11-25  Joseph S. Myers  <joseph@codesourcery.com>

	* gjavah.c, jcf-dump.c, jv-scan.c, jvspec.c: Avoid ` as left quote
	in diagnostics.

2004-11-24  Richard Henderson  <rth@redhat.com>

	* verify-glue.c (vfy_init_name, vfy_clinit_name, vfy_object_type,
	vfy_string_type, vfy_throwable_type): Use ANSI declaration form.

2004-11-24  Tom Tromey  <tromey@redhat.com>

	* verify.c (defer_merging): Don't use C++-style comment.
	* verify.h (java_opcode): Added java_opcode_end.
	* class.c (build_class_ref): Remove C++ comment and old FIXME.

	* verify-impl.c (vfy_push_type): Removed bogus "return".
	(initialize_stack): Use vfy_alloc and vfy_free.
	(verify_instructions_0): Likewise.

	* Merged gcj-abi-2-dev-branch to trunk.

2004-11-24  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (parse_class_file): Set file_start_location.

2004-11-10  Tom Tromey  <tromey@redhat.com>

	* class.c (make_field_value): Don't call build_static_field_ref.
	(build_static_field_ref): Don't emit direct references when using
	indirect dispatch.

	* gcj.texi (Invoking gij): Document -verbose.  Put -verbose and
	-verbose:class into man page synopsis.

2004-11-09  Tom Tromey  <tromey@redhat.com>

	* expr.c (build_java_arraystore_check): Still generate check if
	element type is itself an array.

2004-11-08  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (soft_check_assignment_node): Removed.
	(enum java_tree_index): Removed JTI_SOFT_CHECK_ASSIGNMENT_NODE.
	* decl.c (java_init_decl_processing): Don't initialize
	soft_check_assignment_node.

2004-11-05  Tom Tromey  <tromey@redhat.com>

	* class.c (layout_class_methods): Don't add Miranda methods when
	using indirect dispatch.

2004-11-05  Bryce McKinlay  <mckinlay@redhat.com>

	* class.c (make_class_data): Call emit_assertion_table to set the
	'assertion_table' field.
	(build_signature_for_libgcj): Move here from expr.c.
	(add_assertion_table_entry): New function. Callback for assertion
	hashtable traversal.
	(emit_assertion_table): New. Take class argument, and generate
	assertion table DECL based on the TYPE_ASSERTIONS hashtable.
	* decl.c (init_decl_processing): Define assertion_entry_type record.
	Push 'assertion_table' class field instead of 'verify'.
	* expr.c (type_assertion_eq): Compare 'assertion_code' field.
	(type_assertion_hash): Include 'assertion_code' in hash.
	(add_type_assertion): Rewritten. Take class and assertion_code
	arguments. Add assertions to the TYPE_ASSERTIONS hashtable.
	(can_widen_reference_to): Use new add_type_assertion() arguments.
	* java-tree.h (java_tree_index): Add JTI_ASSERTION_ENTRY_TYPE,
	JTI_ASSERTION_TABLE_TYPE. Remove JTI_VERIFY_IDENTIFIER_NODE.
	(verify_identifier_node): Removed.
	(assertion_entry_type, assertion_table_type): New.
	(ASSERTION_TYPES_COMPATIBLE, ASSERTION_IS_INSTANTIABLE): New. Type
	assertion code definitions.
	(struct type_assertion): Add assertion_code. Rename 'source_type' and
	'target_type' to 'op1' and 'op2'.
	(add_type_assertion): Declare.
	(lang_printable_name_wls): Remove unused definition.
	* verify-glue.c: (vfy_is_assignable_from): New. Call add_type_assertion
	to emit runtime assertion.
	(vfy_note_stack_type): Clean up non-C90 declarations.
	(vfy_note_local_type): Likewise.
	* verify.h (vfy_is_assignable_from): Declare.
	* verify-impl.c (is_assignable_from_slow): Remove unused function.
	(ref_compatible): Rename arguments. Call vfy_is_assignable_from()
	instead of is_assignable_from_slow().
	(types_compatible): Reinstate ref_compatible() call.

2004-11-04  Tom Tromey  <tromey@redhat.com>

	* class.c (build_static_field_ref): Reverted previous patch.

	* class.c (build_static_field_ref): Don't emit direct references
	when using indirect dispatch.

2004-11-03  Tom Tromey  <tromey@redhat.com>

	* expr.c (expand_java_arrayload): Set lhs_type_node.
	(expand_java_arraystore): Set rhs_type_node.

2004-11-02  Tom Tromey  <tromey@redhat.com>

	* jcf-parse.c (compute_class_name): Use filename length from zip
	directory, not strlen.

	* expr.c (expand_invoke): Mark new interface methods as abstract.

2004-11-01  Tom Tromey  <tromey@redhat.com>

	* verify-impl.c (push_jump): Removed check for uninitialized
	objects.
	(push_exception_jump): Likewise.
	(handle_ret_insn): Likewise.
	(handle_jsr_insn): Likewise.
	(state_check_no_uninitialized_objects): Removed.

	* decl.c (check_local_unnamed_variable): Recognize
	promoted-to-int parameters when using the new verifier.
	* expr.c (expand_java_arraystore): Explicitly request array type
	when using new verifier.
	(expand_java_arrayload): Likewise.
	(invoke_build_dtable): Don't pass object_type_node as
	expression argument to build_java_indirect_ref.
	(build_java_check_indexed_type): Do nothing.
	(build_java_arraystore_check): Handle case where array doesn't
	have array type.
	(build_java_array_length_access): Likewise.
	(expand_invoke): Handle case where interface overrides a method
	from Object.
	(pop_type_0): Always succeed for reference types.
	(process_jvm_instruction): Don't pop a value in a dead
	exception handler.
	(pop_arguments): Convert arguments to correct types.

2004-10-29  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (give_name_to_class): Remove line that was
	incorrectly merged.

2004-10-29  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (set_source_filename): Add code to build new sfname.

2004-10-20  Andrew Haley  <aph@redhat.com>

	* decl.c (end_java_method): Don't expand if flag_syntax_only.

2004-10-26  Tom Tromey  <tromey@redhat.com>

	* verify.h (vfy_notify_verified): Removed.
	* verify-glue.c (vfy_notify_verified): Removed.

2004-10-26  Tom Tromey  <tromey@redhat.com>

	* verify-impl.c (debug_print_state): Declare `i' before code.
	(merge_types): Modify `t' when it is null_type.

2004-10-26  Tom Tromey  <tromey@redhat.com>

	* verify-impl.c (type_print): Renamed from print.  Now static and
	takes an argument.
	(debug_print_state): Use type_print.

2004-10-25  Tom Tromey  <tromey@redhat.com>

	* expr.c (build_invokeinterface): Compute correct offset for
	index into interface methods.

2004-10-20  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (verify_jvm_instructions_new): Declare.

	* jvspec.c (jvgenmain_spec): Remove -fnew-verifier from cc1
	command line.

	* verify-impl.c (verify_instructions): Correctly handle wide
	types on the stack.
	* verify-glue.c (vfy_get_class_name): Use DECL_NAME.
	(vfy_get_component_type): Strip pointer types.
	(vfy_find_class): Use get_type_from_signature.  Strip pointer
	types.
	Include java-except.h.

2004-10-20  Bryce McKinlay  <mckinlay@redhat.com>

	* verify-impl.c (type_array_elementpop_raw, vfy_pop_type_t,
	vfy_push_type_t, set_variable, add_new_state, merge_into,
	handle_jsr_insn, branch_prepass, check_class_constant,
	check_wide_constant, get_one_type, compute_static_types,
	verify_instructions_0): Clean up C99 declarations after statements.

2004-10-20  Tom Tromey  <tromey@redhat.com>

	* verify-impl.c (merge_refs): Compare reference against iterator,
	not ref2.

	* verify-glue.c (vfy_tag): Mask off resolved flag.

2004-10-19  Tom Tromey  <tromey@redhat.com>

	* verify-impl.c (verify_instructions): Call vfy_note_local_type.
	(init_state_with_stack): Initialize `this_type' in state.
	(verify_method): Use debug_print.
	* verify-glue.c (vfy_is_primitive): Removed debugging print.
	(vfy_note_stack_depth): Reverted last patch.
	(vfy_note_stack_type): Note pointer to Object, not Object.
	(vfy_note_local_type): Likewise.

	* verify.h (vfy_note_instruction_seen): Declare.
	* verify-glue.c (verify_jvm_instructions_new): Set
	BCODE_EXCEPTION_TARGET on target instruction.
	(vfy_note_instruction_seen): New function.
	* verify-impl.c (FLAG_INSN_SEEN): New define.
	(verify_instructions_0): Set flag on instruction.  Save state for
	PC=0 later.
	(verify_instructions): Call vfy_note_instruction_seen.

	* verify-glue.c (vfy_note_stack_depth): Fix off-by-one error.
	(verify_jvm_instructions_new): Call method_init_exceptions,
	add_handler, and handle_nested_ranges.
	* verify-impl.c (verify_method): Return 1 on success.
	(verify_instructions_0): Save the state at PC=0.

	* verify-impl.c (init_type_from_class): Set is_resolved and
	ref_next on new ref_intersection.
	(init_type_from_string): Likewise.

2004-10-15  Bryce McKinlay  <mckinlay@redhat.com>

	* expr.c (expand_bytecode): Use verify_jvm_instructions_new
	if flag_new_verifier is set.
	* java-tree.h (flag_new_verifier): Declare.
	* lang.opt (fnew-verifier): New option.
	* verify-impl.c: Work around namespace pollution by undef'ing
	'current_class'.
	(struct verifier_context): Make 'bytecode' const.
	(verify_fail_pc): Pass -1 PC argument to vfy_fail.
	(types_compatible): For the BC-ABI, always consider reference types
	compatible.
	(check_class_constant): Use vfr->current_class.
	(check_constant): Likewise.
	(check_wide_constant): Likewise.
	(check_field_constant): Check for 'L' at start of type name.
	(get_one_type): Return pointer instead of type. Set type result in
	caller via passed type pointer.
	(compute_argument_types): Update to use new get_one_type arguments.
	(compute_return_type): Likewise.
	(make_verifier_context): New. Allocate and initialize 'vfr'.
	(free_verifier_context): New. Free 'vfr' and its contents.
	(verify_method): Remove ATTRIBUTE_UNUSED. Call make_verifier_context
	and free_verifier_context.

2004-10-15  Tom Tromey  <tromey@redhat.com>

	* verify-glue.c (vfy_note_local_type): Mark argument as unused.
	* verify.h (vfy_fail): Fixed formatting.

	* verify-impl.c (vfr): Fixed comment formatting.
	(collapse_type): New function.
	(verify_instructions): Notify compiler about type map.
	* verify.h (vfy_note_stack_depth): Updated.
	(vfy_note_stack_type): Likewise.
	(vfy_note_local_type): Likewise.
	(vfy_unsuitable_type, vfy_return_address_type, vfy_null_type):
	Declare.
	* verify-glue.c (vfy_note_stack_depth): Correctly size type
	state.  Added `method' argument.
	(vfy_note_stack_type): Renamed from vfy_note_type.  Added `method'
	argument.
	(vfy_note_local_type): New function.
	(vfy_unsuitable_type): Likewise.
	(vfy_return_address_type): Likewise.
	(vfy_null_type): Likewise.

	* verify.h (VFY_IN_GCC): Removed.
	(VFY_WANT_TYPEMAP): Removed.
	* verify-impl.c (verify_instructions_0): Removed useless "\".
	(struct state) <next>: Uncomment.

2004-10-13  Bryce McKinlay  <mckinlay@redhat.com>

	* verify-impl.c: Formatting fixes. Reformat C++-style comments to
	C-style.

2004-10-06  Bryce McKinlay  <mckinlay@redhat.com>

	* Make-lang.in (verify.o): Re-enabled this target.
	* verify-glue.c (vfy_get_interface_count): Add ATTRIBUTE_UNUSED.
	(vfy_get_interface): Likewise.
	(verify_jvm_instructions_new): Renamed from verify_jvm_instructions.
	* verify.h (verify_jvm_instructions_new): Declare.
	* verify-impl.c (free_state): Temporarily comment out unused
	function.

2004-10-06  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (JV_STATE_READ): New enum value.

2004-10-06  Bryce McKinlay  <mckinlay@redhat.com>

	* verify.h: New file.

2004-10-05  Bryce McKinlay  <mckinlay@redhat.com>

	* verify-impl.c, verify-glue.c, verify.h: New files.
	* Make-lang.in: Add rules for verify-impl.o and verify-glue.o.

2004-09-24  Andrew Haley  <aph@redhat.com>

	* decl.c (check_local_unnamed_variable): Always use the PARM_DECL
	for a slot if it's of pointer type.

2004-09-14  Tom Tromey  <tromey@redhat.com>

	* class.c (make_class_data): Correctly initialize "state" field.
	Initialize "engine" field.
	* decl.c (java_init_decl_processing): Add "engine" field.

2004-09-10  Andrew Haley  <aph@redhat.com>

	PR java/12760
	* expr.c (build_invokeinterface): Use fast method for interface
	dispatch.
	* java-tree.h (enum java_tree_index): Add JTI_ITABLE_TYPE,
	JTI_ITABLE_PTR_TYPE.
	(struct lang_type): Add  itable_methods, itable_decl, itable_syms_decl.
	(emit_symbol_table): Add new arg, element_size.
	* decl.c (java_init_decl_processing): Initialize Class.itable.
	* class.c (GEN_TABLE): New macro.
	(gen_indirect_dispatch_tables): Use it.  Add itable.
	(make_class_data): Add new arg for emit_symbol_table().
	Emit itable.
	(add_miranda_methods): Make sure search_class has been parsed.
	(emit_symbol_table): Add new arg, element_size.

2004-09-06  Andrew Haley  <aph@redhat.com>

	* verify.c (merge_types): Return Object for all merges of
	interfaces.
	* expr.c (add_type_assertion): Don't generate assertions when
	source type is array of Object.

2004-09-03  Andrew Haley  <aph@redhat.com>

	* class.c (finish_class): Nullify TYPE_VERIFY_METHOD.

	* lang.c (java_post_options): Force flag_verify_invocations if
	we're not using indirect dispatch.

	* expr.c (pop_type_0): Move test for interfaces before call to
	can_widen_reference_to().
	(build_signature_for_libgcj): Remove generation of canonical array
	type.
	(add_type_assertion): Canonicalize both arrays.
	Don't assert that type X can be assigned to Object.
	Don't assert that type X an be assigned to type X.
	Don't assert that Object can be assigned to type X.
	(can_widen_reference_to): Warn whenever we generate an assertion.
	(process_jvm_instruction): Use throwable_type_node for the type of
	an exception class.

2004-09-01  Andrew Haley  <aph@redhat.com>

	* decl.c (java_init_decl_processing): Change
	verify_identifier_node to "__verify".
	* expr.c (add_type_assertion): Use verify_identifier_node for name.
	* java-tree.h (verify_identifier_node): Change to "__verify".

	* expr.c (build_signature_for_libgcj): New function.
	(add_type_assertion): Use it to construct signatures for
	source_type and target_type.

2004-08-27  Andrew Haley  <aph@redhat.com>

	* java-tree.h (enum java_tree_index): Add JTI_VERIFY_IDENTIFIER_NODE.
	(verify_identifier_node): New.
	(TYPE_VERIFY_METHOD): New.
	(struct type_assertion): New type.
	* expr.c (type_assertion_eq): New function.
	(type_assertion_hash): New function.
	(add_type_assertion): New function.
	(can_widen_reference_to): Call add_type_assertion().
	* decl.c (java_init_decl_processing): Add verify_identifier_node.
	* class.c (make_class_data): Initialize TYPE_VERIFY_METHOD (type).
	(finish_class): Output TYPE_VERIFY_METHOD (type).

	* decl.c (end_java_method): Nullify unused fields.

2004-08-17  Andrew Haley  <aph@redhat.com>

	* verify.c (defer_merging): Quieten.
	* jcf-parse.c (load_class): Only try to open a class file if it's
	java.lang.Object or if it's part of the current compilation.
	Check that the class we just tried to load is the class we just
	loaded.  Quieten.
	(java_parse_file): Set flag_verify_invocations off if we're
	compiling from .class.
	(parse_zip_file_entries): Abort if we try to read a dummy class.
	* expr.c (can_widen_reference_to): Quieten.
	(build_invokevirtual): Abort if we try to invokevirtual an
	interface.
	(expand_invoke): Don't build a non-interface call to an interface.
	(build_instanceof): Don't do premature optimization if
	flag_verify_invocations is not set.
	* class.c (set_super_info): Disable code that inherits TYPE_DUMMY
	from superclass.
	(build_static_field_ref): Add correct type conversion for
	field_address.
	(add_miranda_methods): Disable generation of Miranda methods for
	dummy classes.
	(layout_class_method): Don't complain about non-static method
	overrides static method with dummy classes.

2004-08-13  Tom Tromey  <tromey@redhat.com>

	* class.c (build_static_field_ref): Re-enable atable lookups for
	static fields.

	* parse.y (strip_out_static_field_access_decl): Indentation fix.

2004-08-11  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (libgcj Runtime Properties): Document new properties.

2004-08-06  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (load_class): Check that we really have loaded the
	class we're looking for.

2004-07-19  Andrew Haley  <aph@redhat.com>

	* verify.c (verify_jvm_instructions): Comment change only.

	* typeck.c (build_java_array_type): Add size field to array name.

	* java-tree.h (LOCAL_SLOT_P): New.
	(update_aliases): Add PC argument.
	(pushdecl_function_level): New function.

	* java-gimplify.c (java_gimplify_expr): Handle VAR_DECL,
	MODIFY_EXPR, and SAVE_EXPR.
	(java_gimplify_modify_expr): New function.

	* expr.c (push_type_0): Call find_stack_slot() to create temporary.
	(expand_iinc): Pass PC to update_aliases().
	(STORE_INTERNAL): Likewise.
	(process_jvm_instruction): Likewise.

	* decl.c (base_decl_map): New variable.
	(uniq): New variable.
	(update_aliases): Rewrite with more thorough checking.
	(debug_variable_p): New function.
	(push_jvm_slot): Don't initialize local variable.  Don't pushdecl.
	(check_local_named_variable): Delete whole function.
	(initialize_local_variable): New function.
	(check_local_unnamed_variable): Add checks and comments.
	(find_local_variable): Rewrite.
	(java_replace_reference): New function.
	(function_binding_level): New variable.
	(pushdecl_function_level): New function.
	(maybe_pushlevels): Set DECL_LOCAL_END_PC.
	(maybe_pushlevels): Call pushdecl() on each of the new decls.
	(start_java_method): Reset uniq.  Create base_decl_map.  Set
	function_binding_level.
	(end_java_method): Null unused fields to save memory.

2004-06-29  Andrew Haley  <aph@redhat.com>

	* except.c (expand_start_java_handler): Push a new binding level.
	Don't build a TRY_CATCH_EXPR now, we'll do it later.  Call
	register_exception_range() to register where we'll do it.
	(expand_end_java_handler): Remove old bogus code.  Replace with
	new logic that simply builds TRY_CATCH_EXPRs and inserts them at
	the top of the expression we're curently building.
	(maybe_end_try): Delete.
	* decl.c (binding_level.exception_range): New field.
	(clear_binding_level): Add field exception_range.  Reformat.
	(poplevel): Call expand_end_java_handler().
	(poplevel): Call java_add_stmt only if functionbody is false.
	(maybe_poplevels): Don't call maybe_end_try() from here.
	(end_java_method): Clear no longer used trees in function decl.
	(register_exception_range): New function.
	* java-tree.h (register_exception_range, struct eh_range): Declare.

2004-06-22  Andrew Haley  <aph@redhat.com>

	* class.c (gen_indirect_dispatch_tables): Set the DECL_OWNER of
	the otable.
	* check-init.c (get_variable_decl): Teach check-init about
	FIELD_DECLs addressed via the otable.
	* jcf-parse.c (load_class): Check CLASS_LOADED_P, not
	CLASS_PARSED_P.

2004-05-28  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (load_class): Don't try to read a class that we've
	already read.

	* expr.c (build_invokeinterface): Use the old-fashioned way of
	doing indirect dispatch: look up interfaces by name.
	* java-tree.h (enum java_tree_index): Add
	JTI_SOFT_LOOKUPINTERFACEMETHODBYNAME_NODE
	* decl.c (java_init_decl_processing): Add
	soft_lookupinterfacemethodbyname_node.

	* gjavah.c (print_method_info): Final methods have vtable entries,
	so gjavah needs to output them.
	* class.c (layout_class_method): Generate vtable entries for final
	methods.
	* parse.y (invocation_mode): Use INVOKE_VIRTUAL for indirect
	dispatch, even if a method is final.

2004-05-25  Andrew Haley  <aph@redhat.com>

	* class.c (build_symbol_entry): Convert the names of constructors
	to init_identifier_node when generating an entry for the indirect
	dispatch table.

	* expr.c (build_known_method_ref): Generate indirect calls for
	all methods marked DECL_EXTERNAL or TREE_PUBLIC.

2004-05-24  Andrew Haley  <aph@redhat.com>

	* expr.c (build_known_method_ref): Make sure ARRAY_REF access to
	atable element is of the right type.

	* class.c (build_static_field_ref): Cast pointer to correct type
	for field.

2004-04-20  Bryce McKinlay  <mckinlay@redhat.com>

	* Merged with HEAD as of 20040514. Diff against
	gcj-abi-2-merge-20040514.

2004-04-16  Andrew Haley  <aph@redhat.com>

	* verify.c (check_pending_block): Disable subroutine checks.
	(defer_merging): New function.
	(merge_types): If types are dummy, use defer_merging to combine them.
	(verify_jvm_instructions): If invocation is invokeinterface and
	target is dummy, assume target really is an interface.

	* parse.y (patch_invoke): Break out call to java_create_object.

	* lang.c (flag_verify_invocations): New.

	* jcf-parse.c (load_class): If we've already failed to load a
	class, don't try again.
	(load_class): If we can't find a .class file, don't fail, but emit
	a warning.
	(parse_class_file): Don't act on dummy methods.

	* java-tree.h (flag_verify_invocations): New.
	(TYPE_DUMMY): New.
	(lang_type.dummy_class): New field.
	(java_create_object): New function.
	(METHOD_DUMMY): New.

	* expr.c (build_field_ref): Widen field offset.
	(pop_type_0): If the type in stack_type_map is a TREE_LIST, check
	that each of its elements is compatible with the one we're
	popping.
	(pop_type_0): Issue a warning to say that we need to generate a
	runtime check.
	(java_create_object): New function.
	(build_field_ref): Only generate hard refs if we're not using
	indirect dispatch.
	(expand_java_field_op): If we're using !verify_invocations and we
	see a missing field, generate a decl for it.

	(expand_invoke): If a class doesn't have the method we seek and
	we're using !flag_verify_invocations, generate a decl for the
	method now.

	(build_known_method_ref): Always use indirect dispatch via the
	atable for static methods.

	(expand_java_NEW): Break out object creation into new function,
	java_create_object.

	(can_widen_reference_to): Issue a warning to say that we need to
	generate a runtime check.

	* class.c (set_super_info): Inherit TYPE_DUMMY from sureclass.
	(make_method_value): Also use index for interfaces.
	(make_class_data): Skip dummy field for inherited data.
	Don't build method array for dummy methods.
	Set size_in_byte to -1 when using inirect dispatch
	Don't build a hard class ref if we don't have a hard ref to our
	superclass, or if we're using inirect dispatch.
	Null out dispatch tables.

	(layout_class_method): Don't complain about non-static method
	overrides static method is method is artificial.

	(build_static_field_ref): Disable atable references to static
	fields for the time being.

	(layout_class_methods): Check for CLASS_INTERFACE as
	well as CLASS_ABSTRACT.

2004-11-24  Steven Bosscher  <stevenb@suse.de>

	* class.c (make_class_data): Don't check flag_inline_functions.
	* lang.c (flag_really_inline): Remove unused flag.
	(java_handle_option): Don't set it here.  Remove special handling
	of flag_inline_functions for Java.
	(java_init): Don't set flag_inline_trees here.  Already done...
	(java_post_options): ...here.  Don't clear flag_inline_functions.

2004-11-24  Steven Bosscher  <stevenb@suse.de>

	* java-gimplify.c (java_gimplify_labeled_block_expr): New function.
	(java_gimplify_exit_block_expr): New function.
	(java_gimplify_expr): Use them to gimplify EXIT_BLOCK_EXPR and
	LABELED_BLOCK_EXPR.
	* java-tree.def (LABELED_BLOCK_EXPR): Moved from tree.def.
	(EXIT_BLOCK_EXPR): Likewise.
	* java-tree.h (LABELED_BLOCK_LABEL): Moved from tree.h.
	(LABELED_BLOCK_BODY): Likewise.
	(EXIT_BLOCK_LABELED_BLOCK): Likewise.
	* jcf-write.c (generate_bytecode_insns): Don't handle the unused
	EXIT_BLOCK_RETURN operand.  Use EXIT_BLOCK_LABELED_BLOCK instead of
	TREE_OPERAND.
	* lang.c (java_tree_inlining_walk_subtrees): Handle EXIT_BLOCK_EXPR.
	(java_dump_tree): Use LABELED_BLOCK_LABEL, LABELED_BLOCK_BODY, and
	EXIT_BLOCK_LABELED_BLOCK instead of TREE_OPERAND.  Don't handle the
	second operand of EXIT_BLOCK_EXPR.
	* parse.y (find_expr_with_wfl): Use LABELED_BLOCK_BODY instead of
	TREE_OPERAND.
	(build_bc_statement): Use build1 to build EXIT_BLOCK_EXPR nodes.

2004-11-23  Ben Elliston  <bje@au.ibm.com>

	* xref.h (xref_flag_value): Remove.
	(xref_set_data, xref_get_data): Likewise.
	(xref_set_current_fp): Likewise.
	(XREF_NONE): Likewise.
	(XREF_GET_DATA): Likewise.
	* xref.c (xref_flag_value): Remove.
	(xref_set_data, xref_get_data): Likewise.
	(xref_set_current_fp): Likewise.

2004-11-23  Ben Elliston  <bje@au.ibm.com>

	* gjavah.c (output_directory): Make static.
	(temp_directory): Likewise.

2004-11-15  Tom Tromey  <tromey@redhat.com>

	* decl.c (instn_ptr_type_node): Removed.
	(lineNumbers_ptr_type_node): Removed.
	(jint_type): Removed.
	(jint_ptr_type): Removed.

2004-11-09  Andrew Pinski  <pinskia@physics.uc.edu>

	PR java/15576
	* check-init.c (check_init): Ignore DECL_EXPR.
	* expr.c (always_initialize_class_p): Reenable.
	(build_class_init): Use a variable to store the decl.  Also use
	boolean_false_node instead of integer_zero_node.
	* parse.y (attach_init_test_initialization_flags): Add a decl_expr
	to the block.

2004-11-08  Tom Tromey  <tromey@redhat.com>

	PR java/16843:
	* gjavah.c (HANDLE_END_FIELD): Call print_field_info when
	generating a JNI header.
	(print_field_info): Handle JNI headers.
	(jni_print_float): Likewise.
	(jni_print_double): Likewise.

2004-11-08  Andrew Pinski  <pinskia@physics.uc.edu>

	* decl.c (end_java_method): Remove duplicated code.

2004-11-06  Zack Weinberg  <zack@codesourcery.com>
	    Gerald Pfeifer  <gerald@pfeifer.com>

	* lex.h (HAVE_ICONV): Undefine if we do not have HAVE_ICONV_H
	as well.

2004-11-02  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/17265
	* class.c: Reinstate 2004-08-18 patch.
	(make_local_function_alias): Don't create an alias for extern (native)
	functions.

2004-10-22  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR java/17265
	* class.c (make_local_function_alias): Revert 2004-08-18 change.
	(make_method_value): Likewise.

2004-10-21  Andrew Haley  <aph@redhat.com>

	PR java/18091:
	* jcf-parse.c (set_source_filename): Add code to build new sfname.

2004-10-20  Andrew Haley  <aph@redhat.com>

	* decl.c (end_java_method): Don't expand if flag_syntax_only.
	Remove duplicated code block.

2004-10-18  Steven Bosscher  <stevenb@suse.de>

	* Make-lang.in (java/parse.o-warn, java/parse-scan.o-warn):
	New rules to work around old Bison warnings.

2004-10-17  Steven Bosscher  <stevenb@suse.de>

	* class.c (ident_subst): Always alloca buffer.
	* java-opcodes.h (LAST_AND_UNUSED_JAVA_OPCODE): Add this dummy
	opcode after including javaop.def.
	* jcf-dump.c (CHECK_PC_IN_RANGE): Return 0 from the arm of the
	conditional expression that exits, to avoid warnings.
	* verify.c (CHECK_PC_IN_RANGE): Mark the __GNUC__ definition as
	a user of an extension.
	* win32-host.c: Move check down to have non-empty file when
	WIN32 is not defined.

	* Make-lang.in (java-warn): Add STRICT_WARN.
	(java/jcf-io.o-warn): Don't have Werror for this file.
	* jcf-io.c (caching_stat): Add FIXME for non-POSIX scandir use.

2004-10-16  Hans-Peter Nilsson  <hp@bitrange.com>

	* expr.c (expr_add_location): Move declaration to before all
	statements.
	* parse.y (java_expand_classes): Ditto.
	* lex.c (java_peek_unicode): Ditto.

2004-10-16  Ranjit Mathew  <rmathew@hotmail.com>

	* check-init.c: Use %<, %> and %q for quoting in diagnostics,
	if possible, else convert `foo' to 'foo'.
	* class.c: Likewise.
	* decl.c: Likewise.
	* expr.c: Likewise.
	* jcf-io.c: Likewise.
	* jcf-parse.c: Likewise.
	* lang.c: Likewise.
	* lex.c: Likewise.
	* parse.h: Likewise.

2004-10-16  Ranjit Mathew  <rmathew@hotmail.com>

	* parse.y (parse_warning_context): Remove ATTRIBUTE_PRINTF_2 and
	rename parameter 'msg' to 'msgid' in function declaration.
	(issue_warning_error_from_context): Likewise.
	(yyerror): Rename parameter 'msg' to 'msgid'.
	(all over): Use new quoting style for diagnostics.

2004-10-15  Kazu Hirata  <kazu@cs.umass.edu>

	* boehm.c, builtins.c, java-except.h, jcf-io.c, jcf-path.c,
	jcf.h, lang-specs.h, lex.c, lex.h, resource.c, win32-host.c:
	Update copyright.

2004-10-14  Matt Austern  <austern@apple.com>

	* lang.c (java_tree_inlining_walk_subtrees): Last arg is struct
	pointer_set_t* now.

2004-10-13  Tom Tromey  <tromey@redhat.com>

	PR java/15578:
	* lang.opt (--extdirs): Document.
	* jvspec.c (lang_specific_driver): Recognize -encoding and
	-extdirs.

2004-10-06  Ulrich Weigand  <uweigand@de.ibm.com>

	* parse.y (issue_warning_error_from_context): Use va_list *
	instead of va_list parameter.
	(parse_error_context): Update call.
	(parse_warning_context): Likewise.

2004-10-05  Zack Weinberg  <zack@codesourcery.com>

	* parse.y, parse-scan.y: Add list of diagnostic messages to
	insulate translation template from version of yacc/bison used
	to compile the grammar.

2004-10-05  Ranjit Mathew  <rmathew@hotmail.com>

	Prepare for %q, %< and %> in diagnostic message strings.
	* java-tree.h (parse_error_context): remove ATTRIBUTE_PRINTF_2.
	Name second parameter 'msgid'.
	* parse.y: Additionally include pretty-print.h and diagnostic.h.
	(issue_warning_error_from_context): Use pretty-printer functions
	instead of vsprintf for constructing formatted messages. Rename
	parameter 'msg' to 'msgid'.
	(parse_error_context): Rename parameter 'msg' to 'msgid'.
	(parse_warning_context): Likewise.

2004-10-05  Andrew Haley  <aph@redhat.com>

	PR java/17779
	* jcf-parse.c (parse_zip_file_entries): If a class has a
	superclass and a TYPE_SIZE of zero, lay it out.

2004-09-30  Andrew Haley  <aph@redhat.com>

	PR java/17733
	* jcf-parse.c (compute_class_name): Rewrite.

2004-10-01  Jan Hubicka  <jh@suse.cz>

	* java.c (java_expand_body): Update call of tree_rest_of_compilation.

2004-10-01  Kazu Hirata  <kazu@cs.umass.edu>

	* lex.c: Fix a comment typo.

2004-10-01  Kazu Hirata  <kazu@cs.umass.edu>

	* java-tree.h: Fix a comment typo.

2004-09-30  Per Bothner  <per@bothner.com>

	Simplify lexer.  Implement --enable-mapped-location support.
	* jcf-parse.c (parse_class_file):  Use linemap_line_start.
	(parse_source_file_1): Pass filename as extra parameter, so we can call
	linemap_add and set input_location here, rather than in both callers.
	(read_class): Pass copied filename to parse_source_file_1.
	Don't initialize wfl_operator - only needed for source compilation.
	(read_class, jcf_parse):  Call linemap_add with LC_LEAVE.
	* lex.h:  Remove a bunch of debugging macros.
	* lex.h (struct_java_line, struct java_error):  Remove types.
	(JAVA_COLUMN_DELTA):  Remove - use java_lexer.next_colums instead.
	(struct java_lc_s):  Remove prev_col field.
	(struct java_lexer):  New fields next_unicode, next_columns, and
	avail_unicode.  New position field, and maybe token_start field.
	Don't need hit_eof field - use next_unicode == -1 instead.
	(JAVA_INTEGERAL_RANGE_ERROR):  Rename to JAVA_RANGE_ERROR.
	(JAVA_RANGE_ERROR, JAVA_FLOAT_ANGE_ERROR):  Update accordingly.
	* parse.h:  Various changes for USE_MAPPED_LOCATION.
	(EXPR_WFL_EMIT_LINE_NOTE): XXX
	(BUILD_EXPR_WFL, EXPR_WFL_ADD_COL): Remove no-longer-used macros.
	(struct parser_ctxt):  New file_start_location field.
	Remove p_line, c_line fields since we no longer save lines.
	Remove elc, lineno, and current_jcf fields - no longer used.
	* parse.y:  Updates for USE_MAPPED_LOCATION and new lexer.
	Don't use EXPR_WFL_ADD_COL since that isn't trivial with
	source_location and is probably not needed anymore anyway.
	Use new expr_add_Location function.
	(SET_EXPR_LOCATION_FROM_TOKEN):  New convenience macro.
	(java_pop_parser_context):  Minor cleanup.
	(java_parser_context_save_global, java_parser_context_restore_global,
	java_pop_parser_context):  Save/restore input_location as a unit.
	(issue_warning_error_from_context):  If USE_MAPPED_LOCATION take
	a source_location instead of a wfl context node.
	(check_class_interface_creation):  input_filename is not addressable.
	(create_artificial_method):  Calling java_parser_context_save_global
	and java_parser_context_restore_global is overkill.  Instead,
	temporarily set input_location from class decl.
	(java_layout_seen_class_methods): Set input_location from method decl.
	(fix_constructors): Make more robust if no EXPR_WITH_FILE_LOCATION.
	(finish_loop_body):  Likewise.
	* lex.c: Updates for USE_MAPPED_LOCATION.  Use build_unknwon_wfl.
	(java_sprint_unicode):  Take a character, not index in line.
	(java_sneak_uncode):  Replaced by java_peek_unicode.
	(java_unget_unicode):  No longer used.
	(java_allocate_new_line. java_store_unicode):  Removed, since we
	no longer remember "lines".
	(java_new_lexer):  Update for new data structures.
	(java_read_char):  Move unget_value checking to java_read_unicode.
	(java_get_unicode, java_peek_unicode, java_next_unicode): New more
	efficient functions that are used directly when lexing.
	(java_read_unicode_collapsing_terminators):  No longer needed.
	(java_parse_end_comment, java_parse_escape_sequence, do_java_lex):
	Re-organize to use java_peek_unicode to avoid java_unget_unicode.
	(java_parse_escape_sequence):  Rewrite to be simpler / more efficient.
	(do_java_lex):  Lots of movings around to avoid java_unget_unicode,
	combine switch branches, and test for common token kinds earlier.
	(java_lex_error):  Rewrite.
	* jv-scan.c (expand_location): New function, copied from tree.c.
	(main): Set ctxp->filename instead of setting input_filename directly.

2004-09-30  Per Bothner  <per@bothner.com>

	More cleanup for --enable-mapped-location.
	* class.c (push_class):  If USE_MAPPED_LOCATION don't set
	input_location here.  Instead do it in give_name_to_class.
	(build_class_ref):  Set DECL_ARTIFICIAL, for the sake of dwarf2out.
	* expr.c (expand_byte_code): Call linemap_line_start.
	* expr.c (build_expr_wfl):  If USE_MAPPED_LOCATION, change final
	parameters to a source_location.  Don't need EXPR_WFL_FILENAME_NODE.
	(expr_add_location):  New function, if USE_MAPPED_LOCATION.
	* class.c (maybe_layout_super_class):  Adjust build_expr_wfl call
	to USE_MAPPED_LOCATION case.

	* java-tree.h (JAVA_FILE_P, ZIP_FILE_P):  Remove unused macros.
	* jcf-parse.c (java_parse_file): Don't set input_filename.
	Use IS_A_COMMAND_LINE_FILENAME_P to check for duplicate filenames.
	Create a list of TRANSLATION_UNIT_DECL.
	(current_file_list):  Is now a TRANSLATION_UNIT_DECL chain.  The
	reason is so we can set a DECL_SOURCE_LOCATION for each file.
	(java_parse_file):  Don't set unused ZIP_FILE_P, JAVA_FILE_P..
	Create line-map LC_ENTER/LC_LEAVE entries for archive itself.
	(file_start_location):  New static.
	(set_source_filename):  Avoid extra access to input_filename macro.
	Concatenate new name with class's package prefix.
	(set_source_filename, give_name_to_class): Update.
	(give_name_to_class):  Set class's "line 0" input_location here.
	(parse_class_file):  Set input_location as a unit.

	* jcf-parse.c (load_class): Sanity test if missing inner class file.

2004-09-29  Per Bothner  <per@bothner.com>

	* java-tree.h:  Redefine some macros and add some declaration
	to handle the USE_MAPPED_LOCATION case.
	* parse.h (EXPR_WFL_QUALIFICATION):  Use operand 1, not 2.
	* java-tree.h (EXPR_WFL_FILENAME_NODE):  Use operand 2, not 1.
	* java-tree.def (EXPR_WITH_FILE_LOCATION): Only need two operands in
	USE_MAPPED_LOCATION case, since EXPR_WFL_FILENAME_NODE is gone.

	* check-init.c (check_init): Handle USE_MAPPED_LOCATION case.
	* decl.c (finish_method, java_add_stmt): Likewise.
	* java-gimplify.c (java-gimplify.c):  Likewise.
	* jcf-write.c (generate_bytecode_insns):  Likewise.
	* lang.c (java_post_options): Likewise - call linemap_add.

2004-09-29  Andrew Haley  <aph@redhat.com>

	PR java/17007
	* parse.y (patch_binop): Don't mess with the TREE_SIDE_EFFECTS of the
	result of TRUNC_MOD_EXPR.
	(patch_unaryop): Likewise for CONVERT_EXPR, which may throw.
	* decl.c (java_init_decl_processing): Mark
	soft_lookupinterfacemethod_node and soft_instanceof_node pure.

2004-09-28  Tom Tromey  <tromey@redhat.com>

	PR java/15710:
	* class.c (add_miranda_methods): Load superinterface if not
	already loaded.

2004-09-28  Andrew Haley  <aph@redhat.com>

	PR java/17586
	* jcf-parse.c (load_class): Don't try to read a class that we've
	already read.

2004-09-28  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (load_class): Back out previous broken patch.

2004-09-28  Andrew Haley  <aph@redhat.com>

	PR java/17586
	* jcf-parse.c (load_class): Don't try to read a class that we've
	already read.
	Check that we really did read the right class.

2004-09-25  Tom Tromey  <tromey@redhat.com>

	PR java/17500:
	* parse.y (create_artificial_method): Use add_method_1.

2004-09-25  Kazu Hirata  <kazu@cs.umass.edu>

	* expr.c, jcf-dump.c, parse-scan.y, parse.y: Fix
	comment typos.
	* gcj.texi: Fix typos.

2004-09-24  Tom Tromey  <tromey@redhat.com>

	PR java/15656:
	* parse.y (class_instance_creation_expression): Set `$$' to NULL
	in error parts of rule.
	(unary_expression): Don't call error_if_numeric_overflow when $1
	is NULL.

2004-09-24  Tom Tromey  <tromey@redhat.com>

	PR java/16789:
	* parse.y (resolve_qualified_expression_name): Set
	CAN_COMPLETE_NORMALLY on first call when chaining static calls.
	* expr.c (force_evaluation_order): Check for empty argument list
	after stripping COMPOUND_EXPR.

2004-09-23  Andrew Haley  <aph@redhat.com>

	PR java/16927:
	* parse.y (java_complete_lhs): Call patch_string() on Operand 1 of
	COND_EXPRs.

2004-09-23  Tom Tromey  <tromey@redhat.com>

	PR java/17329:
	* java-gimplify.c (java_gimplify_expr) <SAVE_EXPR>: Ignore case
	where operand is null.

2004-09-23  Tom Tromey  <tromey@redhat.com>

	PR java/17380:
	* parse.y (not_accessible_p): Allow access to protected members
	even when class is not static.

2004-09-22  Kelley Cook  <kcook@gcc.gnu.org>

	* Make-lang.in: Revert the gcc-none.o change.

2004-09-22  Nathan Sidwell  <nathan@codesourcery.com>

	* parse.y (patch_anonymous_class): VEC_space returns true if there
	is space.

2004-09-21  Matt Austern  <austern@apple.com>

	Fix bootstrap.
	* gjavah.c (free_method_name_list): Fix function definition so
	it's a proper C prototype.

2004-09-21  Tom Tromey  <tromey@redhat.com>

	PR java/17575:
	* gjavah.c (free_method_name_list): New method.
	(main): Call it.

2004-09-17  Jeffrey D. Oldham  <oldham@codesourcery.com>
	    Zack Weinberg  <zack@codesourcery.com>

	* java-tree.def: Use tree_code_class enumeration constants
	instead of code letters.
	* java-gimplify.c, jcf-write.c, lang.c, parse.y: Update for
	new tree-class enumeration constants.

2004-09-13  Tom Tromey  <tromey@redhat.com>

	PR java/17216:
	* class.c (layout_class_method): Put synthetic methods into the
	vtable.

2004-09-11  Andrew Pinski  <apinski@apple.com>

	* Make-lang.in (java/ggc-none.c): Change dependency
	for ggc.h into $(GGC_H).

2004-09-11  Mohan Embar  <gnustuff@thisiscool.com>

	* Make-lang.in (java/win32-host.o): Add dependency on
	coretypes.h.
	* win32-host.c: Add includes for coretypes.h, jcf.h

2004-09-11  Mohan Embar  <gnustuff@thisiscool.com>

	* Make-lang.in (GCJH_OBJS): Change dependency from
	ggc-none.o to java/ggc-none.o
	(JCFDUMP_OBJS): Likewise.
	(java/ggc-none.o): New target.

2004-08-25  Nathan Sidwell  <nathan@codesourcery.com>

	* boehm.c (get_boehm_type_descriptor):  Adjust build_int_cst calls.
	* class.c (build_utf8_ref, build_static_field_ref,
	make_field_value, make_method_value, get_dispatch_table,
	make_class_data, emit_symbol_table, emit_catch_table): Likewise.
	* constants.c (get_tag_node, build_ref_from_constant_pool,
	build_constants_constructor): Likewise.
	* decl.c (java_init_decl_processing): Likewise.
	* expr.c (build_java_array_length_access, build_newarray,
	expand_java_multianewarray, expand_java_pushc, expand_iinc,
	build_java_binop, build_field_ref, expand_java_add_case,
	expand_java_call, build_known_method_ref, build_invokevirtual,
	build_invokeinterface, build_jni_stub): Likewise.
	* java-gimplify.c (java_gimplify_new_array_init): Likewise.
	* jcf-parse.c (get_constant): Likewise.
	* lex.c (do_java_lex): Likewise.
	* parse.y (patch_binop, patch_unaryop, patch_cast,
	build_newarray_node, patch_newarray): Likewise.
	* resource.c (compile_resource_data): Likewise.
	* typeck.c (build_prim_array_type): Likewise.

2004-08-24  Nathan Sidwell  <nathan@codesourcery.com>

	* decl.c (java_init_decl_processing): Adjust
	initialize_sizetypes call.

2004-08-23  Nathan Sidwell  <nathan@codesourcery.com>

	* jv-scan.c (fancy_abort): Add.

2004-08-20  Nathan Sidwell  <nathan@codesourcery.com>

	* expr.c (build_java_arrayaccess): Use convert to change
	len's type.

2004-08-19  Bryce McKinlay  <mckinlay@redhat.com>

	* class.c (make_local_function_alias): Allocate extra space for 'L'
	in name buffer. Reported by Thomas Neumann.

2004-08-19  Nathan Sidwell  <nathan@codesourcery.com>

	* parse.h (JAVA_RADIX10_FLAG): Rename to ...
	(JAVA_NOT_RADIX10_FLAG): ... here.  Invert meaning.
	* lex.c (do_java_lex): Adjust.
	(error_if_numeric_overflow): Likewise.

2004-08-18  Andrew Pinski  <apinski@apple.com>

	* class.c (make_local_function_alias): Only make a new decl if we
	support alias attribute on all decls.

2004-08-18  Bryce McKinlay  <mckinlay@redhat.com>

	* class.c (make_local_function_alias): New function. Create local
	alias for public method DECL.
	(make_method_value): Use make_local_function_alias.
	* parse.y (craft_constructor): Don't special-case anonymous classes.
	Always set ctor_name to init_identifier_node.
	(lookup_method_invoke): Call layout_class_method when creating
	anonymous class constructor.

2004-08-18  Richard Henderson  <rth@redhat.com>

	* java-gimplify.c (java_gimplify_expr): Move '2' handling into
	default case.  Treat '<' similarly.  Update for
	is_gimple_formal_tmp_var name change.

2004-08-17  Andrew Haley  <aph@redhat.com>

	* lang.c (lang_printable_name): Obey verbose flag.
	* parse.y (constructor_circularity_msg): Set VERBOSE arg for
	lang_printable_name().
	(verify_constructor_circularity, get_printable_method_name,
	check_abstract_method_definitions, java_check_regular_methods,
	java_check_abstract_methods, check_inner_class_access,
	fix_constructors, patch_method_invocation, patch_return):
	Likewise.
	* expr.c (pop_type_0): Likewise.

	* java-tree.h (lang_printable_name_wls): Delete.

2004-08-16  Tom Tromey  <tromey@redhat.com>

	PR java/8473:
	* parse.y (primary): Changed for initialized and uninitialized
	array creations.
	(array_access): Handle array_creation_initialized.
	(array_creation_expression): Split into
	array_creation_initialized and array_creation_uninitialized.

2004-08-16  Andrew Haley  <aph@redhat.com>

	* jcf-write.c (find_constant_index): Canonicalize NaNs when
	generating bytecode.

2004-08-16  Elliot Lee <sopwith@redhat.com>

	PR java/9677
	* jcf-parse.c (java_parse_file): Handle filenames with embedded
	spaces, and quoted filelists.

2004-08-15  Nathan Sidwell  <nathan@codesourcery.com>

	* boehm.c (get_boehm_type_descriptor): Use build_int_cst.
	* class.c (build_utf8_ref, build_static_field_ref,
	make_field_value, make_method_value, get_dispatch_table,
	make_class_data, emit_symbol_table, emit_catch_table): Likewise.
	* constants.c (get_tag_node,  build_ref_from_constant_pool,
	build_constants_constructor): Likewise.
	* decl.c (java_init_decl_processing): Likewise.
	* expr.c (build_java_array_length_access, build_newarray,
	expand_java_multianewarray, expand_java_pushc, expand_iinc,
	build_java_binop, build_field_ref, expand_java_add_case,
	expand_java_call, build_known_method_ref, build_invokevirtual,
	build_invokeinterface, build_jni_stub): Likewise.
	* java-gimplify.c (java_gimplify_new_array_init): Likewise.
	* jcf-parse.c (get_constant): Likewise.
	* lex.c (do_java_lex): Likewise.
	* parse.y (patch_binop, patch_unaryop, patch_cast,
	build_null_of_type, patch_newarray): Likewise.
	* resource.c (compile_resource_data): Likewise.
	* typeck.c (build_prim_array_type): Likewise.

2004-08-10  Bryce McKinlay  <mckinlay@redhat.com>

	* java-gimplify.c (java_gimplify_new_array_init): Use create_tmp_var.
	Don't create BLOCK here or call java_gimplify_block.

2004-08-09  H.J. Lu  <hongjiu.lu@intel.com>

	* java-tree.h (flag_deprecated): Removed.
	* lang.opt (Wdeprecated): Use existing Var(warn_deprecated).
	* parse.y (check_deprecation): Check warn_deprecated instead of
	flag_deprecated.

2004-08-06  Kelley Cook  <kcook@gcc.gnu.org>

	* lang.c (flag_emit_class_files, flag_filelist_file, flag_redundant,
	flag_use_divide_subroutine, flag_use_boehm_gc, flag_store_check,
	flag_hash_synchronization, flag_assert, flag_jni, flag_newer,
	flag_check_references, flag_extraneous_semicolon, flag_deprecated,
	flag_force_classes_archive_check, flag_optimize_sci,
	flag_indirect_dispatch): Remove explicit declarations.
	* lang.opt: Add implicit declare/define/assign.  Remove obsolete
	final comment.

2004-08-05  Michael Chastain  <mec.gnu@mindspring.com>

	PR bootstrap/14893
	* Make-lang.in (java.install-man): Install from either build
	tree or source tree, whichever has the file first.

2004-08-05  Nathan Sidwell  <nathan@codesourcery.com>

	* jcf-parse.c (get_constant): Adjust force_fit_type call.
	* lex.h (SET_LVAL_NODE_TYPE): Remove.
	* lex.c (java_perform_atof): Use SET_LVAL_NODE directly.
	(do_java_lex): Likewise. Adjust force_fit_type call.

2004-08-04  Roger Sayle  <roger@eyesopen.com>
	    Andrew Haley  <aph@redhat.com>

	* typeck.c (convert_ieee_real_to_integer): Call fold on the range
	checking trees as they're being built.
	(convert): Call convert_ieee_real_to_integer if we're
	converting a constant, even if we're writing a class file.

2004-08-02  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/16701
	* parse.y (fold_constant_for_init): Call resolve_field_access with
	correct current_class context.

2004-08-01  Roger Sayle  <roger@eyesopen.com>

	* decl.c (update_aliases, initialize_local_variable): Replace calls
	to build with calls to buildN.
	* java-gimplify.c (java_gimplify_modify_expr): Likewise.
	* java-tree.h (BUILD_MONITOR_ENTER, BUILD_MONITOR_EXIT): Likewise.
	* parse.h (BUILD_THROW): Likewise.
	* parse.y (switch_expression, synchronized_statement,
	catch_clause_parameter, array_creation_expression,
	conditional_expression, make_qualified_name,
	resolve_qualified_expression_name, patch_method_invocation,
	patch_invoke, build_method_invocation, build_new_invocation,
	build_assignment, patch_assignment, build_binop, patch_binop,
	build_string_concatenation, build_incdec, patch_unaryop,
	patch_cast, build_array_ref, build_newarray_node, patch_newarray,
	patch_return, build_if_else_statement, build_labeled_block,
	build_new_loop, build_loop_body, build_bc_statement,
	build_assertion, encapsulate_with_try_catch, build_try_statement,
	build_try_finally_statement, patch_synchronized_statement,
	emit_test_initialization): Likewise, replace build with buildN.

2004-07-28  Eric Christopher  <echristo@redhat.com>

	* lang.c (LANG_HOOKS_UNSAFE_FOR_REEVAL): Delete.
	(java_unsafe_for_reeval): Ditto.

2004-07-26    <hp@bitrange.com>

	* parse.y (build_super_invocation): Adjust declaration order to
	avoid declaration after statement.

2004-07-25  Bernardo Innocenti  <bernie@develer.com>

	* decl.c: Rename all identifiers named `class' to `cl'.

2004-07-25  Richard Henderson  <rth@redhat.com>

	* decl.c (build_result_decl): Set DECL_ARTIFICIAL and DECL_IGNORED_P.

2004-07-23  Mike Stump  <mrs@apple.com>

	* boehm.c (set_bit): Improve type safety wrt unsignedness.
	* gjavah.c (throwable_p, decode_signature_piece,
	print_full_cxx_name, print_include, add_namelet, add_class_decl,
	process_file): Likewise.
	* jcf-dump.c (main): Likewise.
	* jcf-io.c (read_zip_member): Likewise.
	* jcf-parse.c (HANDLE_CONSTANT_Utf8, get_constant,
	give_name_to_class, get_class_constant): Likewise.
	* jcf-write.c (find_constant_wide, push_long_const,
	generate_classfile): Likewise.
	* lex.c (java_new_lexer, java_read_char, cxx_keyword_p): Likewise.
	* parse.y (read_import_dir): Likewise.
	* typeck.c (parse_signature_type): Likewise.
	* verify.c (verify_jvm_instructions): Likewise.
	* zextract.c (find_zip_file_start, read_zip_archive): Likewise.

2004-07-23  Thomas Fitzsimmons  <fitzsim@redhat.com>

	* Make-lang.in: Replace rmic and rmiregistry references with
	grmic and grmiregistry.
	* gcj.texi: Likewise.

2004-07-20  Andrew Haley  <aph@redhat.com>

	PR java/16431.
	* verify.c (verify_jvm_instructions): Comment change only.

	* typeck.c (build_java_array_type): Add size field to array name.

	* java-tree.h (LOCAL_SLOT_P): New.
	(update_aliases): Add PC argument.
	(pushdecl_function_level): New function.

	* java-gimplify.c (java_gimplify_expr): Handle VAR_DECL,
	MODIFY_EXPR, and SAVE_EXPR.
	(java_gimplify_modify_expr): New function.

	* expr.c (push_type_0): Call find_stack_slot() to create temporary.
	(expand_iinc): Pass PC to update_aliases().
	(STORE_INTERNAL): Likewise.
	(process_jvm_instruction): Likewise.

	* decl.c (base_decl_map): New variable.
	(uniq): New variable.
	(update_aliases): Rewrite with more thorough checking.
	(debug_variable_p): New function.
	(push_jvm_slot): Don't initialize local variable.  Don't pushdecl.
	(check_local_named_variable): Delete whole function.
	(initialize_local_variable): New function.
	(check_local_unnamed_variable): Add checks and comments.
	(find_local_variable): Rewrite.
	(java_replace_reference): New function.
	(function_binding_level): New variable.
	(pushdecl_function_level): New function.
	(maybe_pushlevels): Set DECL_LOCAL_END_PC.
	(maybe_pushlevels): Call pushdecl() on each of the new decls.
	(start_java_method): Reset uniq.  Create base_decl_map.  Set
	function_binding_level.
	(end_java_method): Null unused fields to save memory.

2004-07-20  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (add_interface_do): Remove.
	(set_super_info, interface_of_p, maybe_add_interface,
	add_interface, make_class_data, layout_class,
	add_miranda_methods): Adjust BINFO accessors and addition.
	* expr.c (can_widen_reference_to, lookup_field): Adjust BINFO
	accessors.
	* jcf-write.c (generate_classfile): Likewise.
	* parse.y (patch_anonymous_class, check_inner_circular_reference,
	check_circular_reference, java_complete_class,
	check_abstract_method_definitions,
	java_check_abstract_method_definitions,
	check_interface_throws_clauses, java_check_abstract_methods,
	lookup_java_interface_method2,
	find_applicable_accessible_methods_list): Adjust BINFO accessors
	and addition.
	* typeck.c (find_method_in_interfaces): Adjust BINFO accessors.

2004-07-18  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (max_builtin, min_builtin,
	java_build_function_call_expr): Replace calls to build with buildN.
	* class.c (build_class_ref, build_static_field_ref,
	get_dispatch_table, make_class_data, layout_class_method): Likewise.
	* constants.c (build_ref_from_constant_pool): Likewise.
	* decl.c (update_aliases, push_jvm_slot, poplevel, finish_method,
	add_stmt_to_compound): Likewise.
	* except.c (build_exception_object_ref, expand_end_java_handler):
	Likewise.
	* java-gimplify.c (java_gimplify_case_expr,
	java_gimplify_default_expr, java_gimplify_block,
	java_gimplify_new_array_init, java_gimplify_try_expr): Likewise.
	* jcf-write.c (generate_bytecode_insns): Likewise.
	* typeck.c (convert_ieee_real_to_integer): Likewise.

2004-07-17  Joseph S. Myers  <jsm@polyomino.org.uk>

	* java-tree.h (builtin_function): Declare.

2004-07-16  Steven Bosscher  <stevenb@suse.de>

	* parse.y (java_complete_expand_methods, java_expand_classes): Don't
	abuse restore_line_number_status.

2004-07-15  Frank Ch. Eigler  <fche@redhat.com>

	g++/15861
	* jcf-parse.c (java_emit_static_constructor): Specify default
	priority.

2004-07-13  Per Bothner  <per@bothner.com>

	* java-tree.h (all_class_filename):  Remove useless macro.
	(enum java_tree_index):  Remove JTI_ALL_CLASS_FILENAME constant.
	(BUILD_FILENAME_IDENTIFIER_NODE):  Remove useless macro.
	* parse.y (java_parser_context_restore_global):  Replace
	BUILD_FILENAME_IDENTIFIER_NODE by plain get_identifier.
	* jcf-parse.c (read_class, java_parse_file):  Likewise.

2004-07-12  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/16474
	gjavah.c (print_field_info): Emit constant only if field is static.

2004-07-11  Roger Sayle  <roger@eyesopen.com>

	* expr.c (java_truthvalue_conversion, flush_quick_stack,
	java_stack_swap, java_stack_dup, build_java_athrow, build_java_jsr,
	build_java_ret, build_java_throw_out_of_bounds_exception,
	build_java_array_length_access, java_check_reference,
	build_java_arrayaccess, build_java_arraystore_check, build_newarray,
	build_anewarray, expand_java_multianewarray, expand_java_arraystore,
	expand_java_arrayload, build_java_monitor, expand_java_return,
	expand_load_internal, expand_java_NEW, build_get_class,
	build_instanceof, expand_java_CHECKCAST, expand_iinc,
	build_java_soft_divmod, build_java_binop, build_field_ref,
	expand_compare, expand_java_goto, expand_java_switch,
	expand_java_add_case, build_class_init, build_known_method_ref,
	invoke_build_dtable, build_invokevirtual, build_invokeinterface,
	expand_invoke, build_jni_stub, expand_java_field_op,
	java_expand_expr, expand_byte_code, STORE_INTERNAL,
	force_evaluation_order, emit_init_test_initialization): Convert
	calls to "build" into calls to the prefered "buildN" functions.

2004-07-11  Joseph S. Myers  <jsm@polyomino.org.uk>

	* java-tree.h (set_block): Remove.
	* lang.c (java_clear_binding_stack): New.
	(LANG_HOOKS_CLEAR_BINDING_STACK): Define.
	* decl.c (struct binding_level): Remove this_block.
	(clear_binding_level): Likewise.
	(poplevel): Don't handle this_block.
	(set_block): Remove.

2004-07-10  Bryce McKinlay  <mckinlay@redhat.com>

	* class.c (common_enclosing_context_p): Remove statement with no
	side-effects.

2004-07-09  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/8618
	* parse.y (create_anonymous_class): Remove 'location' argument. Use
	the WFL from TYPE_NAME to get line number for the decl. Fix comment.
	(craft_constructor): Inherit access flags for implicit constructor
	from the enclosing class.
	(create_class): Fix comment typo.
	(resolve_qualified_expression_name): Pass type of qualifier to
	not_accessible_p, not the type in which target field was found.
	(not_accessible_p): Handle inner classes. Expand protected
	qualifier-subtype check to enclosing instances, but don't apply this
	check to static members. Allow protected access to inner classes
	of a subtype. Allow private access within common enclosing context.
	(build_super_invocation): Get WFL line number info from current
	class decl.
	(build_incomplete_class_ref): Update for new create_anonymous_class
	signature.
	* parse.h (INNER_ENCLOSING_SCOPE_CHECK): Use
	common_enclosing_instance_p.
	* class.c (common_enclosing_context_p): New. Determine if types
	share a common enclosing context, even across static contexts.
	(common_enclosing_instance_p): Renamed from
	common_enclosing_context_p. Determines if types share a common
	non-static enclosing instance.
	* java-tree.h (common_enclosing_instance_p): Declare.
	* jcf-write.c (get_method_access_flags): New. Surpress private flag
	for inner class constructors.
	(generate_classfile): Use get_method_access_flags.

2004-07-09  Bryce McKinlay  <mckinlay@redhat.com>

	* class.c (interface_of_p): Check for null TYPE_BINFO.

2004-07-09  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (make_class): Do not create binfo here.
	(set_super_info): Create it here.
	* java-tree.h (CLASS_HAS_SUPER): Cope with lack of a binfo.

2004-07-08  Richard Henderson  <rth@redhat.com>

	* expr.c (case_identity, get_primitive_array_vtable,
	java_expand_expr, emit_init_test_initialization): Remove.
	* java-tree.h (java_expand_expr): Remove.
	* lang.c (LANG_HOOKS_EXPAND_EXPR): Remove.

2004-07-07  Per Bothner  <per@bothner.com>

	* class.c (build_static_field_ref):  Add a NOP_EXPR; otherwise we
	get internal error due to mismatched types.

	* gcj.texi (Invoking gij):  Document new -verbose:class flag.

	* gcj.texi (Linking):   New node.  Document -lgij usage.

2004-07-07  Nathan Sidwell  <nathan@codesourcery.com>

	* java-tree.h (CLASSTYPE_SPUER): Adjust BINFO macros.
	(TYPE_NVIRTUALS, TYPE_VTABLE): Likewise.
	* java/class.c (set_super_info, class_depth, interface_of_p,
	maybe_add_interface, add_interface, make_class_data,
	layout_class, add_miranda_methods): Adjust BINFO macros.
	* expr.c (can_widen_reference_to, lookup_field): Likewise.
	* jcf-write.c (generate_classfile): Likewise.
	* parse.y (patch_anonymous_class,
	check_inner_circular_reference, check_circular_reference,
	java_complete_class, check_abstract_method_definitions,
	java_check_abstract_method_definitions,
	check_interface_throws_clauses, java_check_abstract_methods,
	lookup_java_interface_method2,
	find_applicable_accessible_methods_list): Likewise.
	* typeck.c (find_method_in_interface): Likewise.
	* verify.c (merge_types): Likewise.

2004-07-06  Nathan Sidwell  <nathan@codesourcery.com>

	* java-tree.h (CLASS_HAS_SUPER_FLAG): Use BINFO_FLAG_1.
	* class.c (add_interface_do): Use BINFO_VIRTUAL_P.

2004-07-05  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (make_class): Use make_tree_binfo.
	(set_super_info, add_interface_do): Likewise.
	* java-tree.h (CLASS_HAS_SUPER_FLAG): Expect a BINFO.

2004-07-04  Ranjit Mathew  <rmathew@hotmail.com>

	* verify.c: Correct array element access formatting thinko.

2004-07-04  Ranjit Mathew  <rmathew@hotmail.com>

	* verify.c: Insert a short blurb at the start referring to the JVMS.
	(merge_type_state): Remove redundant nested if statement.
	(verify_jvm_instructions): Ensure current_subr is initialised to
	NULL_TREE.
	Minor formatting fixes all over the place.

2004-07-02  Richard Henderson  <rth@redhat.com>

	* jcf-write.c (generate_bytecode_insns <case SAVE_EXPR>): Rewrite.

2004-07-01  Richard Henderson  <rth@redhat.com>

	* class.c (registerClass_libfunc): Remove.
	(init_class_processing): Don't set it.
	(emit_register_classes): Take list_p parameter.  Fill it in
	with _Jv_RegisterClass calls.
	* decl.c (java_init_decl_processing): Don't call
	init_resource_processing.
	* jcf-parse.c (java_emit_static_constructor): New.
	(java_parse_file): Call it.
	* resource.c (registerResource_libfunc): Remove.
	(init_resource_processing): Remove.
	(write_resource_constructor): Take list_p parameter.  Fill it in
	with _Jv_RegisterResource calls.
	* java-tree.h: Update prototypes.

2004-06-29  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/1262
	* class.c (layout_class_method): Do not override package-private
	method if its in a different package.
	(split_qualified_name): Move here from parse.y. Rename from
	breakdown_qualified. Add comment.
	(in_same_package): Move here from parse.y. Add comment.
	* java-tree.h (break_down_qualified, in_same_package): Declare.
	(in_same_package): Likewise.
	* parse.y (breakdown_qualified, in_same_package): Moved to class.c.
	Callers updated.

2004-06-29  Andrew Haley  <aph@redhat.com>

	* except.c (expand_start_java_handler): Push a new binding level.
	Don't build a TRY_CATCH_EXPR now, we'll do it later.  Call
	register_exception_range() to register where we'll do it.
	(expand_end_java_handler): Remove old bogus code.  Replace with
	new logic that simply builds TRY_CATCH_EXPRs and inserts them at
	the top of the expression we're curently building.
	(maybe_end_try): Delete.
	* decl.c (binding_level.exception_range): New field.
	(clear_binding_level): Add field exception_range.  Reformat.
	(poplevel): Call expand_end_java_handler().
	(poplevel): Call java_add_stmt only if functionbody is false.
	(maybe_poplevels): Don't call maybe_end_try() from here.
	(end_java_method): Clear no longer used trees in function decl.
	(register_exception_range): New function.
	* java-tree.h (register_exception_range, struct eh_range): Declare.

2004-06-28  Bryce McKinlay  <mckinlay@redhat.com>

	* jcf-write.c (get_classfile_modifiers): Formatting fixes.

2004-06-27  Ranjit Mathew  <rmathew@hotmail.com>

	Formatting fixes.
	* expr.c (class_has_finalize_method): Fix method name indentation.
	(expand_java_call): Remove K&R style parameter declaration.
	(expand_invoke): Fix statement indentation.
	(expand_java_field_op): Likewise.
	* parse-scan.y: Fix typo.
	(reset_report): Fix method name indentation.
	* parse.y (unresolved_type_p, build_expr_block): Remove extra blank
	line. Fix typos.
	* verify.c (verify_jvm_instructions): Document parameters, insert
	page break.
	* lang.c (lang_init_source): Fix method name indentation.
	* class.c (common_enclosing_context_p): Likewise.
	(emit_symbol_table): Fix parameter list indentation.
	* decl.c (add_stmt_to_compound, java_add_stmt): Remove K&R style
	parameter declaration.
	* constants.c: Fix copyright notice indentation.
	* typeck.c (find_method_in_superclasses): Fix parameter list
	indentation.
	(find_method_in_interfaces): Likewise.
	* zextract.c (makelong): Fix method name indentation.

2004-06-26  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/15715.
	* parse.y (create_interface): Set correct access modifiers for
	interfaces.
	* jcf-write.c (get_classfile_modifiers): New function.
	(generate_classfile): Use get_classfile_modifiers, not
	get_access_flags.

2004-06-26  Bryce McKinlay  <mckinlay@redhat.com>

	* parse.y (register_incomplete_type): Set JDEP_ENCLOSING for "super"
	dependency to current parser context, not NULL_TREE, for top-level
	classes.
	(jdep_resolve_class): Enable member access check for all inner
	class dependencies.

2004-06-26  Bryce McKinlay  <mckinlay@redhat.com>

	* parse.y (qualify_and_find): Pass type decl, not identifier, to
	load_class.

2004-06-26  Bryce McKinlay  <mckinlay@redhat.com>

	PR java/15734
	* expr.c (expand_java_field_op): Ensure that target class for static
	field access has been loaded.

2004-06-26  Bryce McKinlay  <mckinlay@redhat.com>
	    Ranjit Mathew  <rmathew@hotmail.com>

	PR java/1207, java/16178
	* jcf-parse.c (load_class): Return immediately if passed a type decl
	where CLASS_FROM_SOURCE_P is set. Remove FIXME.
	* parse.y (do_resolve_class): Remove checks for CLASS_FROM_SOURCE_P
	before calling load_class.
	(qualify_and_find): Likewise.
	(find_in_imports_on_demand): Likewise.
	(find_applicable_accessible_methods_list): Likewise.

2004-06-24  Bryce McKinlay  <mckinlay@redhat.com>

	* parse.y (java_layout_seen_class_methods): Don't call load_class
	on class defined by source parser.

2004-06-23  Bryce McKinlay  <mckinlay@redhat.com>

	* parse.y (set_nested_class_simple_name_value): Removed.
	(java_complete_expand_class): Remove calls to
	set_nested_class_simple_name_value.

2004-06-22  Andrew Haley  <aph@redhat.com>
	    Ranjit Mathew  <rmathew@hotmail.com>

	Fixes PR java/16113.
	* decl.c (force_poplevels): Remove call to expand_end_bindings.

2004-06-22  Ranjit Mathew  <rmathew@hotmail.com>

	* parse.y (create_class): Correct diagnostic message about
	java.lang.Object extending anything else.

2004-06-21  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* class.c (build_class_ref): Add new operand for COMPONENT_REF.
	(build_static_field_ref): Likewise and add new operands for ARRAY_REF.
	* constants.c (build_ref_from_constant_pool): Likewise.
	* expr.c (build_java_array_length_access): Likewise.
	(build_get_class, build_field_ref, build_known_method_ref): Likewise.
	(invoke_build_dtable, build_invokevirtual): Likewise.
	(build_invokeinterface, java_expand_expr): Likewise.
	(emit_init_test_initialization): Likewise.
	* java-gimplify.c (java_gimplify_new_array_init): Likewise.
	* parse.y (make_qualifed_name, build_array_ref): Likewise.

2004-06-21  Andrew Haley  <aph@redhat.com>

	* java-gimplify.c (java_gimplify_block): set TREE_USED on the new
	block.

2004-06-21  Joseph S. Myers  <jsm@polyomino.org.uk>

	* jcf.h (struct JCF): Change java_source, right_zip and finished
	to unsigned int.
	* lex.h (struct java_lexer): Change hit_eof, read_anything,
	byte_swap and use_fallback to unsigned int.
	* parse.h (struct _jdep): Change flag0 to unsigned int.

2004-06-17  Ranjit Mathew  <rmathew@hotmail.com>

	Fixes PR java/13948
	* parse.y (java_layout_seen_class_methods): Ensure class is loaded
	before trying to lay out its methods.
	* jcf-parse.c (read_class): Track parsed files using canonical paths
	obtained via lrealpath from libiberty.
	(java_parse_file): Likewise.
	(parse_source_file_1): Rename formal parameter to reflect its
	modified purpose. Minor formatting fix.

2004-06-15  Paolo Bonzini  <bonzini@gnu.org>

	* class.c (emit_register_classes): Make the function uninlinable,
	do not set current_function_cannot_inline.
	* resource.c (write_resource_constructor): Do not reset
	flag_inline_functions around rest_of_compilation.

2004-06-08  Andrew Pinski  <pinskia@physics.uc.edu>

	PR java/15769
	* expr.c (java_truthvalue_conversion): Handle
	UNEQ_EXPR, UNLE_EXPR, UNGE_EXPR, UNLT_EXPR, UNGT_EXPR,
	ORDERED_EXPR, and UNORDERED_EXPR as comparison operators,
	i.e. return the expression.

2004-06-03 Mark G. Adams  <mark.g.adams@sympatico.ca>

	* gjavah.c: Include version.h

2004-05-31  Bryce McKinlay  <mckinlay@redhat.com>

	* jcf-write.c (generate_bytecode_conditional): Correct handling
	of unordered conditionals. Add comment.

2004-05-29  Ranjit Mathew  <rmathew@hotmail.com>
	    Per Bothner  <per@bothner.com>

	* java-tree.h (DECL_LOCAL_FINAL_IUD): New macro to test if a
	local variable was initialised upon declaration.
	* parse.y (declare_local_variables): Set DECL_LOCAL_FINAL_IUD if
	variable was final and initialised upon declaration.
	* check-init.c (check_final_reassigned): Give error only if a blank
	final is not definitely unassigned or if an initialised final is
	reassigned.
	(check_bool_init): Respect JLS2 16.1.7 requirements for boolean
	assignment expressions. Remove case MODIFY_EXPR, label do_default.
	(check_init): Perform initialised-variable-removing-optimisation
	only on non-final local variables.

2004-05-28  Bryce McKinlay  <mckinlay@redhat.com>

	* jcf-write.c (generate_bytecode_conditional): Handle binops
	UNLT_EXPR, UNLE_EXPR, UNGT_EXPR, UNGE_EXPR, UNEQ_EXPR,
	and LTGT_EXPR.
	(generate_bytecode_insns): Likewise.

2004-05-28  Bryce McKinlay  <mckinlay@redhat.com>

	* check-init.c (check_init): Handle binops UNLT_EXPR, UNLE_EXPR,
	UNGT_EXPR, UNGE_EXPR, UNEQ_EXPR, and LTGT_EXPR.

2004-05-28  Bryce McKinlay  <mckinlay@redhat.com>

	* gcj.texi (Object allocation): Remove _Jv_AllocBytes.
	(Mixing with C++): Document JvAllocBytes and RawDataManaged.

2004-05-26  Bryce McKinlay  <mckinlay@redhat.com>

	* decl.c (struct binding_level): Add GTY marker. Compile
	binding_depth unconditionally.
	(current_binding_level, free_binding_level, global_binding_level):
	Likewise.
	(clear_binding_level): Unconditionally set binding_depth.
	(make_binding_level): Use ggc_alloc_cleared, not xmalloc.

2004-05-26  Bryce McKinlay  <mckinlay@redhat.com>

	* lex.c (java_new_lexer): Set 'encoding'.
	(java_read_char): Improve error message for unrecognized characters.
	* lex.h (struct java_lexer): New field 'encoding'.

2004-05-23  Paolo Bonzini  <bonzini@gnu.org>

	* Make-lang.in: Link in $(LIBCPP) instead of mkdeps.o.

2004-05-21  Mark Wielaard  <mark@klomp.org>

	* gjavah.c (print_stub_or_jni): Mark functions only JNIEXPORT, not
	extern.

2004-05-19  Paolo Bonzini  <bonzini@gnu.org>

	* typeck.c: Remove non-printable character 160.

2004-05-17  Ranjit Mathew  <rmathew@hotmail.com>

	* check-init.c: Correct minor typos.

2004-05-13  Diego Novillo  <dnovillo@redhat.com>

	* Make-lang.in, expr.c, java-gimplify.c: Rename
	tree-simple.[ch] to tree-gimple.[ch].

2004-05-14  Ranjit Mathew  <rmathew@hotmail.com>

	* java-gimplify.c (java_gimplify_expr): Correct minor typos.

2004-05-13  Diego Novillo  <dnovillo@redhat.com>

	Merge from tree-ssa-20020619-branch.  See
	ChangeLog.tree-ssa for details.

	* Make-lang.in, builtins.c, check-init.c, class.c,
	constants.c, decl.c, except.c, expr.c, java-except.h,
	java-tree.def, java-tree.h, jcf-parse.c, jcf-write.c,
	lang.c, lang.opt, parse.y, resource.c: Merged.
	* java-gimplify.c: New file.

2004-05-10  Andrew Haley  <aph@redhat.com>

	* parse.y (create_class): Set TYPE_VFIELD.
	* decl.c (java_init_decl_processing): Likewise.

	* expr.c (build_invokevirtual): Remove DECL_VINDEX offset adjustment.
	* class.c (make_method_value): Replace DECL_VINDEX with call to
	get_method_index().
	(get_dispatch_vector): Likewise.
	(layout_class_method): Likewise.
	Replace set of DECL_VINDEX with call to set_method_index().
	(set_method_index): New function.
	(get_method_index): New function.
	* java-tree.h (set_method_index): New function decl.
	(get_method_index): New function decl.

2004-05-10  Andrew Pinski  <pinskia@physics.uc.edu>

	* parse.y (check_pkg_class_access): Add new argument
	and use it when cl is NULL to call lookup_cl on it.
	(parser_check_super_interface): Do not call lookup_cl.
	Pass this_decl to check_pkg_class_access and NULL
	instead of lookup_cl.
	(parser_check_super): Update for change in
	check_pkg_class_access.
	(do_resolve_class): Likewise.
	(process_imports): Likewise.
	(find_in_imports_on_demand): Likewise.
	(resolve_qualified_expression_name): Likewise.

2004-05-06  Ranjit Mathew  <rmathew@hotmail.com>

	Fixes PR java/9685, PR java/15073
	* parse.y (accessibility_string): New method.
	(not_accessible_field_error): Use accessibility_string()
	instead of java_accstring_lookup().
	(resolve_qualified_expression_name): Check with
	check_pkg_class_access() before allowing access using
	qualified names.
	Fix comment typo.
	Use check_pkg_class_access() instead of not_accessible_p()
	for unqualified types.
	(not_accessible_p): Use DECL_CONTEXT (member) instead of
	REFERENCE for package-private access checking.
	(patch_method_invocation): Use accessibility_string() instead
	of java_accstring_lookup().

2004-04-30  Ranjit Mathew  <rmathew@hotmail.com>

	Fixes PR java/15133
	* gjavah.c (struct method_name): Add member is_native.
	(overloaded_jni_method_exists_p): Match candidate method only if
	it is native.
	(print_method_info): Initialise is_native flag from the method's
	access flags.

2004-04-30  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (java_builtins): Add acos, asin, ceil and floor.
	(initialize_builtins): Likewise, define acos, asin, ceil and floor.

2004-04-22  Roger Sayle  <roger@eyesopen.com>

	* resource.c (write_resource_constructor): Guard call to possibly
	NULL targetm.asm_out.constructor with targetm.have_ctors_dtors.

2004-04-19  Bryce McKinlay  <mckinlay@redhat.com>

	* class.c (make_class_data): Add new field aux_info.
	* decl.c (java_init_decl_processing): Push type and decl for
	`aux_info'.

2004-04-15  Bryce McKinlay  <mckinlay@redhat.com>

	* expr.c (expand_java_NEW): Don't use size argument for
	_Jv_AllocObject calls.
	* parse.y (patch_invoke): Likewise.

2004-04-12  Bryce McKinlay  <mckinlay@redhat.com>

	* expr.c (build_invokeinterface): Remove unused variables to
	fix warnings.

2004-04-12  Bryce McKinlay  <mckinlay@redhat.com>

	* class.c (get_interface_method_index): New function. Return dispatch
	index for interface method.
	(make_method_value): For interface methods, set index field to
	iface dispatch index, not DECL_VINDEX.
	* expr.c (build_invokeinterface): Use get_interface_method_index.

2004-03-31  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* jcf-write.c (generate_bytecode_insns): Use TYPE_UNSIGNED.

2004-03-31  Andrew Haley  <aph@redhat.com>

	PR java/14104
	* jcf-io.c (opendir_in_zip): Tidy up error handling.

2004-03-30  Zack Weinberg  <zack@codesourcery.com>

	* builtins.c, expr.c, jcf.h, parse.h: Use new shorter
	form of GTY markers.

2004-03-25  Marcus Meissner  <meissner@suse.de>

	PR java/14689:
	* jcf-path.c (jcf_path_extdirs_arg): Add missing closedir.

2004-03-23  Tom Tromey  <tromey@redhat.com>

	PR java/14315:
	* jcf-write.c (make_class_file_name): Don't report if mkdir
	failed with EEXIST.

2004-03-23  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Extensions): Document GCJ_PROPERTIES.

2004-03-20  Kazu Hirata  <kazu@cs.umass.edu>

	* class.c, gjavah.c, lang.c: Fix comment typos.
	* gcj.texi: Fix typos.

2004-03-19  Per Bothner  <per@bothner.com>

	* gcj.texi (Code Generation):  Document new flags and assert defaults.

	* class.c (assume_compiled_node_struct):  Rename type to
	class_flag_node_struct, as it is now also used for enable_assertions.
	Rename assume_compiled_node typedef.  Rename excludep field to value.
	(find_assume_compiled_node):  Rename function to find_class_flag_node.
	Minor optimization - avoid needless strlen.
	(add_assume_compiled):  Some tweaking and optimization.
	Rename and generalize to add_class_flag takem an extra parameter.
	(add_assume_compled):  New just calls add_class_flag.
	(add_enable_assert, enable_assertions):  New functions.
	(enable_assert_tree):  New static.
	* java-tree.h (add_enable_assert, enable_assertions): New declarations.
	* lang.opt (fenable-assertions, fenable-assertions=,
	fdisable-assertions, fdisable-assertions=):  New options.
	* lang.c (java_handle_option):  Handle new options.
	* parse.y (build_incomplete_class_ref):  Handle class$ in an inner
	class in an interface - create helper class nested in outer interface.
	(build_assertion):  Short-circuit if enable_assertions is false.

2004-03-18  Richard Kenner <kenner@vlsi1.ultra.nyu.edu>

	* java-tree.h: Changes throughout to add checking to macros
	and numerous whitespace changes.
	(VAR_OR_FIELD_CHECK): New macro.
	* jcf-write.c (get_access_flags): Use FIELD_PUBLIC, METHOD_PUBLIC,
	FIELD_FINAL, and METHOD_FINAL instead of CLASS_PUBLIC and CLASS_FINAL.

2004-03-16  Per Bothner  <per@bothner.com>

	* jcf-jump.c (options):  New --print-constants option.
	* gcj.texi (Invoking jcf-dump):  Document --print-constants.

	* jcf-dump.c (flag_print_constant_pool):  Default to off.
	(print_constant_terse_with_index):  New helper function.
	(various places):  Check flag_print_constant_pool where missing.
	(main):  If verbose set flag_print_constant_pool.
	(HANDLE_INNERCLASSES_ATTRIBUTE):  Null inner class name is anonymous.

2004-03-15  Andrew Haley  <aph@redhat.com>

	PR java/14581
	* parse.y (java_complete_lhs): Check that final variable has an
	initializer.

2004-03-12  Andrew Haley  <aph@redhat.com>

	PR java/14551
	* typeck.c (convert): Clear TREE_OVERFLOW after an integer
	conversion.

2004-02-29  Roger Sayle  <roger@eyesopen.com>

	* jcf-parse.c (java_parse_file): Handle the case that input_filename
	is NULL.

2004-02-27  Per Bothner  <per@bothner.com>

	* parse.y (build_assertion):  Re-do 02-25 change following Jeff Sturm
	suggestion:  Use build_incomplete_class_ref.
	This fixes PR java/13508, java/11714.

2004-02-27  Kazu Hirata  <kazu@cs.umass.edu>

	* java/parse.h: Update copyright.

2004-02-26  Andrew Haley  <aph@redhat.com>

	PR java/14231:
	* parse.y (check_interface_throws_clauses): Check for
	!METHOD_INVISIBLE (iface_method).
	* class.c (layout_class_methods): Check for CLASS_INTERFACE as
	well as CLASS_ABSTRACT.

2004-02-25  Per Bothner  <per@bothner.com>

	* parse.y (build_assertion):  If we're in an inner class, create the
	class$ helper routine in the outer class.

2004-02-19  Richard Henderson  <rth@redhat.com>

	* parse.y (switch_label): Use make_node for DEFAULT_EXPR.

2004-02-16  Geoffrey Keating  <geoffk@apple.com>

	* Make-lang.in (java.install-man): Add extra dependencies.

2004-02-13  Geoffrey Keating  <geoffk@apple.com>

	* Make-lang.in: Install man pages under the same names
	(possibly transformed) as the program they document.

2004-02-10  Joseph S. Myers  <jsm@polyomino.org.uk>

	* gjavah.c: Include "intl.h".
	(error): New function.
	(main): Call gcc_init_libintl.
	(get_field_name, throwable_p, print_c_decl, print_full_cxx_name,
	print_stub_or_jni, process_file, main): Use error rather than
	fprintf.
	(print_method_info, usage, help, version, main): Mark strings for
	translation with _.  Avoid splitting up sentences.  Send
	information messages to stdout.
	* jcf-dump.c: Include "intl.h".
	(main): Call gcc_init_libintl.
	(process_class, usage, help, version, main, CHECK_PC_IN_RANGE):
	Mark error, usage and version messages for translation with _.
	Avoid splitting up sentences.
	* jv-scan.c: Include "intl.h".
	(fatal_error, warning): Change parameter s to msgid.  Translate
	messages.
	(main): Call gcc_init_libintl.
	(usage, help, version): Mark error, usage and version messages for
	translation with _.  Avoid splitting up sentences.
	* jvgenmain.c: Include "intl.h".
	(main): Call gcc_init_libintl.
	(usage, main): Mark error messages for translation with _.
	* Make-lang.in (GCJH_OBJS, JVSCAN_OBJS, JCFDUMP_OBJS,
	JVGENMAIN_OBJS): Add intl.o.
	(java/jcf-dump.o, java/gjavah.o, java/jv-scan.o,
	java/jvgenmain.o): Update dependencies.

2004-02-08  Per Bothner  <per@bothner.com>

	* parse.y (resolve_qualified_expression_name):  In case of inaccessible
	class don't use not_accessible_field_error, which can get confused.

2004-02-05  Kelley Cook  <kcook@gcc.gnu.org>

	Make-lang.in (po-generated):  Delete.

2004-02-05  Kazu Hirata  <kazu@cs.umass.edu>

	* Make-lang.in (java/decl.o, java/expr.o, java/parse.o):
	Depend on target.h.
	* decl.c: Include target.h.
	(start_java_method): Replace PROMOTE_PROTOTYPES with
	targetm.calls.promote_prototypes.
	* expr.c: Include target.h.
	(pop_arguments): Replace PROMOTE_PROTOTYPES with
	targetm.calls.promote_prototypes.
	* parse.y: Include target.h.
	(start_complete_expand_method): Replace PROMOTE_PROTOTYPES
	with targetm.calls.promote_prototypes.

2004-02-04  Kazu Hirata  <kazu@cs.umass.edu>

	* typeck.c: Update copyright.

2004-02-02  Tom Tromey  <tromey@redhat.com>

	* decl.c (java_init_decl_processing): Remove duplicate
	gnu/gcj/RawData.

2004-01-30  Kelley Cook  <kcook@gcc.gnu.org>

	* Make-lang.in (doc/gcj.dvi): Use $(abs_docdir).

2004-01-28  Andrew Pinski  <pinskia@physics.uc.edu>

	* expr.c (build_field_ref): Move variable
	definition up.

2004-01-28  Andrew Haley  <aph@redhat.com>

	* expr.c (build_field_ref): Widen field offset.

2004-01-27  Andrew Haley  <aph@redhat.com>

	java/13273
	* parse.y (check_interface_throws_clauses): Make sure class_decl
	has been loaded.

2004-01-22  Jeff Sturm  <jsturm@one-point.com>

	PR java/13733
	* parse.y (patch_assignment): Don't modify lhs_type for
	reference assignments.

2004-01-20  Kelley Cook  <kcook@gcc.gnu.org>

	* Make-lang.in: Replace $(docdir) with doc.
	(java.info, java.srcinfo, java.man, java.srcman): New rules.
	(java.install-man): Revamp rule.

2004-01-20  Kelley Cook  <kcook@gcc.gnu.org>

	* Make-lang.in (JAVA_INSTALL_NAME, JAVA_TARGET_INSTALL_NAME,
	GCJH_TARGET_INSTALL_NAME): Define via a immediate $(shell)
	instead of deferred backquote.

2004-01-16  Andrew Pinski  <pinskia@physics.uc.edu>

	* typeck.c (find_method_in_interfaces): Move variable
	definition up.

2004-01-16  Andrew Haley  <aph@redhat.com>

	PR java/13273:
	* typeck.c (shallow_find_method): New.
	(find_method_in_superclasses): New.
	(find_method_in_interfaces): New.
	(lookup_do): Rewrite.
	* java-tree.h (SEARCH_ONLY_INTERFACE): Delete.

	* jcf-parse.c (read_class): Save and restore output_class.
	* decl.c (java_expand_body): Set output_class from fndecl.

2004-01-15  Michael Chastain  <mec.gnu@mindspring.com>

	* class.c (gen_indirect_dispatch_tables): Fix string length
	calculations.

2004-01-15  Kelley Cook  <kcook@gcc.gnu.org>

	* Make-lang.in (parse.c, parse-scan.c): Always build in doc directory.
	(java.srcextra): Copy above back to source directory if requested.
	(po-generated): Delete reference to $(parsedir).
	(java/parse.o, java/parse-scan.o): Delete reference to $(parsedir).
	Use implicit rule.

2004-01-14  Jan Hubicka  <jh@suse.cz>

	* lang.c (java_estimate_num_insns_1): Fix bug in MODIFY_EXPR cost
	estimation.

2004-01-09  Mark Mitchell  <mark@codesourcery.com>

	* java-tree.h (java_expand_expr): Change prototype.
	* expr.c (java_expand_expr): Add alt_rtl parameter.

2004-01-09  Andrew Haley  <aph@redhat.com>

	PR java/12755:
	* parse.y (java_fix_constructors):  Set output_class.
	(java_reorder_fields): Likewise.
	(java_layout_classes): Likewise.
	(java_expand_classes): Generate indirect dispatch tables.
	(java_expand_classes): Set output_class.
	(java_finish_classes): Likewise.
	* lang.c (java_init): Turn on always_initialize_class_p if we're
	using indirect dis[atch.
	(java_decl_ok_for_sibcall): Use output_class, not current_class.
	(java_get_callee_fndecl): Use class local atable.
	* jcf-parse.c
	(always_initialize_class_p): Decl moved to java-tree.h.
	(HANDLE_CLASS_INFO): Set output_class.
	(read_class): Likewise.
	(parse_class_file): Call gen_indirect_dispatch_tables.
	(parse_zip_file_entries): Set output_class.
	(java_parse_file): Set output_class.  Don't emit symbol tables.
	* java-tree.h (output_class): New.
	Remove global declarations for otable, atable, and ctable.
	(always_initialize_class_p): moved here from decl.c.
	(DECL_OWNER): New.
	(TYPE_ATABLE_METHODS, TYPE_ATABLE_SYMS_DECL, TYPE_ATABLE_DECL,
	TYPE_OTABLE_METHODS, TYPE_OTABLE_SYMS_DECL, TYPE_OTABLE_DECL,
	TYPE_CTABLE_DECL, TYPE_CATCH_CLASSES): New.
	(struct lang_type): Add otable_methods, otable_decl,
	otable_syms_decl, atable_methods, atable_decl, atable_syms_decl,
	ctable_decl, catch_classes, type_to_runtime_map.
	* expr.c (build_field_ref): Make otable, atable, and ctable class
	local rather than global.
	(build_known_method_ref): Likewise.
	(build_invokeinterface): Likewise.
	(java_expand_expr): Pass runtime type (rather than actual type) to
	expand_start_catch.
	* except.c (prepare_eh_table_type): Create TYPE_TO_RUNTIME_MAP for
	this class.  Look up each class in that map to delete duplicates.
	(expand_end_java_handler): Pass runtime type (rather than actual
	type) to expand_start_catch.
	* decl.c: (always_initialize_class_p): Decl moved to java-tree.h.
	(do_nothing): New.
	(java_init_decl_processing): Rearrange things.  Remove global
	declarations of otable, atable, and ctable.
	(java_init_decl_processing): Make lang_eh_runtime_type do_nothing.
	(java_expand_body): Set output_class.
	* constants.c (build_constant_data_ref): Use output_class, not
	current_class.
	(alloc_name_constant): Likewise.
	* class.c (gen_indirect_dispatch_tables): New.
	(build_class_ref): Generate hard reference to superclass, even if
	using indirect dispatch.
	(build_static_field_ref): Use class local atable.
	(make_class_data): Generate hard reference to superclass, even if
	using indirect dispatch.
	Generate symbolic references to interfaces when using indirect
	dispatch.
	(make_class_data): Emit otable, atable, and ctable.
	Make otable, atable, and ctable class local rather than global.
	(emit_catch_table): Make otable, atable, and ctable class local
	rather than global.

2003-12-25  Andrew Pinski  <pinskia@physics.uc.edu>

	* parse.y (catch_clause_parameter): Fix typo.

	PR java/13404
	* parse.y: (catch_clause_parameter): Return early if $3, aka
	formal_parameter, is null.

2003-12-20  Kazu Hirata  <kazu@cs.umass.edu>

	* class.c: Remove uses of "register" specifier in
	declarations of arguments and local variables.
	* decl.c: Likewise.
	* expr.c: Likewise.
	* gjavah.c: Likewise.
	* jcf-dump.c: Likewise.
	* jcf-io.c: Likewise.
	* jcf-parse.c: Likewise.
	* jcf-write.c: Likewise.
	* keyword.h: Likewise.
	* parse.y: Likewise.
	* typeck.c: Likewise.
	* verify.c: Likewise.

2003-12-06  Kelley Cook  <kcook@gcc.gnu.org>

	* Make-lang.in (GCJ_CROSS_NAME): Delete.
	(java.install_common, java.install-man): Adjust for above.
	(java.uninstall): Likewise.

2003-12-03  Michael Koch  <konqueror@gmx.de>

	* class.c (make_class_data):
	Push field value to 'hack_signers' instead of 'signers'.
	* decl.c (java_init_decl_processing):
	Push field 'hack_signers' instead of 'signers'.

2003-12-03  Zack Weinberg  <zack@codesourcery.com>

	* lex.h: Check both HAVE_ICONV and HAVE_ICONV_H before
	including iconv.h.

2003-12-03  Ralph Loader  <rcl@ihug.co.nz>

	PR java/12374:
	* parse.y (qualify_ambiguous_name): Remove lots of broken
	field access processing - there's no need to do that here,
	because we have resolve_field_access.  Remove
	RESOLVE_EXPRESSION_NAME_P as it isn't used anywhere else.
	* java-tree.h: Remove RESOLVE_EXPRESSION_NAME_P as it isn't
	used.

2003-12-01  Jeff Sturm  <jsturm@one-point.com>

	Fix PR java/13237
	* parse.y (java_complete_lhs): Save location prior to patching
	CALL_EXPR.

2003-11-25  Mohan Embar  <gnustuff@thisiscool.com>

	PR java/12548
	* resource.c (write_resource_constructor): Append
	"_resource" to constructor identifier name.

2003-11-25  Jeff Sturm  <jsturm@one-point.com>

	Fix PR java/13183.
	* constants.c (cpool_for_class): New function.
	(outgoing_cpool): Remove global variable.
	(alloc_name_constant): Use cpool_for_class.
	(build_constants_constructor): Likewise.
	* decl.c (java_expand_body): Set current_class.
	* java-tree.h (outgoing_cpool) Remove declaration.
	(init_outgoing_cpool): Likewise.
	* jcf-parse.c (init_outgoing_cpool): Remove function.
	(parse_class_file): Don't call init_outgoing_cpool.
	* parse.y (java_complete_expand_methods): Don't call
	init_outgoing_cpool.  Don't save outgoing_cpool.
	(java_expand_classes): Don't restore outgoing_cpool.
	(java_finish_classes): Likewise.

2003-11-24  Mohan Embar  <gnustuff@thisiscool.com>

	* Make-lang.in: (java.install-common) Add
	symlink for $(target_noncanonical)-gcjh for
	native builds.

2003-11-20  Joseph S. Myers  <jsm@polyomino.org.uk>

	* Make-lang.in (java.extraclean): Delete.

2003-11-20  Joseph S. Myers  <jsm@polyomino.org.uk>

	* Make-lang.in (check-java): Add.

2003-11-19  Jeff Sturm  <jsturm@one-point.com>

	Fix PR java/13024.
	* except.c (prepare_eh_table_type): Allocate variable-sized
	buffer `buf' with alloca.

2003-11-17  Jeff Sturm  <jsturm@one-point.com>

	Fix PR java/12857.

	decl.c (java_init_decl_processing): Don't initialize
	class_not_found_type_node, no_class_def_found_type_node.

	java-tree.h (JTI_CLASS_NOT_FOUND_TYPE_NODE,
	JTI_NO_CLASS_DEF_FOUND_TYPE_NODE): Remove from java_tree_index.
	(class_not_found_type_node, no_class_def_found_type_node):
	Don't define.

	parse.y (build_dot_class_method_invocation): Add this_class
	argument.  Qualify method invocations to a different class.
	(create_new_parser_context): Initialize saved_data_ctx to 0.
	(java_parser_context_save_global): Initialize saved_data_ctx to 1.
	(build_dot_class_method): Don't load classes.  Register
	incomplete types.
	(build_incomplete_class_ref): Special cases for interfaces
	and inner classes.  Move build_dot_class_method call to here...
	(patch_incomplete_class_ref): ...from here.  Pass current_class
	to build_dot_class_method_invocation.
	(build_assertion): Pass class_type to
	build_dot_class_method_invocation.
	(encapsulate_with_try_catch): Handle EXPR_WITH_FILE_LOCATION node.

2003-11-17  Jeff Sturm  <jsturm@one-point.com>

	Fix PR java/12739.
	* java-tree.h (BLOCK_EMPTY_P): Define.
	* parse.y (java_complete_lhs): Check for empty blocks
	in TRY_FINALLY_EXPR case.

2003-11-17  Andrew Haley  <aph@redhat.com>

	* java-tree.h (LOCAL_VAR_OUT_OF_SCOPE_P): New.
	(struct lang_decl_var:freed): New variable.
	* decl.c (poplevel): Mark local vars that have gone out of scope.
	(push_jvm_slot): Don't use the RTL of a var that has gone out of
	scope.

2003-11-16  Jason Merrill  <jason@redhat.com>

	* Make-lang.in (java.tags): Create TAGS.sub files in each directory
	and TAGS files that include them for each front end.

2003-11-15  Tom Tromey  <tromey@redhat.com>

	* gjavah.c (print_stub_or_jni): Pass `env' to FatalError.

2003-11-12  Jason Merrill  <jason@redhat.com>

	PR optimization/12547
	* lang.c (java_tree_inlining_walk_subtrees): Just walk
	BLOCK_EXPR_BODY directly.

2003-11-12  Andrew Haley  <aph@redhat.com>

	PR java/11045
	* parse.y (fold_constant_for_init): Check that we really do have a
	constant.

	PR java/11533
	* lang.c (merge_init_test_initialization): Clear DECL_INITIAL for
	init_test_decls being inlined.

	PR java/12890:
	* parse.y (do_resolve_class): Check return value from
	breakdown_qualified().

2003-11-11  Tom Tromey  <tromey@redhat.com>

	PR java/12915:
	* parse.y (merge_string_cste): Handle case where we have a
	pointer that happens to be zero, not null_pointer_node.

2003-11-10  Tom Tromey  <tromey@redhat.com>

	* jcf-parse.c (classify_zip_file): Correctly compare
	filename_length against length of manifest file's name.

2003-11-08  Tom Tromey  <tromey@redhat.com>

	PR java/12894:
	* jcf-parse.c (classify_zip_file): Only skip MANIFEST.MF file.

2003-11-06  Andrew Haley  <aph@redhat.com>

	* expr.c (java_stack_swap): Make sure destination stack slots are
	of the correct type.

2003-11-03  Kelley Cook  <kcook@gcc.gnu.org>

	* Make-lang.in (dvi): Move targets to $(docobjdir).
	(gcj.dvi): Simplify rule and adjust target.
	(gcj.info): Simplify rule.
	(gcj.pod): New intermediate rule.
	(gcjh.pod): Likewise.
	(jv-scan.pod): Likewise.
	(jcf-dump.pod): Likewise.
	(gij.pod): Likewise.
	(jv-convert.pod): Likewise.
	(rmic.pod): Likewise.
	(rmiregistry.pod): Likewise.
	(gcj.1): Delete.
	(gcjh.1): Delete.
	(jv-scan.1): Delete.
	(jcf-dump.1): Delete.
	(gij.1): Delete.
	(jv-convert.1): Delete.
	(rmic.1): Delete.
	(rmiregistry.1): Delete.

2003-11-02  Jeff Sturm  <jsturm@one-point.com>

	Fixes PR java/12866.
	* parse.y (resolve_qualified_expression_name): Move test
	for outer field access methods from here...
	(check_thrown_exceptions) ...to here.

2003-11-01  Kelley Cook  <kcook@gcc.gnu.org>

	* .cvsignore: Delete.

2003-10-28  Frank Ch. Eigler  <fche@redhat.com>

	* verify.c (verify_jvm_instructions): Don't warn about legal
	eh binding regions generated for example by jdk 1.4.1.

2003-10-24  David S. Miller  <davem@redhat.com>

	* jcf-parse.c (jcf_parse): Fix args to fatal_error().

2003-10-22  Andrew Haley  <aph@redhat.com>

	* lang.c (LANG_HOOKS_GET_CALLEE_FNDECL): New.
	(java_get_callee_fndecl): New.

	* jcf-parse.c (java_parse_file): Call emit_catch_table().

	* java-tree.h (ctable_decl): New.
	(catch_classes):  New.
	(java_tree_index): Add JTI_CTABLE_DECL, JTI_CATCH_CLASSES.

	* decl.c (java_init_decl_processing): Add catch_class_type.
	Add ctable_decl.
	Add catch_classes field.

	* class.c (build_indirect_class_ref): Break out from
	build_class_ref.
	(make_field_value): Check flag_indirect_dispatch.
	(make_class_data): Ditto.
	Tidy uses of PUSH_FIELD_VALUE.
	Add field catch_classes.
	(make_catch_class_record): New.

	* java-tree.h (PUSH_FIELD_VALUE): Tidy.

2003-10-22  Kazu Hirata  <kazu@cs.umass.edu>

	* jcf-write.c: Follow spelling conventions.
	* parse.y: Likewise.

2003-10-22  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Fix typos.
	* expr.c: Fix comment typos.
	* jcf-write.c: Likewise.
	* lang.c: Likewise.
	* lex.c: Likewise.
	* mangle.c: Likewise.
	* parse-scan.y: Likewise.
	* parse.y: Likewise.

2003-10-22  Tom Tromey  <tromey@redhat.com>

	* expr.c (expand_byte_code): Only warn about dead bytecode when
	extra_warnings is set.

2003-10-22  Bryce McKinlay  <bryce@mckinlay.net.nz>

	Fix for	PR java/12586.
	* mangle.c (find_compression_record_match): Don't iterate through
	package namespace elements unless they all match compression_table
	entries.

2003-10-20  Kelley Cook  <kcook@gcc.gnu.org>

	* Make-lang.in (info): Honor $(parsedir) and $(docobjdir).
	(generate-manpages): Likewise.
	(java.maintainer-clean): Likewise.
	(gcj.info): Likewise.
	(gcj.1): Likewise.
	(gcjh.1): Likewise.
	(jv-scan.1): Likewise.
	(jcf-dump.1): Likewise.
	(gij.1): Likewise.
	(jv-convert.1): Likewise.
	(rmic.1): Likewise.
	(rmiregistry.1): Likewise.
	(java.install-man): Likewise.
	(parse-scan.o): Move and define complete compile line.
	(parse.o): Likewise.
	(jcf-tree-inline.o): Move.

2003-10-20  Mark Mitchell  <mark@codesourcery.com>

	* Make-lang.in (info): Update dependencies.
	(java.install-info): Remove.
	($(srcdir)/java/gcj.info): Replace with ...
	($(docobjdir)/gcj.info): ... this.

2003-10-14  Nathanael Nerode  <neroden@gcc.gnu.org>

	* Make-lang.in: Replace uses of $(target_alias) with
	$(target_noncanonical).

2003-10-09  Tom Tromey  <tromey@redhat.com>

	* decl.c (java_init_decl_processing): Declare signers field.
	* class.c (make_class_data): Set signers field.

2003-10-09  Jason Merrill  <jason@redhat.com>

	* parse.y (patch_assignment): Use make_node to create a BLOCK.
	* parse.h (BUILD_PTR_FROM_NAME): Use make_node to create a
	POINTER_TYPE.

2003-10-06  Mark Mitchell  <mark@codesourcery.com>

	* Make-lang.in (java.info): Replace with ...
	(info): ... this.
	(java.dvi): Replace with ...
	(dvi): ... this.
	(java.generated-manpages): Replace with ...

2003-10-03  Kelley Cook  <kelleycook@wideopenwest.com>

	* builtins.c, jcf.h, jvspec.c: Remove PARAMS macros.

2003-10-01  Andrew Haley  <aph@redhat.com>

	* jcf-parse.c (java_parse_file): Write otable and atable.
	* java-tree.h (atable_methods): New.
	(atable_decl): New.
	(atable_syms_decl): New.
	(enum java_tree_index): Add JTI_ATABLE_METHODS, JTI_ATABLE_DECL,
	JTI_ATABLE_SYMS_DECL.  Rename JTI_METHOD_SYMBOL* to JTI_SYMBOL*.
	(symbol_*type): Rename method_symbol* to symbol*type.
	(emit_offset_symbol_table): Delete.
	(emit_symbol_table): New.
	(get_symbol_table_index): New.
	(atable_type): New.
	* expr.c (build_field_ref): Handle flag_indirect_dispatch.
	(build_known_method_ref): Likewise.
	(get_symbol_table_index): Rename from get_offset_table_index.
	Parameterize to allow re-use by differing types of symbol table.
	(build_invokevirtual): Pass table to get_offset_table_index.
	* decl.c (java_init_decl_processing): Push types and decls for
	atable and atable_syyms.
	* class.c (build_static_field_ref): Handle flag_indirect_dispatch.
	(make_class_data): Add new fields atable and atable_syms.
	(emit_symbol_table): Rename from emit_offset_symbol_table.
	Parameterize to allow re-use by different types of symbol table.
	(build_symbol_entry): Renamed from build_method_symbols_entry.

2003-09-30  Roger Sayle  <roger@eyesopen.com>

	* jcf-write.c (generate_bytecode_insns): Implement evaluate-once
	semantics for SAVE_EXPR, by caching the result in a temporary.

2003-09-28  Richard Henderson  <rth@redhat.com>

	* check-init.c (check_init): Save and restore input_location
	instead of file and line separately.
	* decl.c (java_expand_body): Likewise.
	* jcf-write.c (generate_bytecode_insns): Likewise.
	* parse.y (safe_layout_class): Likewise.
	* jcf-parse.c (read_class, parse_class_file): Likewise.
	(java_parse_file): Use %H for warning locator.

2003-09-28  Roger Sayle  <roger@eyesopen.com>

	* expr.c (java_check_reference): Use the semantics of COND_EXPRs
	with void-type branches instead of using a COMPOUND_EXPR.

2003-09-28  Jeff Sturm  <jsturm@one-point.com>

	* decl.c (java_optimize_inline, dump_function): Remove.
	* java-tree.h (java_optimize_inline): Remove declaration.
	* jcf-parse.c (java_parse_file): Assume flag_unit_at_a_time is set.
	* parse.y (source_end_java_method, java_expand_classes):
	Likewise.  Remove dead code.

2003-09-27  Roger Sayle  <roger@eyesopen.com>

	* lang.c (java_init_options): Set flag_evaluation_order.
	* expr.c (force_evaluation_order): Don't attempt to force
	evaluation order of binary operations using save_expr.
	* parse.y (java_complete_lhs): No longer need to call
	force_evaluation_order when constructing binary operators.

2003-09-27  Alexandre Petit-Bianco  <apbianco@redhat.com>
	    Bryce McKinlay  <bryce@mckinlay.net.nz>

	PR java/1333:
	* parse.y (not_accessible_field_error): New function.
	(resolve_expression_name): Check field access permissions.
	(resolve_qualified_expression_name): Use
	not_accessible_field_error.
	(resolve_qualified_expression_name): Likewise.

2003-09-24  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* class.c (build_utf8_ref): Test for HAVE_GAS_SHF_MERGE value.

2003-09-23  Roger Sayle  <roger@eyesopen.com>

	* jcf-write.c (generate_bytecode_insns): Optimize binary operations
	with equal operands without side-effects.

2003-09-22  Jeff Sturm  <jsturm@one-point.com>

	* decl.c (java_init_decl_processing): Don't emit otable decls
	if flag_indirect_dispatch is not set.

2003-09-21  Richard Henderson  <rth@redhat.com>

	* class.c, decl.c, jcf-parse.c, jcf-write.c, parse.y,
	resource.c: Revert.

2003-09-21  Richard Henderson  <rth@redhat.com>

	* class.c, decl.c, jcf-parse.c, jcf-write.c, parse.y,
	resource.c: Update for DECL_SOURCE_LOCATION rename and change to const.

2003-09-20  Richard Henderson  <rth@redhat.com>

	* check-init.c, class.c, decl.c, expr.c: Use %J in diagnostics.

2003-09-18  Roger Sayle  <roger@eyesopen.com>

	* expr.c (java_truthvalue_conversion): Remove FFS_EXPR case.
	* check-init.c (check_init): Likewise.

2003-09-18  Roger Sayle  <roger@eyesopen.com>

	* jcf-write.c (generate_bytecode_insns): Add support for fconst_2.

2003-09-16  Andrew Haley  <aph@redhat.com>

	* jcf-write.c (generate_bytecode_insns): Add MIN_EXPR and MAX_EXPR.

2003-09-17  Ranjit Mathew  <rmathew@hotmail.com>

	Fixes PR java/9577
	* mangle.c (find_compression_record_match): Skip
	over a "6JArray" (the array template mangled string)
	IDENTIFIER_NODE.
	(mangle_array_type): Correct minor typo.
	(atms): Move definition to the beginning.

2003-09-16  Bryce McKinlay  <bryce@mckinlay.net.nz>

	* class.c (add_miranda_methods): Ensure super-interfaces are laid
	out. Fix for PR java/12254.

2003-09-11  Richard Henderson  <rth@redhat.com>

	* parse.y (source_end_java_method): Update for new
	cgraph_finalize_function argument.

2003-09-09  Richard Henderson  <rth@redhat.com>

	* parse.y (source_end_java_method): Update call to
	cgraph_finalize_function.

2003-09-03  Jeff Sturm  <jsturm@one-point.com>

	* decl.c (java_expand_body): New function.
	* expr.c (build_class_init): Set DECL_IGNORED_P.
	* java-tree.h (start_complete_expand_method,
	java_expand_body): Declare.
	* jcf-parse.c (cgraph.h): Include.
	(java_parse_file): Handle flag_unit_at_a_time.
	* lang.c (LANG_HOOKS_TREE_INLINING_START_INLINING,
	LANG_HOOKS_CALLGRAPH_EXPAND_FUNCTION): Define.
	(java_estimate_num_insns): Use walk_tree_without_duplicates.
	(java_start_inlining): New function.
	* parse.h (java_finish_classes): Declare.
	* parse.y: Include cgraph.h.
	(block): Don't special-case empty block production.
	(craft_constructor): Set DECL_INLINE.
	(source_end_java_method): Handle flag_unit_at_a_time.
	Replace inline code with call to java_expand_body.
	(start_complete_expand_method): Remove static modifier.
	(java_expand_method_bodies): Patch function tree for
	class initialization and/or synchronization as needed.
	Don't begin RTL expansion yet.
	(java_expand_classes): Check flag_unit_at_a_time before
	calling finish_class.
	(java_finish_classes): New function.
	(java_complete_lhs): Ensure COMPOUND_EXPR has non-NULL type.
	(patch_assignment): Set DECL_CONTEXT on temporary variable.
	(emit_test_initialization): Set DECL_IGNORED_P.

2003-09-03  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (enum builtin_type): Delete unused enumeration.
	* Make-lang.in (java/builtins.o): Remove built-types.def dependency.

2003-08-28  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Extensions): Document gcjlib URLs.

2003-08-20  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Extensions): Added xref.
	(libgcj Runtime Properties): Document
	gnu.gcj.runtime.VMClassLoader.library_control.

2003-08-20  Andrew Haley  <aph@redhat.com>

	* except.c (prepare_eh_table_type): Use new encoding for exception
	handlers when using -fno-assume-compiled.

2003-08-13  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Invoking gij): Document -X and -?.

2003-08-13  Mohan Embar  <gnustuff@thisiscool.com>

	* Make-lang.in: Added missing win32-host.o to JAVA_OBJS,
	GCJH_OBJS, JCFDUMP_OBJS
	* win32-host.c: Removed the unnecessary and broken dependency
	on jcf.h

2003-08-11  Tom Tromey  <tromey@redhat.com>

	* parse.y (java_check_regular_methods): Typo fixes.  Call
	check_interface_throws_clauses.  Use
	check_concrete_throws_clauses.
	(check_interface_throws_clauses): New function.
	(check_concrete_throws_clauses): New function.
	(hack_is_accessible_p): New function.
	(find_most_specific_methods_list): Added FIXME.
	* typeck.c (lookup_do): Use `flags' argument to decide what to
	do.  Reimplemented.
	(lookup_argument_method_generic): New function.
	(lookup_argument_method2): Removed.
	* jcf.h (ACC_INVISIBLE): New define.
	* jcf-write.c (generate_classfile): Skip invisible methods.
	* class.c (add_miranda_methods): New function.
	(layout_class_methods): Use it.
	(get_access_flags_from_decl): Use ACC_INVISIBLE.
	* java-tree.h (METHOD_INVISIBLE): New define.
	(lang_decl_func) [invisible]: New field.
	(lookup_argument_method_generic): Declare.
	(SEARCH_INTERFACE): New define.
	(SEARCH_SUPER): Likewise.
	(SEARCH_ONLY_INTERFACE): Likewise.
	(SEARCH_VISIBLE): Likewise.
	(lookup_argument_method2): Removed declaration.

2003-08-05  Tom Tromey  <tromey@redhat.com>

	Fix for PR java/11600:
	* parse.y (java_complete_lhs): See whether we're calling a method
	on an array.
	(check_thrown_exceptions): Added `is_array_call' argument;
	fixed `clone' checking; updated all callers.

2003-08-05  Steven Bosscher  <steven@gcc.gnu.org>

	* java-tree.h (DECL_ESTIMATED_INSNS): Remove (moved to tree.h).

2003-08-03  Tom Tromey  <tromey@redhat.com>

	* java-tree.h (METHOD_TRANSIENT): Removed.
	* decl.c (pushdecl): Removed some dead code.
	* class.c (get_access_flags_from_decl): Can't have transient
	method.
	(add_method_1): Can't have a transient method.

2003-07-28  Andreas Jaeger  <aj@suse.de>

	* jvspec.c: Convert to ISO C90 prototypes.

2003-07-25  Nathan Sidwell  <nathan@codesourcery.com>

	* decl.c (force_poplevels): Fix warning call.

2003-07-25  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* expr.c (expand_java_field_op): Don't use xxx_with_decl
	(expand_java_field_op): Likewise.
	* class.c (layout_class_method): Likewise
	(emit_register_classes): Likewise.
	* decl.c (pushdecl): Likewise.
	(poplevel): Likewise.
	(force_poplevels): Likewise.
	(give_name_to_locals): Likewise.
	* check-init.c (check_for_initialization): Likewise.

2003-07-24  Jason Merrill  <jason@redhat.com>

	* java-tree.h: Move boolean_type_node et al to the back end.

2003-07-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c java-tree.h jcf-write.c jvspec.c: Remove unnecessary
	casts.

2003-07-19  Neil Booth  <neil@daikokuya.co.uk>

	* lang.opt: Don't show -MD_ and -MDD_.

2003-07-18  Neil Booth  <neil@daikokuya.co.uk>

	* lang-options.h: Remove.
	* lang.opt: Add help text.

2003-07-15  Kazu Hirata  <kazu@cs.umass.edu>

	* expr.c: Remove the last argument to expand_assignment().

2003-07-09  Jan Hubicka  <jh@suse.cz>

	* java-tree.h (DECL_NUM_STMTS): Rename to...
	(DECL_ESTIMATED_INSNS): ... this.
	* lang.c (java_estimate_num_insns, java_estimate_num_insns_1):
	New static functions.
	(LANG_HOOKS_TREE_INLINING_ESTIMATE_NUM_INSNS): Define.
	* parser.y (add_stmt_to_compound): Do not account statements.

2003-07-08  Mark Wielaard  <mark@klomp.org>

	* gcj.texi: CNI now expands to Compiled Native Interface.

2003-07-08  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* Make-lang.in (java/gcj.dvi): Use PWD_COMMAND.

2003-07-07  Nathan Sidwell  <nathan@codesourcery.com>

	* expr.c (expand_byte_code): Adjist emit_line_note call.

2003-07-06  Neil Booth  <neil@daikokuya.co.uk>

	* lang.c (java_handle_option): Don't handle filenames.

2003-07-02  Zack Weinberg  <zack@codesourcery.com>

	* jcf-path.c: Don't default-define PATH_SEPARATOR nor
	DIR_SEPARATOR.
	Use FILENAME_CMP.
	* jcf-write.c: Don't default-define DIR_SEPARATOR.
	* jcf.h: Delete COMPARE_FILENAMES definition.

2003-07-02  Neil Booth  <neil@daikokuya.co.uk>

	* lang.c (java_init_options): Update prototype.

2003-07-01  Nathan Sidwell  <nathan@codesourcery.com>

	* decl.c (poplevel): Adjust define_label call.

2003-06-27  Zack Weinberg  <zack@codesourcery.com>

	* gjavah.c (flag_jni): Make non-static.
	* parse-scan.y (ctxp): Make non-static.

	* class.c (build_method_symbols_entry)
	* expr.c (get_offset_table_index)
	* jcf-parse.c (jcf_parse):
	Mark the definition static, matching the forward declaration.

2003-06-26  Neil Booth  <neil@daikokuya.co.uk>

	* lang.c (java_handle_option): Don't check for missing arguments.

2003-06-20  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (push_class): Use a location_t to save place.
	(emit_register_classes): Set input_location. Adjust
	expand_function_end call.
	* resource.c (write_resource_constructor): Likewise.
	* decl.c (end_java_method): Adjust expand_function_end call.
	* parse.y (source_end_java_method): Likewise.

2003-06-17  Robert Abeles  <rabeles@archaelogic.com>

	* lang.c (java_handle_option): Likewise.

2003-06-16  Neil Booth  <neil@daikokuya.co.uk>

	* lang.c (java_handle_option): Special-casing of optional
	joined arguments no longer needed.
	* lang.opt: Update switches that take optional argument.

2003-06-15  Neil Booth  <neil@daikokuya.co.uk>

	* lang.opt: Declare Java.
	* lang.c (java_init_options): Update.

2003-06-15  Neil Booth  <neil@daikokuya.co.uk>

	* lang.c (version_flag): Rename to v_flag to avoid clash w/ toplev.h.

2003-06-14  Neil Booth  <neil@daikokuya.co.uk>

	* lang-specs.h: Rewrite -MD and -MMD to append an underscore.
	* lang.c (java_handle_option): -MD and -MMD have an underscore.
	* lang.opt: -MD and -MMD have an underscore.

2003-06-14  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (emit_register_classes): Adjust init_function_start
	call.
	* decl.c (complete_start_java_method): Likewise.
	* resource.c (write_resource_constructor): Likewise.

2003-06-14  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in: Update to use options.c and options.h.
	* lang.c: Include options.h not j-options.h.
	(java_handle_option): Abort on unrecognized option.
	(java_init_options): Request Java switches.

2003-06-11  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in: Handle mostlyclean.

2003-06-11  Tom Tromey  <tromey@redhat.com>

	* lang.c (java_handle_option): Update dependency_tracking for
	OPT_MF case.

	* lang.c (java_handle_option): OPT_fbootclasspath_ can take an
	empty argument.

2003-06-10  Andrew Haley  <aph@redhat.com>

	* resource.c (write_resource_constructor): Use expand_expr to
	generate the address of the label attached to a resource.
	* Make-lang.in (java/resource.o): Add expr.h

2003-06-10  Andrew Haley  <aph@redhat.com>

	* lang.c (LANG_HOOKS_DECL_OK_FOR_SIBCALL): New.
	(java_decl_ok_for_sibcall): New.

2003-06-09  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in (JAVA_OBJS, java/lang.o): Update.
	(java/j-options.c, java/j-options.h): New.
	* java-tree.h (resource_name, compile_resource_file,
	compile_resource_data): Constify.
	* jcf-write.c (jcf_write_base_directory): Similarly.
	* jcf.h (jcf_write_base_directory): Similarly.
	* lang.c: Include j-options.h.
	(cl_options_count, cl_options, string_option, java_decode_option,
	lang_f_options, lang_W_options, LANG_HOOKS_DECODE_OPTION,
	process_option_with_no): Remove.
	(resource_name): Constify.
	(LANG_HOOKS_HANDLE_OPTION): Override.
	(java_handle_option): New.
	(java_init): Don't call jcf_path_init.
	(java_init_options): Call jcf_path_init.
	* lang.opt: New.
	* resource.c (compile_resource_data, compile_resource_file): Constify.

2003-06-09  Nathan Sidwell  <nathan@codesourcery.com>

	* java-tree.h (DECL_FUNCTION_LAST_LINE): New.
	(struct lang_decl_func): Add last_line field.
	* parse.h (DECL_SOURCE_LINE_MERGE, DECL_SOURCE_LINE_FIRST,
	DECL_SOURCE_LINE_LAST): Remove.
	* parse.y (missing_return_error, finish_method_declaration,
	lookup_cl, start_artificial_method_body, source_end_java_method,
	start_complete_expand_method): Adjust.

2003-06-08  Tom Tromey  <tromey@redhat.com>

	* jvspec.c (jvgenmain_spec): Added `*' after fassume-compiled and
	fno-assume-compiled.

2003-06-08  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (define_builtin_type, builtin_types): Delete.
	(define_builtin): Rewritten to take just the built-in code,
	the function's name, type and fallback library function name.
	All built-ins used by Java are implicit and BUILT_IN_NORMAL.
	(initialize_builtins): Overhaul to define the GCC builtins
	used by gcj manually, providing the Java run-time's
	implementations as the fallback library function.

2003-06-08  Anthony Green  <green@redhat.com>

	* parse.y (patch_cast): Fix conversions from floating-point to
	integral types.

2003-06-08  Neil Booth  <neil@daikokuya.co.uk>

	* Make-lang.in: Update.
	* lang.c: Include opts.h. Define cl_options_count and cl_options.

2003-06-07  Neil Booth  <neil@daikokuya.co.uk>

	* lang.c (java_init_options): Update.

2003-06-05  Jan Hubicka  <jh@suse.cz>

	* Make-lang.in:  Add support for stageprofile and stagefeedback

2003-05-31  Roger Sayle  <roger@eyesopen.com>

	* lang.c (java_init_options): Prescribe wrap-around two's
	complement arithmetic overflow by setting flag_wrapv.

2003-05-29  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (cos_builtin, sin_builtin, sqrt_builtin): Delete.
	(builtin_record): Add an additional builtin_code field to
	record which GCC built-in corresponds to the Java function.
	(java_builtins):  Add new entries for atan, atan2, exp, log,
	pow and tan.
	(max_builtin, min_builtin, abs_builtin): Perform constant
	folding on the resulting tree.
	(java_build_function_call_expr): Likewise, perform constant
	folding on the resulting tree.
	(initialize_builtins): The NULL creators are now allowed in
	the java_builtins table, which is now terminated by an entry
	with builtin_code == END_BUILTINS.
	(check_for_builtin): Likewise.  If the matching creator is
	NULL, construct the call using java_build_function_call_expr
	directly with the decl for the corresponding builtin_code.

2003-05-23  Nathanael Nerode  <neroden@gcc.gnu.org>

	* win32-host.c: Normalize copyright boilerplate.

2003-05-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* parse.y (print_int_node): Use string concatentation on
	HOST_WIDE_INT_PRINT_* format specifier to collapse multiple
	function calls into one.

2003-05-13  Zack Weinberg  <zack@codesourcery.com>

	* jcf-parse.c, jcf-write.c, lex.c: Replace all calls to
	fatal_io_error with calls to fatal_error; add ": %m" to the end of
	all the affected error messages.

2003-05-13  Richard Henderson  <rth@redhat.com>

	* class.c (layout_class_method): Set DECL_EXTERNAL.
	* decl.c (java_mark_decl_local, java_mark_class_local): New.
	* java-tree.h (java_mark_class_local): Declare.
	* jcf-parse.c (parse_class_file): Use it.
	* parse.y (java_expand_classes): Likewise.

2003-05-04  Nathan Sidwell  <nathan@codesourcery.com>

	* Make-lang.in (java/parse.o, java/parse-scan.o): Depend on input.h.
	* lex.h: #include input.h.
	* jv-scan.c (input_filename): Remove.

2003-05-02  Tom Tromey  <tromey@redhat.com>

	PR java/10491:
	* gjavah.c (HANDLE_INNERCLASSES_ATTRIBUTE): New macro.
	(handle_inner_classes): New function.

2003-05-01  Tom Tromey  <tromey@redhat.com>

	PR java/10459:
	* parse.y (finish_for_loop): Do nothing if update expression is a
	EXPR_WFL_NODE wrapping nothing.
	(java_complete_lhs) <COMPOUND_EXPR>: Likewise.

2003-05-02  Nathan Sidwell  <nathan@codesourcery.com>

	* lex.h (input_lineno): Remove declaration.
	* parse-scan.y: #include input.h.
	(input_filename): Remove declaration.
	(input_location): Add definition.
	(input_line): Remove definition.

2003-05-01  Nathan Sidwell  <nathan@codesourcery.com>

	* lex.h (lineno): Rename to ...
	(input_line): ... here
	* parse-scan.y (lineno): Rename to ...
	(input_line): ... here.
	(reset_report): Rename lineno to input_line.
	* check-init.c (check_init): Likewise.
	* class.c (push_class): Likewise.
	* decl.c (complete_start_java_method, end_java_method): Likewise.
	* expr.c (expand_byte_code): Likewise.
	* jcf-parse.c (give_name_to_class, parse_class_file): Likewise.
	* jcf-write.c (generate_bytecode_insns): Likewise.
	* lex.c (java_init_lex, java_allocate_new_line,
	do_java_lex): Likewise.
	* parse.h (YYNOT_TWICE): Likewise.
	* parse.y (empty_statement, expression_statement,
	java_pop_parser_context, java_parser_context_save_global,
	yyerror, register_fields, method_header, safe_layout_class,
	find_in_imports_on_demand, create_artificial_method,
	source_end_java_method, start_complete_expand_method,
	build_thisn_assign, java_complete_lhs,
	maybe_absorb_scoping_block): Likewise.

2003-04-20  Mohan Embar  <gnustuff@thisiscool.com>

	* jcf-io.c (find_class): use DIR_SEPARATOR instead of
	'/' when computing java source filename

2003-04-13  Tom Tromey  <tromey@redhat.com>

	* gjavah.c (print_c_decl): Indentation fix.

2003-04-12  Zack Weinberg  <zack@codesourcery.com>

	* class.c (make_field_value, make_method_value, get_dispatch_table)
	(make_class_data, emit_offset_symbol_table)
	* constants.c (build_constants_constructor)
	* java-tree.h (START_RECORD_CONSTRUCTOR)
	* parse.y (maybe_build_array_element_wfl):
	Use build_constructor.

2003-04-10  Eric Blake  <ebb9@email.byu.edu>

	PR java/10253:
	* parse.y (string_convert_int_cst): Always use at least one digit
	in string conversion. Remove ASCII dependence.
	(merge_string_cste): Fix merging of 3-byte UTF-8 characters.

2003-03-16  Mohan Embar  <gnustuff@thisiscool.com>

	* Make-lang.in: added win32-host.c
	* jcf.h: defined macro JCF_OPEN_EXACT_CASE which
	resolves to open() on non-Win32 platforms and
	Win32-specific jcf_open_exact_case() on Win32
	* jcf-io.c (find_class): use JCF_OPEN_EXACT_CASE
	when trying .java and .class files
	* win32-host.c: added to repository. Defines
	Win32-specific jcf_open_exact_case()

2003-04-10  Andrew Haley  <aph@redhat.com>

	* jcf-write.c (struct jcf_partial): num_jsrs: new field.
	(maybe_free_localvar): Renamed from localvar_free.
	Add new arg, really.
	(generate_bytecode_insns): Set new variable, jsrs.
	Only free local vars if no jsr insns have been emittted.
	Call maybe_free_localvar, not localvar_free.

2003-03-30  Joseph S. Myers  <jsm@polyomino.org.uk>

	* gcj.texi: Remove @ at start of file.

2003-03-25  Tom Tromey  <tromey@redhat.com>

	* parse.y (create_interface): Call CHECK_DEPRECATED.

2003-03-23  Zack Weinberg  <zack@codesourcery.com>

	* Make-lang.in: Link jcf-dump against $(LDEXP_LIB).

2003-03-21  Zack Weinberg  <zack@codesourcery.com>

	* javaop.h (jfloat, jdouble): Make them structures mirroring
	the bit fields of IEEE float and double respectively.
	(JFLOAT_FINITE, JFLOAT_QNAN_MASK, JFLOAT_EXP_BIAS,
	JDOUBLE_FINITE, JDOUBLE_QNAN_MASK, JDOUBLE_EXP_BIAS): New.
	(union Word, union DWord): Delete.
	(WORD_TO_FLOAT, WORDS_TO_DOUBLE): Update to match.

	* gjavah.c (java_float_finite, java_double_finite, F_NAN_MASK,
	D_NAN_MASK): Delete.
	(jni_print_float, jni_print_double): New.  Generate
	hexadecimal floating constants.
	(print_field_info): Use jni_print_float/double.

	* jcf-dump.c: Include math.h.  Use ldexp/frexp to assemble
	finite floating point numbers for output; special case
	non-finite floats.

2003-03-19  Nathanael Nerode  <neroden@gcc.gnu.org>

	* lang.c (java_dump_tree): Change return type from 'int' to 'bool'.
	Replace 0 and 1 with true and false in return statements.

2003-03-19  Tom Tromey  <tromey@redhat.com>

	* lex.c (do_java_lex): Renamed from java_lex.
	(java_lex): New function.
	Include timevar.h.

2003-03-13  Tom Tromey  <tromey@redhat.com>

	* parse.y (resolve_inner_class): Error if qualifier is a primitive
	type.

2003-03-04  Andrew Haley  <aph@redhat.com>

	* gjavah.c (is_first_data_member): New global variable.
	(print_c_decl): If it's the first data member, align it as the
	superclass.
	(process_file): Set is_first_data_member.

2003-03-11  Tom Tromey  <tromey@redhat.com>

	* parse.y (resolve_field_access): Initialize class if field is
	found in another static field.
	* expr.c (build_class_init): Don't optimize out initialization of
	implemented interface.

2003-03-11  Andrew Haley  <aph@redhat.com>

	* jcf-io.c (caching_stat): Initialize origsep to remove compiler
	warning.

2003-03-10  Ranjit Mathew  <rmathew@hotmail.com>

	* jcf-io.c (caching_stat): Account for both DIR_SEPARATOR
	and DIR_SEPARATOR_2 for a target.
	Correct minor typos.

	* jcf-write.c (make_class_file_name): Take both DIR_SEPARATOR
	and DIR_SEPARATOR_2 for a target into account.

2003-03-08  Neil Booth  <neil@daikokuya.co.uk>

	* lang.c (java_init): Update prototype, move code to java_post_options.
	(java_post_options): Similarly.

2003-03-05  Ranjit Mathew  <rmathew@hotmail.com>

	* jcf.h (COMPARE_FILENAMES): New macro similar to "strcmp" to
	compare file name components depending on the case-sensitivity
	or otherwise of the host file system.

	* jcf-path.c (add_entry): Use COMPARE_FILENAMES instead of
	"strcmp" to compare file name components.
	Use IS_DIR_SEPARATOR instead of comparing directly against
	DIR_SEPARATOR.
	(jcf_path_extdirs_arg): Use IS_DIR_SEPARATOR instead of
	comparing directly against DIR_SEPARATOR.

2003-03-04  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (java.tags): New target.

2003-03-01  Roger Sayle  <roger@eyesopen.com>

	* java/builtins.c (builtin_type): Handle DEF_FUNCTION_TYPE_VAR_3.
	(initialize_builtins): Handle DEF_FUNCTION_TYPE_VAR_3.

2003-03-01  Tom Tromey  <tromey@redhat.com>

	* parse.y (jdep_resolve_class): Only check deprecation if we found
	a decl.

2003-02-28  Tom Tromey  <tromey@redhat.com>

	PR java/9695:
	* class.c (maybe_layout_super_class): Always pass a WFL to
	do_resolve_class.
	* parse.y (do_resolve_class): Updated comment to explain
	parameters.

2003-02-26  Tom Tromey  <tromey@redhat.com>

	* jcf-write.c (generate_classfile): Check whether class is
	deprecated before writing attribute count.

2003-02-25  Roger Sayle  <roger@eyesopen.com>

	* java/decl.c (java_init_decl_processing): Get soft_fmod_node from
	built_in_decls[BUILT_IN_FMOD] rather than define it ourselves.

2003-02-23  Tom Tromey  <tromey@redhat.com>

	* lang-options.h: Added -Wdeprecated.
	* gcj.texi (Warnings): Document -Wdeprecated.
	* java-tree.h (flag_deprecated): Declare.
	* lang.c (lang_W_options): Added deprecated.
	(flag_deprecated): New global.
	* chartables.h: Rebuilt.
	* gen-table.pl (process_one): Look at whitespace.
	(print_tables): Define LETTER_SPACE, LETTER_MASK.
	* parse.h (CLEAR_DEPRECATED): New macro.
	(CHECK_DEPRECATED_NO_RESET): New macro.
	* jcf-parse.c (handle_deprecated): New function.
	(HANDLE_DEPRECATED_ATTRIBUTE): New define.
	* jcf-reader.c (get_attribute): Handle Deprecated attribute.
	* parse.y (resolve_type_during_patch): Check deprecation.
	(jdep_resolve_class): Likewise.
	(process_imports): Likewise.
	(resolve_expression_name): Likewise.
	(check_deprecation): Strip arrays from decl.  Check
	flag_deprecated.
	(patch_method_invocation): Also check the particular constructor
	for deprecation.
	(register_fields): Use CHECK_DEPRECATED_NO_RESET in loop.
	* jcf-write.c (append_deprecated_attribute): New function.
	(generate_classfile): Generate deprecated attribute when
	appropriate.
	* lex.c (java_parse_doc_section): Return type now void.  Rewrote.
	(java_lex) [case '*']: Simplify logic.
	(java_start_char_p): Use LETTER_MASK.
	(java_part_char_p): Likewise.
	(java_space_char_p): New function.

2003-02-20  Nathan Sidwell  <nathan@codesourcery.com>

	Change base class access representation.
	* java/class.c (set_super_info): Don't set TREE_VIA_PUBLIC.
	(add_interface_do): Likewise.

2003-02-12  Ranjit Mathew  <rmathew@hotmail.com>

	* decl.c (java_init_decl_processing): Change
	soft_lookupjnimethod_node to reflect the change in
	signature of _Jv_LookupJNIMethod in libjava/jni.cc
	* expr.c (build_jni_stub): Calculate and pass the size
	on the stack of the arguments to a JNI function. Use
	new target macro MODIFY_JNI_METHOD_CALL to allow a
	target to modify the call to a JNI method.

2003-02-08  Roger Sayle  <roger@eyesopen.com>

	* jcf-io.c (java_or_class_file): Use libiberty's lbasename
	instead of basename to avoid compiler warnings on Tru64.

2003-02-04  Joseph S. Myers  <jsm@polyomino.org.uk>

	* gcj.texi: Update to GFDL 1.2.

2003-01-31  Andrew Haley  <aph@redhat.com>

	* parse.y (java_expand_classes): Scan the whole class list looking
	for access methods that haven't yet been expanded.

2003-01-31 Adrian Bunk <bunk@fs.tum.de>

	Fix for java/4269:

	* jv-scan.c: Use HAVE_LANGINFO_CODESET instead of HAVE_NL_LANGINFO
	to fix bootstrap on sparc-unknown-netbsdelf1.5.
	* jcf-parse.c: Likewise.

2003-01-31  Mark Wielaard  <mark@klomp.org>

	* gjavah.c (throwable_p): Allocate 1 more byte for string.

2003-01-31  Nathan Sidwell  <nathan@codesourcery.com>

	* class.c (make_class): Use BINFO_ELTS.
	(set_super_info): Likewse.
	(add_interface_do): Likewise.

2003-01-30  Tom Tromey  <tromey@redhat.com>

	* jcf-parse.c (read_class): Update identifier's class value if it
	changed during parsing.

2003-01-30  Loren James Rittle  <ljrittle@acm.org>

	* Make-lang.in (po-generated): Find the targets in $(parsedir).
	Propagate change to all other rules as required.
	(java/parse-scan.o): Add explicit dependency on
	$(parsedir)/java/parse-scan.c .

2003-01-29  Tom Tromey  <tromey@redhat.com>

	* parse.y (patch_assignment): Only transform the rhs of an
	assignment when compiling to native.

2003-01-28  Tom Tromey  <tromey@redhat.com>

	* jcf-write.c (generate_bytecode_conditional): Typo fixes.

2003-01-28  Tom Tromey  <tromey@redhat.com>

	* lex.c (java_lex): Don't include UEOF as part of token.
	(java_read_unicode): Error if \u sequence prematurely terminated.

2003-01-27  Tom Tromey  <tromey@redhat.com>

	* parse.y (java_check_regular_methods): Check for construct after
	checking types in throws clause.

2003-01-24  Tom Tromey  <tromey@redhat.com>

	* class.c (build_static_field_ref): Only a String or numeric field
	can fold to a constant.

2003-01-23  Tom Tromey  <tromey@redhat.com>

	* jcf-parse.c (parse_zip_file_entries): Overwrite trailing \0 of
	file name in resource buffer.

2003-01-23  Tom Tromey  <tromey@redhat.com>

	* expr.c (build_known_method_ref): Use method's context to find
	method table index.

2003-01-23  Tom Tromey  <tromey@redhat.com>

	* constants.c (set_constant_entry): Allocated cleared memory.

2003-01-22  Tom Tromey  <tromey@redhat.com>

	* java-tree.h: Don't use PARAMS.
	* resource.c: Add prototypes for all functions.
	(write_resource_constructor): Use `const char *' to avoid
	warning.

2003-01-22 Nathanael Nerode  <neroden@gcc.gnu.org>

	* jcf-parse.c (process_zip_dir): Remove unused variable.

2003-01-22  Tom Tromey  <tromey@redhat.com>

	* expr.c (build_invokeinterface): Abort if method's context is not
	an interface.

2003-01-22  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Input and output files): Mention non-class entries.
	* decl.c (java_init_decl_processing): Call
	init_resource_processing.
	* java-tree.h (compile_resource_data, write_resource_constructor,
	compile_resource_file, init_resource_processing): Declare.
	* config-lang.in (gtfiles): Added resource.c.
	* Make-lang.in (gt-java-resource.h): New target.
	(JAVA_OBJS): Added resource.o.
	(java/resource.o): New target.
	* resource.c: New file.
	* class.c (compile_resource_file): Moved to resource.c.
	(registerResource_libfunc): Likewise.
	(utf8_decl_list): Mark with GTY; now static.
	* jcf-parse.c (classify_zip_file): New function.
	(parse_zip_file_entries): Use it; compile .properties files.
	(process_zip_dir): Use classify_zip_file and compute_class_name.
	Don't write class name into zip directory.
	(java_parse_file): Call write_resource_constructor.
	(compute_class_name): New function.
	* jcf-io.c (read_zip_member): Reindented.

2003-01-21  Tom Tromey  <tromey@redhat.com>

	* class.c (supers_all_compiled): New function.
	(make_class_data): Use it.

2003-01-21  Tom Tromey  <tromey@redhat.com>

	* parse.y (method_header): Native method can't be strictfp.
	No method can be transient or volatile.

2003-01-21  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	Make-lang.in (jvspec.o-warn): Add -Wno-error.

2003-01-18  Kazu Hirata  <kazu@cs.umass.edu>

	* check-init.c: Fix comment typos.
	* class.c: Likewise.
	* constants.c: Likewise.
	* decl.c: Likewise.
	* except.c: Likewise.
	* expr.c: Likewise.
	* java-except.h: Likewise.
	* java-tree.h: Likewise.
	* javaop.h: Likewise.
	* jcf-dump.c: Likewise.
	* jcf-io.c: Likewise.
	* jcf-parse.c: Likewise.
	* jcf-write.c: Likewise.
	* lang.c: Likewise.
	* mangle.c: Likewise.
	* typeck.c: Likewise.
	* verify.c: Likewise.

2003-01-18  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Make-lang.in (java/jcf-write.o): Depend on $(TM_P_H).
	* jcf-write.c: Include "tm_p.h".

2003-01-17  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* jcf-io.c (caching_stat): Cast the 3rd arg of scandir to void*.

2003-01-16  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* builtins.c (java_build_function_call_expr): Renamed from
	build_function_call_expr.  All callers changed.

	* Make-lang.in (java/jcf-parse.o): Depend on $(TM_P_H).
	* jcf-parse.c: Include tm_p.h.

	* jcf-write.c (generate_bytecode_insns): Avoid signed/unsigned
	warning.

2003-01-14  Tom Tromey  <tromey@redhat.com>

	* class.c (make_class_data): Check that super is compiled before
	building class reference to it.

2003-01-14  Andrew Haley  <aph@redhat.com>

	* decl.c (java_init_decl_processing): _Jv_NewMultiArray is a
	varargs function -- correct.

2003-01-14  Andrew Haley  <aph@redhat.com>

	* decl.c (java_init_decl_processing): Temporarily back out previous patch.

2003-01-14  Andrew Haley  <aph@redhat.com>

	* decl.c (java_init_decl_processing): _Jv_NewMultiArray is a
	varargs function -- correct.

	* parse.y (patch_assignment): Copy the rhs of an assignment into a
	temporary if the RHS is a reference.

2003-01-11  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* Make-lang.in (keyword.h): Pass "-L ANSI-C" to gperf.
	* keyword.h: Regenerated.

	* All Files: Convert to ISO C style function definitions.

2003-01-09  Nathanael Nerode  <neroden@gcc.gnu.org>

	* parse.y (check_pkg_class_access): ANSIfy definition.

2003-01-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl.c, parse-scan.y, parse.y: Don't cast return value of
	xmalloc et al.

	* class.c, gjavah.c, parse.y, verify.c: Don't use PTR.

2003-01-09  Geoffrey Keating  <geoffk@apple.com>

	Merge from pch-branch:

	2002-12-02  Geoffrey Keating  <geoffk@apple.com>

	* Make-lang.in (java/gjavah.o): Update dependencies.
	* gjavah.c: Include ggc.h.

	2002-08-16  Geoffrey Keating  <geoffk@redhat.com>

	* Make-lang.in (GCJH_OBJS): Add ggc-none.o.
	(JCFDUMP_OBJS): Add ggc-none.o.
	(java/jcf-dump.o): Depend on GGC_H.
	* jcf-reader.c (jcf_parse_constant_pool): Use ggc_alloc to allocate
	CPool substructures.
	* jcf-parse.c (process_zip_dir): Use ggc_alloc to allocate JCFs.
	* jcf-dump.c: Include ggc.h.

	2002-08-08  Geoffrey Keating  <geoffk@redhat.com>

	* jcf.h (union cpool_entry): New.
	(struct CPool): Use gengtype to mark.  Change field 'data' to be
	an array of unions.
	(struct JCF): Use gengtype to mark.
	(CPOOL_UINT): Update for new cpool_entry type.
	(CPOOL_USHORT1): Likewise.
	(CPOOL_USHORT2): Likewise.
	(CPOOL_FINISH): Use GC to free cpool subfields.
	* parse.h (struct parser_ctxt): Mark field current_jcf.
	* lex.c (java_init_lex): Use GC to allocate struct JCF.
	* jcf-parse.c (HANDLE_CONSTANT_Utf8): Update for new cpool_entry type.
	(main_jcf): Use gengtype to mark.
	(ggc_mark_jcf): Delete.
	(get_constant): Update for new cpool_entry type.
	(give_name_to_class): Likewise.
	(get_class_constant): Likewise.
	(init_outgoing_cpool): Use GGC to allocate struct CPool.
	(java_parse_file): Use GGC to allocate struct JCF.
	(init_jcf_parse): Don't call ggc_add_root.
	* jcf-reader.c (jcf_parse_constant_pool): Update for new
	cpool_entry type.
	* java-tree.h (current_jcf): Use gengtype to mark.
	(CPOOL_UTF): Update for new cpool_entry type.
	(outgoing_cpool): Use gengtype to mark.
	(struct lang_type): GC struct JCF and struct CPool.
	* config-lang.in (gtfiles): Add jcf.h.
	* constants.c (find_tree_constant): New.
	(set_constant_entry): Allocate cpool subfields using GGC.  Update
	for new cpool_entry type.
	(find_constant1): Update for new cpool_entry type.
	(find_constant2): Likewise.
	(find_utf8_constant): Use find_tree_constant.
	(find_class_or_string_constant): Remove unnecessary cast to jword.
	Update for new cpool_entry type.
	(count_constant_pool_bytes): Update for new cpool_entry type.
	(write_constant_pool): Likewise.
	(alloc_name_constant): Use find_tree_constant.
	(build_constants_constructor): Update for new cpool_entry type.

	2002-08-08  Geoffrey Keating  <geoffk@redhat.com>

	* parse.y (mark_parser_ctxt): Delete.
	(goal): Don't use ggc_add_root.
	(create_new_parser_context): Use GC to allocate struct parser_ctxt.
	(java_pop_parser_context): Let GC free parser_ctxt.
	(java_parser_context_resume): Likewise.
	* parse.h (struct parser_ctxt): Use gengtype to mark.
	(ctxp): Likewise.
	(ctxp_for_generation): Likewise.
	* lex.h (struct java_lc_s): Mark for gengtype.
	(java_lexer): Rearrange for gengtype.
	* config-lang.in (gtfiles): Add lex.h, parse.h.

2003-01-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* All Files: Remove PARAMS macro.

	* expr.c, gjavah.c, javaop.h, jcf-dump.c, jcf-io.c, jcf-reader.c,
	jcf-write.c, jcf.h, jv-scan.c: Don't rely on the `DEFUN', `AND' or
	`__STDC__' macros.

	* jv-scan.c, parse.y: Remove VPARAMS, VA_OPEN, VA_FIXEDARG and
	VA_CLOSE.

2003-01-09  Christian Cornelssen  <ccorn@cs.tu-berlin.de>

	* Make-lang.in (java.install-common, java.uninstall,
	java.install-info, java.install-man): Prepend $(DESTDIR)
	to destination paths in all (un)installation commands.
	(java.install-common): Rewrite $(LN) command to support
	DESTDIR with "ln" as well as with "ln -s".

2003-01-08  Nathanael Nerode  <neroden@gcc.gnu.org>

	* java-tree.h: Protect against multiple inclusion.

2003-01-07  Tom Tromey  <tromey@redhat.com>

	* class.c (add_assume_compiled): Don't adjust parent if we're
	already at the root of tree.

2003-01-05  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* lang.c (dump_compound_expr): Prototype.

2003-01-03  Tom Tromey  <tromey@redhat.com>

	Fix for PR java/8712:
	* expr.c (build_instanceof): Build an NE_EXPR, not a COND_EXPR,
	when simply checking against `null'.

2003-01-03  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Standard Properties): Document http.proxyHost and
	http.proxyPort.

	* gcj.texi (GNU Classpath Properties): Document new properties.

2003-01-02  Steven Bosscher <s.bosscher@student.tudelft.nl>

	* java/jcf-reader.c, java/jvgenmain.c, java/keyword.gperf,
	java/lang-options.h, java/mangle.c, java/mangle_name.c,
	java/xref.c, java/zextract.c,java/zipfile.h: Fix copyright years.

2003-01-01  Steven Bosscher  <s.bosscher@student.tudelft.nl>

	* Make-lang.in, boehm.c, buffer.c,
	  buffer.h, builtins.c, class.c,
	  config-lang.in, constants.c,
	  convert.h, decl.c, except.c,
	  expr.c, java-except.h,
	  java-tree.h, javaop.def,
	  jcf-parse.c, jcf-write.c,
	  jv-scan.c, jvgenmain.c,
	  jvspec.c, keyword.gperf,
	  keyword.h, lang-options.h,
	  lang-specs.h, lang.c, lex.c,
	  lex.h, mangle.c, mangle_name.c,
	  parse-scan.y, parse.h, parse.y,
	  typeck.c, verify.c, xref.c,
	  xref.h: Replace "GNU CC" with
	  "GCC" in the copyright header.

	* check-init.c, gjavah.c, javaop.h,
	  jcf-depend.c, jcf-dump.c, jcf-io.c,
	  jcf-path.c, jcf-reader.c, jcf.h,
	  zextract.c, zipfile.h: These files are
	  "part of GCC". Also say "GCC" not "GNU CC".

2002-12-30  DJ Delorie  <dj@redhat.com>

	* Make-lang.in: Protect against texi2pod/pod2man failing.

2002-12-28  Joseph S. Myers  <jsm@polyomino.org.uk>

	* gcj.texi: Use @copying.

2002-12-27  Mark Mitchell  <mark@codesourcery.com>

	* gjavah.c (print_name_for_stub_or_jni): Adjust call to
	print_cxx_classname.
	(print_cxx_classname): Add add_scope parameter.
	(print_class_decls): Do not emit a semicolon after the extern
	"Java" block.
	(process_file): Adjust calls to print_cxx_classname.

2002-12-23  Joseph S. Myers  <jsm@polyomino.org.uk>

	* gcj.texi: Include Cover Texts in man page.

2002-12-23  Jeff Sturm  <jsturm@one-point.com>

	* class.c (build_static_field_ref): Check FIELD_FINAL.

	* constants.c (alloc_class_constant): Use TYPE_CPOOL_DATA_REF
	instead of current_constant_pool_data_ref.
	* java-tree.h (current_constant_pool_data_ref): Undefine.
	(JTI_CURRENT_CONSTANT_POOL_DATA_REF): Remove.
	* jcf-parse.c (init_outgoing_cpool): Don't initialize
	current_constant_pool_data_ref.

	* except.c (prepare_eh_table_type ): Use DECL_NAME of class type,
	not build_internal_class_name.

	* parse.y (patch_incomplete_class_ref): Always emit `class$' method.
	Use it when class ref isn't certain to be compiled.

2002-12-23  Joseph S. Myers  <jsm@polyomino.org.uk>

	* gcj.texi: Include gcc-common.texi.
	* Make-lang.in ($(srcdir)/java/gcj.info, java/gcj.dvi): Depend on
	$(srcdir)/doc/include/gcc-common.texi.

2002-12-22  Anthony Green  <green@redhat.com>

	* gcj.texi (Limitations): Add note about org.xml.sax and
	org.w3c.dom.

2002-12-20  Tom Tromey  <tromey@redhat.com>

	* jcf-write.c (generate_bytecode_insns) [SWITCH_EXPR]: Handle case
	where minimum case value is Integer.MIN_VALUE.
	Fixes PR java/8955.

2002-12-18  Andrew Haley  <aph@redhat.com>

	* parse.y (patch_invoke): Force evaluation order when `check' is
	set.  For PR libgcj/8945.

2002-12-16  Mark Mitchell  <mark@codesourcery.com>

	* gcj.texi: Change version number to 3.4.

2002-12-05  Ranjit Mathew <rmathew@hotmail.com>
	Andrew Haley <aph@redhat.com>

	* parse.y (source_end_java_method): Remove custom encoding of line
	numbers for a function decl before passing it to the back end.

2002-12-03  Andrew Haley  <aph@redhat.com>

	* class.c (make_class_data): New field, "chain".
	* decl.c (java_init_decl_processing): Likewise.

2002-12-02  Tom Tromey  <tromey@redhat.com>

	For PR java/8740:
	* parse.y (do_resolve_class): Handle qualified name via
	recursion.

2002-11-30  Zack Weinberg  <zack@codesourcery.com>

	* boehm.c, buffer.c, builtins.c, check-init.c, class.c,
	constants.c, decl.c, except.c, expr.c, gjavah.c, jcf-depend.c,
	jcf-dump.c, jcf-io.c, jcf-parse.c, jcf-path.c, jcf-write.c,
	jv-scan.c, jvgenmain.c, jvspec.c, lang.c, mangle.c, mangle_name.c,
	parse-scan.y, parse.y, typeck.c, verify.c, xref.c, zextract.c:
	Include coretypes.h and tm.h.
	* Make-lang.in: Update dependencies.

2002-11-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl.c (java_init_decl_processing): Use `LL' on 64-bit constant.

2002-11-25  Diego Novillo  <dnovillo@redhat.com>

	* jcf-reader.c: Don't expand JCF_readu4 inside the
	expansion of JCF_SKIP.

2002-11-25  Diego Novillo  <dnovillo@redhat.com>

	* jcf-reader.c: Don't expand JCF_readu4 inside the
	expansion of JCF_SKIP.

2002-11-22  Tom Tromey  <tromey@redhat.com>

	* parse.y (patch_binop): Cast right hand side of shift expression
	to `int'.  Fixes PR java/8676.

2002-11-22  Ranjit Mathew <rmathew@hotmail.com>
	    Andrew Haley <aph@redhat.com>

	* gcc/java/jcf-write.c (write_classfile): Remove target
	class file, if it exists, before renaming the temporary
	class file to it.

2002-11-19  Jason Thorpe  <thorpej@wasabisystems.com>

	* jvspec.c (lang_specific_spec_functions): New.

2002-11-18  Tom Tromey  <tromey@redhat.com>

	Fix for PR java/7912:
	* expr.c (can_widen_reference_to): Allow cast of array to
	Cloneable or Serializable.
	* java-tree.h (java_lang_cloneable_identifier_node): Declare.
	(java_io_serializable_identifier_node): Likewise.
	* parse.y (java_lang_cloneable, java_io_serializable): Removed.
	(valid_ref_assignconv_cast_p): Use new identifier nodes.
	* lex.c (java_init_lex): Don't initialize java_lang_cloneable and
	java_io_serializable.
	* decl.c (java_init_decl_processing): Initialize
	java_lang_cloneable_identifier_node and
	java_io_serializable_identifier_node.
	(java_lang_cloneable_identifier_node): New global.
	(java_io_serializable_identifier_node): Likewise.

2002-11-14  Jens-Michael Hoffmann  <jensmh@gmx.de>

	* buffer.c: Remove unnecessary casts.
	* check-init.c: Likewise.
	* class.c: Likewise.
	* constants.c: Likewise.
	* decl.c: Likewise.
	* except.c: Likewise.
	* gjavah.c: Likewise.
	* jcf-io.c: Likewise.
	* jcf-parse.c: Likewise.
	* jcf-path.c: Likewise.
	* jvspec.c: Likewise.
	* lang.c: Likewise.
	* lex.c: Likewise.
	* verify.c: Likewise.

2002-11-06  Tom Tromey  <tromey@redhat.com>

	* gjavah.c (print_stub_or_jni): Include JNIEXPORT and JNICALL in
	a JNI header.

2002-11-05  Tom Tromey  <tromey@redhat.com>

	Fix for PR java/6388.
	* lex.h (JAVA_INTEGRAL_RANGE_ERROR): Wrap in do...while.
	* java-tree.h (enum java_tree_index): New values
	JTI_DECIMAL_INT_MAX_NODE, JTI_DECIMAL_LONG_MAX_NODE.
	(decimal_int_max, decimal_long_max): New defines.
	* lex.c (yylex): Rewrote range checking.  Sign extend literals.
	(error_if_numeric_overflow): Rewrote range checking.
	* decl.c (java_init_decl_processing): Initialize decimal_int_max,
	decimal_long_max.

2002-11-02  Tom Tromey  <tromey@redhat.com>

	* java-tree.h: Move JV_STATE_ERROR before JV_STATE_DONE.

	* class.c (make_method_value): Put class name, not signature, into
	`throws' field.  For PR java/8415.

2002-10-24  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Invoking gij): Document --showversion.
	(Standard Properties): java.library.path now set.

2002-10-23  Tom Tromey  <tromey@redhat.com>

	* gjavah.c (decode_signature_piece): In JNI mode, print
	`jobjectArray' when array depth is nonzero.
	Fixes PR java/8296.

2002-10-15  Andrew Haley  <aph@redhat.com>

	* parse.y (patch_invoke): Call force_evaluation_order on a static
	arg list.
	(resolve_qualified_expression_name): Call force_evaluation_order
	on a arg list that is part of a Qualified Expression Name.

	* lang.c (dump_compound_expr): New.
	(java_dump_tree): New.

2002-10-20  Ranjit Mathew <rmathew@hotmail.com>

	* gcj.texi: Added item describing the GCJ runtime property
	"gnu.gcj.progname".

2002-10-15  Richard Henderson  <rth@redhat.com>

	* jcf-parse.c (get_constant): Fix type warning.

2002-10-15  Andrew Haley  <aph@redhat.com>

	* java-tree.h (java_inlining_merge_static_initializers): Declare.
	(java_inlining_map_static_initializers): Declare.

2002-10-14  Andrew Haley  <aph@redhat.com>

	* tree-inline.c (remap_block): All local class initialization
	flags go in the outermost scope.
	(expand_call_inline): Call java_inlining_map_static_initializers.
	(expand_call_inline): Call java_inlining_merge_static_initializers.
	* java/lang.c (merge_init_test_initialization): New.
	(java_inlining_merge_static_initializers): New.
	(inline_init_test_initialization): New.
	(java_inlining_map_static_initializers): New.

2002-10-11  Mark Wielaard  <mark@klomp.org>

	* gcj.texi (Compatibility): Add Limitations and Extensions section.

2002-10-10  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* class.c (JAVA_TREEHASHHASH_H): Use htab_hash_pointer.

2002-10-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* parse.y (merge_string_cste): Add parentheses around & within |.

2002-10-08  Tom Tromey  <tromey@redhat.com>

	* parse.y (variable_declarator_id): Simplify error path for
	array declarator error.  For PR java/8003.

2002-10-08  Zack Weinberg  <zack@codesourcery.com>

	* gjavah.c, jcf-dump.c, jv-scan.c: Globally replace GCCBUGURL with
	bug_report_url.

2002-10-08  Andrew Haley  <aph@redhat.com>

	* parse.y (attach_init_test_initialization_flags): Check for
	error_mark_node.

2002-10-07  Anthony Green  <green@redhat.com>

	* parse.y (merge_string_cste): Fix bug in string concatenation.

2002-10-03  Michael Koch  <konqueror@gmx.de>

	* gcj.texi (Standard properties):
	Change default of java.awt.toolkit to gnu.awt.gtk.GtkToolkit.

2002-10-02  Roger Sayle  <roger@eyesopen.com>

	PR optimization/6627
	* lang.c (java_init): If storing the vbit in function
	pointers, ensure that force_align_functions_log is atleast
	one to aid compatability with g++ vtables.

2002-10-01  Nathan Sidwell  <nathan@codesourcery.com>

	* jcf-dump.c (print_constant, case CONSTANT_float): Don't fall
	foul of type-based aliasing.

2002-09-30  Anthony Green  <green@redhat.com>

	* gcj.texi (Invoking jv-scan): Fix texinfo.

2002-09-28  Anthony Green  <green@redhat.com>

	* gcj.texi (Invoking jv-scan): Add --no-assert documentation.
	(Code Generation): Add -fno-assert documentation.
	* jv-scan.c (flag_assert): New global.
	(options): Add assert option.
	(help): Add --no-assert documentation.
	* parse-scan.y (flag_assert): New global.
	* lang.c (lang_f_options): Add -fassert/-fno-assert support.
	(flag_assert): New global.
	* java-tree.h (flag_assert): New global.
	* lex.c (java_lex): Obey flag_assert.
	* jvspec.c (jvgenmain_spec): Strip -fassert/-fno-assert when
	calling cc1.

2002-09-26  Andrew Haley  <aph@redhat.com>

	* expr.c (build_java_array_length_access): Check for null pointer.
	* expr.c (expand_java_arrayload): Likewise.

2002-09-21  Richard Henderson  <rth@redhat.com>

	* jcf-parse.c (get_constant): Decode from IEEE no matter
	what the target format.

2002-09-20  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Follow spelling conventions.
	* class.c: Likewise.
	* decl.c: Likewise.
	* expr.c: Likewise.
	* gjavah.c: Likewise.
	* java-tree.h: Likewise.
	* jcf-dump.c: Likewise.
	* jcf-parse.c: Likewise.
	* jvspec.c: Likewise.
	* lang.c: Likewise.
	* mangle.c: Likewise.
	* parse.y: Likewise.

2002-09-17  Tom Tromey  <tromey@redhat.com>

	* lex.c (java_read_unicode_collapsing_terminators): Handle case
	where \r appears at EOF.  Fixes PR java/7950.

2002-09-16  Volker Reichelt  <reichelt@igpm.rwth-aachen.de>

	* jvspec.c (lang_specific_driver): Remove unused variable.

2002-09-16  Geoffrey Keating  <geoffk@apple.com>

	* java-tree.h (union lang_tree_node): Add chain_next option.

2002-09-16  Richard Henderson  <rth@redhat.com>

	* jcf-parse.c (get_constant): Runtime check for IEEE format;
	use new real.h interface.
	* jcf-write.c (find_constant_index): Use new real.h interface.
	* lex.c (IS_ZERO): Use REAL_VALUES_EQUAL.

2002-09-15  Kazu Hirata  <kazu@cs.umass.edu>

	* lang.c: Follow spelling conventions.

2002-09-11  Per Bothner  <per@bothner.com>

	* parse.y (fold_constant_for_init):  If a VAR_DECL, convert numerical
	constant to the type of the field.
	(java_complete_tree):  Remove now-redundant code.

	* parse.y (fold_constant_for_init):  'null' is not a constant expr.

2002-09-03  Jesse Rosenstock  <jmr@ugcs.caltech.edu>

	For PR java/5794:
	* verify.c (verify_jvm_instructions) [OPCODE_jsr]: Only push the
	return label if a ret instruction for the jsr has been reached.

2002-09-09  Ranjit Mathew  <rmathew@hotmail.com>

	* parse.y (DIR_SEPARATOR): Don't define.
	(check_class_interface_creation): Use IS_DIR_SEPARATOR.

2002-08-28  Andrew Haley  <aph@redhat.com>

	* verify.c (verify_jvm_instructions): Allow exception handler
	inside code that is being protected, but generate a warning.
	* except.c (link_handler): Initialize `expanded' in new eh_range.
	(binding_depth, is_class_level, current_pc): Declare extern.

2002-09-01  Mark Wielaard <mark@klomp.org>

	* gcj.texi: Add chapter about system properties.
	Fixed some typos.

2002-08-26  Tom Tromey  <tromey@redhat.com>

	* parse.y (try_builtin_assignconv): Allow narrowing primitive
	conversion if RHS_TYPE is byte, short, or char.

2002-08-22  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Invoking gij): Document -cp and -classpath.

2002-08-21  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (java/jcf-path.o): Use $(datadir), not
	$(prefix)/share.  For PR libgcj/7633.

	For PR java/6005 and PR java/7611:
	* lang.c (LANG_HOOKS_CAN_USE_BITFIELDS_P): New define.
	(java_can_use_bit_fields_p): New function.

2002-08-16  Tom Tromey  <tromey@redhat.com>

	* gcj.texi (Class Initialization): Mention class initialization of
	arrays.

2002-07-30  Andrew Haley  <aph@cambridge.redhat.com>

	* Make-lang.in (java-tree-inline.o): New.
	(JAVA_OBJS): Add java-tree-inline.o.
	* parse.y (source_end_java_method): Call java_optimize_inline.
	(java_expand_method_bodies): Save method's tree in
	DECL_SAVED_TREE.
	(add_stmt_to_compound): Keep track of the number of statments.
	* lang.c (java_init): Enable flag_inline_trees.
	(java_post_options): If flag_inline_functions is on, enable
	flag_inline_trees instread.
	(decl_constant_value): New.
	(java_tree_inlining_walk_subtrees): New.
	* java-tree.h (DECL_NUM_STMTS): New macro.
	(java_optimize_inline): Declare.
	* expr.c (java_expand_expr): Allow a BLOCK to return a value.
	Handle a LABEL_EXPR.
	* decl.c (build_result_decl): If we already have a DECL_RESULT
	don't make another.
	(dump_function): New.
	(java_optimize_inline): New.
	(dump_function): New.

2002-08-13  Jesse Rosenstock  <jmr@fulcrummicro.com>

	For PR java/7483:
	* parse.y (build_assertion): Invert return from
	desiredAssertionStatus.

2002-08-08  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* jcf-write.c (get_access_flags): Return correct access flags for
	private and protected inner classes.

2002-08-08  Nathan Sidwell  <nathan@codesourcery.com>

	* java/Make-lang.in (java.mostlyclean): Remove coverage files.

2002-08-05  Geoffrey Keating  <geoffk@redhat.com>

	* mangle_name.c: Don't include obstack.h twice.
	* xref.c: Don't include obstack.h.

2002-08-04  Geoffrey Keating  <geoffk@redhat.com>

	* class.c: (permanent_obstack): Delete declaration.
	* constants.c: (permanent_obstack): Delete declaration.
	* except.c: (permanent_obstack): Delete declaration.
	* expr.c: (permanent_obstack): Delete declaration.
	* jcf-parse.c: (permanent_obstack): Delete declaration.
	(saveable_obstack): Delete declaration.
	* parse.h: (permanent_obstack): Delete declaration.
	* typeck.c: (permanent_obstack): Delete declaration.

2002-08-04  Joseph S. Myers  <jsm@polyomino.org.uk>

	* gcj.texi (version-gcc): Increase to 3.3.

2002-07-22  Tom Tromey  <tromey@redhat.com>

	* lex.c (java_lex): Check for `e' or `E' after 0.

2002-07-21  Richard Henderson  <rth@redhat.com>

	* lang.c (java_unsafe_for_reeval): New.
	(LANG_HOOKS_UNSAFE_FOR_REEVAL): New.

2002-07-21  Neil Booth  <neil@daikokuya.co.uk>

	* jcf-path.c (GET_ENV_PATH_LIST): Remove.
	(jcf_path_init): Use GET_ENVIRONMENT.

2002-07-10  Roger Sayle  <roger@eyesopen.com>
	    Zack Weinberg <zack@codesourcery.com>

	* builtins.c (initialize_builtins): Remove defines that
	handled C/C++ specific junk hereby removed from builtins.def.

2002-07-07  Neil Booth  <neil@daikokuya.co.uk>

	* lang.c (java_post_options): Update prototype.

2002-07-05  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (initialize_builtins): Ignore the additional
	parameter to DEF_BUILTIN.  Handle more C/C++ specific junk in
	the builtins.def file.

2002-07-01  Tom Tromey  <tromey@redhat.com>

	For PR libgcj/7073:
	* parse.y (patch_incomplete_class_ref): Handle VOID_TYPE
	specially.

2002-07-01  Roger Sayle  <roger@eyesopen.com>

	* java/decl.c (builtin_function): Accept additional parameter.
	(java_init_decl_processing): Pass an additional NULL_TREE
	argument to builtin_function.

2002-06-29  T.J. Mather  <tjmather@maxmind.com>

	* gcj.texi: Fixed gcj invocation example so that it compiles.

2002-06-26  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* lex.c (java_init_lex): Avoid incorrect hardcoded constant 11.
	* parse.y (mark_parser_ctxt): Likewise.
	(check_modifiers, declare_local_variables): Avoid incorrect
	hardcoded constant 10.

	* lex.c (java_read_char): Avoid "comparison is always true"
	warning.

2002-06-25  Andreas Schwab  <schwab@suse.de>

	* expr.c (JSR): Avoid undefined operation on PC.

2002-06-21  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* decl.c (clear_binding_level): Const-ify.

2002-06-13  Akim Demaille  <akim@epita.fr>

	* parse.y (class_declaration, interface_declaration): Make sure
	all their rules have an action, in order to avoid meaningless `$$
	= $1' and their type clashes.

2002-06-11  Tom Tromey  <tromey@redhat.com>

	* jcf-write.c (generate_classfile): Use FIELD_SYNTHETIC.
	* parse-scan.y (statement_without_trailing_substatement): Added
	assert_statement.
	(assert_statement): New rule.
	* java-tree.h (struct lang_type) [assertions]: New field.
	(TYPE_USES_ASSERTIONS): New macro.
	(CLASS_USES_ASSERTIONS): Likewise.
	(FIELD_SYNTHETIC): New define.
	* lex.c (java_lval;): Added ASSERT_TK.
	* parse.y (ASSERT_TK): Added.
	(statement_without_trailing_substatement): Added assert_statement.
	(assert_statement): New rule.
	(build_assertion): New function.
	(maybe_generate_pre_expand_clinit): Create and initialize
	$assertionsDisabled.
	(lookup_package_type): Removed decl.
	* keyword.h: Rebuilt.
	* keyword.gperf (assert): New token.

2002-06-10  Akim Demaille  <akim@epita.fr>

	* parse.y (interface_type_list, class_member_declaration)
	(unary_expression_not_plus_minus): Remove duplicate %type.
	Whitespace changes.

2002-06-09  Tom Tromey  <tromey@redhat.com>

	* Make-lang.in (java/lang.o): Use LANGHOOKS_DEF_H.

	* parse.y (method_header): Give error message in all cases.
	Fixes PR java/6865.

2002-06-10  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	Don't use RTL inlining. Fix for PR java/6820.
	* lang.c (LANG_HOOKS_POST_OPTIONS): Define.
	(flag_really_inline): New.
	(java_decode_option): Set flag_really_inline if -finline-functions
	is seen.
	(java_post_options): New function. Turn off inlining unless
	flag_really_inline is set.

2002-06-10  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* gjavah.c (throwable_p): Accept argument as either a classname or
	signature fragment. Create null-terminated classname string for super
	when calling itself recursively.
	(decode_signature_piece): Skip first character from class name
	signature when calling throwable_p.

2002-06-08  H.J. Lu  (hjl@gnu.org)

	* jcf-path.c (jcf_path_init): Allocate 1 more byte for string.

2002-06-04  Tom Tromey  <tromey@redhat.com>

	* jcf-write.c (perform_relocations): Optmize a goto to a goto.

2002-06-04  Michael Koch  <konqueror@gmx.de>

	* gcj.texi (Input Options): Fixed typo.

2002-06-04  Zack Weinberg  <zack@codesourcery.com>

	* java-tree.h, class.c, expr.c, jcf-parse.c, parse.y,
	typeck.c, verify.c: Remove all #if JAVA_USE_HANDLES blocks,
	all mention of CLASS_TO_HANDLE_TYPE or HANDLE_TO_CLASS_TYPE,
	and all now-pointless local variables.  Rename other local
	variables to reflect their not being handles.

	* java-tree.h, jcf-dump.c, jcf-io.c: Remove all
	#if JCF_USE_STDIO blocks.

	* parse.y: Add missing semicolon at end of rule.

2002-06-03  Geoffrey Keating  <geoffk@redhat.com>

	* check-init.c (attach_initialized_static_class): Delete, unused.
	* parse.y: Use htab_t instead of struct hashtable, update
	all uses.
	* java-tree.h: Include hashtab.h instead of hash.h.
	(struct lang_decl_func): Use htab_t, set up for gengtype.
	(struct init_test_hash_entry): Delete.
	(struct treetreehash_entry): New.
	(java_treetreehash_find): New
	(java_treetreehash_new): New prototype.
	(java_treetreehash_create): New prototype.
	(java_mark_tree): Delete prototype.
	(java_hash_hash_tree_node): Delete prototype.
	(java_hash_compare_tree_node): Delete prototype.
	(attach_initialized_static_class): Delete prototype.
	* expr.c (build_class_init): Update to use java_treetreehash
	functions.
	(java_expand_expr): Update to use htab_t.
	(emit_init_test_initialization): Likewise.
	* decl.c (java_mark_tree): Delete.
	* class.c (init_test_hash_newfunc): Delete.
	(java_hash_hash_tree_node): Delete.
	(java_hash_compare_tree_node): Delete.
	(add_method_1): Update to use java_treetreehash functions.
	(JAVA_TREEHASHHASH_H): New macro.
	(java_treetreehash_hash): New function.
	(java_treetreehash_compare): New function.
	(java_treetreehash_find): New function.
	(java_treetreehash_new): New function.
	(java_treetreehash_create): New function.
	* Make-lang.in (JAVA_TREE_H): Replace hash.h by HASHTAB_H.

	* Make-lang.in (java/parse.o): Depend on debug.h.
	* java-tree.h (struct lang_identifier): Use gengtype.
	(union lang_tree_node): New.
	(struct lang_decl_func): Use gengtype.
	(struct lang_decl_var): Likewise.
	(struct lang_decl): Likewise.
	* parse.y: Include debug.h.
	* lang.c (LANG_HOOKS_MARK_TREE): Delete.

	* lang.c (struct language_function): New dummy structure.

	* java-tree.h (MAYBE_CREATE_VAR_LANG_DECL_SPECIFIC): Set
	descriminator for DECL_LANG_SPECIFIC.
	(struct lang_decl_func): Rename from struct lang_decl.
	(enum lang_decl_desc): New.
	(struct lang_decl): Make it a union.  Update all the accessor macros.
	(struct lang_type): Use gengtype.
	* class.c (add_method_1): Set descriminator for DECL_LANG_SPECIFIC.
	* decl.c (java_dup_lang_specific_decl): All lang_decl structures
	are now the same size.
	(lang_mark_tree): Use gengtype to mark TYPE_LANG_SPECIFIC;
	use discriminator to mark DECL_LANG_SPECIFIC.

	* Make-lang.in (gt-java-builtins.h): New rule.
	(java/builtins.o): Add dependency on gt-<filename>.h.
	* builtins.c: Use gengtype for roots.
	(union string_or_tree): Use gengtype.
	(struct builtin_record): Use gengtype.
	* config-lang.in (gtfiles): Add builtins.c.

	* Make-lang.in (gt-java-class.h, gt-java-constants.h,
	gt-java-decl.h, gt-java-expr.h, gt-java-jcf-parse.h,
	gt-java-jcf-write.h, gt-java-lang.h, gt-java-mangle.h,
	gt-java-parse.h, gtype-java.h): Add rules to generate.
	(parse.o): Add dependency on gt-java-parse.h, gt-java.h.
	(class.o): Add dependency on gt-*.h.
	(constants.o): Likewise.
	(decl.o): Likewise.
	(expr.o): Likewise.
	(jcf-parse.o): Likewise.
	(jcf-write.o): Likewise.
	(lang.o): Likewise.
	* config-lang.in (gtfiles): New.
	* class.c: Replace uses of ggc_add_* with GTY markers.  Include gt-*.h.
	* constants.c: Replace uses of ggc_add_* with GTY markers.
	Include gt-*.h.
	* decl.c: Replace uses of ggc_add_* with GTY markers.  Include gt-*.h.
	* expr.c: Replace uses of ggc_add_* with GTY markers.  Include gt-*.h.
	* java-tree.h: Replace uses of ggc_add_* with GTY markers.
	* jcf-parse.c: Replace uses of ggc_add_* with GTY markers.
	Include gt-*.h.
	* jcf-write.c: Replace uses of ggc_add_* with GTY markers.
	Include gt-*.h.
	* lang.c: Replace uses of ggc_add_* with GTY markers.  Include gt-*.h.
	* mangle.c: Replace uses of ggc_add_* with GTY markers.  Include
	gt-*.h.
	* parse.y: Replace uses of ggc_add_* with GTY markers.  Include gt-*.h.
	Include gtype-java.h.

2002-06-02  Tom Tromey  <tromey@redhat.com>

	Fix for PR java/5913:
	* parse.y (patch_binop): Call patch_string on op1.

2002-06-02  Tom Tromey  <tromey@redhat.com>

	Fix for PR java/1343, PR java/6336:
	* parse.y (make_nested_class_name): Remove extraneous `else'; fix
	formatting.  Changed return type.
	(anonymous_class_counter): Moved to top of file.
	(maybe_make_nested_class_name): Append number to class name for
	function-local classes.

2002-05-28  Zack Weinberg  <zack@codesourcery.com>

	* decl.c, jcf-parse.c, parse.y, typeck.c: Include real.h.
	* Make-lang.in: Update dependency lists.

2002-05-18  Mark Mitchell  <mark@codesourcery.com>

	* gjavah.c (throwable_p): Do not free the name of the class after
	passing it to find_class.
	* java-tree.h (CLASS_BEING_LAIDOUT): Remove duplicate definition.
	* jcf-io.c (dirent.h): Include it.
	(fnmatch.h): Likewise.
	(compare_path): New function.
	(java_or_class_file): Likewise.
	(memoized_dirlist_entry): New type.
	(memoized_dirlist_lookup_eq): New function.
	(memoized_dirlists): New variable.
	(caching_stat): New function.
	(memoized_class_lookup_eq): New function.
	(memoized_class_lookups): Likewise.
	(find_class): Use memoized_class_lookups and caching_stat.
	* jcf.h (JCF_USE_SCANDIR): Define.
	* parse.y (java_expand_classes): Write the class files in reverse
	order.

2002-05-16  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* Make-lang.in: Allow for PWDCMD to override hardcoded pwd.

2002-05-13  Mark Mitchell  <mark@codesourcery.com>

	* jcf-write.c (write_classfile): Unlink the temporary file if it
	cannot be renamed.  Use concat to build up the name of the
	temporary file.

2002-05-08  Mark Mitchell  <mark@codesourcery.com>

	* jcf-write.c (write_classfile): Write the file to a
	temporary file and then rename it.

2002-05-07  Tom Tromey  <tromey@redhat.com>

	* gjavah.c (throwable_p): Use xstrdup, not strdup.

	Fix for PR java/1200:
	* gjavah.c (throwable_p): New function.
	(decode_signature_piece): Use it.  A `WeakReference' isn't the
	same as a `jweak'.
	Include hashtab.h.
	(gcjh_streq): New function.

2002-05-07  Andreas Jaeger  <aj@suse.de>

	* parse.y (finish_for_loop): Fix if statement.

2002-05-06  Tom Tromey  <tromey@redhat.com>

	Fix for PR java/5941:
	* parse.y (finish_for_loop): Set SUPPRESS_UNREACHABLE_ERROR for
	loop update expression.
	(java_complete_lhs): Use SUPPRESS_UNREACHABLE_ERROR.
	* java-tree.h (SUPPRESS_UNREACHABLE_ERROR): New macro.

2002-05-04  Mark Wielaard  <mark@klomp.org>

	For PR java/6519:
	* parse.y (build_string_concatenation): Return just op1 only when op2
	is null and op1 is a STRING_CST, otherwise always construct a
	StringBuffer.

2002-04-27  Tom Tromey  <tromey@redhat.com>

	For PR java/6382:
	* parse.y (string_convert_int_cst): New function.
	(merge_string_cste): Use it.

2002-04-25  Neil Booth  <neil@daikokuya.demon.co.uk>

	* java-tree.h (java_parse_file): Update.
	(java_set_yydebug): Remove.
	* jcf-parse.c (yydebug): Remove.
	(java_set_yydebug): Die.
	(java_parse_file): Update.
	* lang.c (LANG_HOOKS_SET_YYDEBUG): Remove.

2002-04-24  Tom Tromey  <tromey@redhat.com>

	For PR java/6425:
	* parse.y (qualify_ambiguous_name) [case CALL_EXPR]: Always choose
	EXPR_WFL_QUALIFICATION of qual_wfl.

2002-04-23  Per Bothner  <per@bothner.com>

	* expr.c (PRE_JSR):  Call NOTE_LABEL for return address.
	* java-tree.h (BCODE_RETURN_TARGET):  Removed - never set.
	(BCODE_TARGET):  Remove BCODE_RETURN_TARGET.

2002-04-23  Tom Tromey  <tromey@redhat.com>

	For PR java/6314:
	* jvspec.c (lang_specific_driver): Use --resource, not -R.  Also
	recognize `-fcompile-resource='.
	* gcj.texi (Invoking gcj): Use --resource, not -R.  Expanded text
	a bit.

2002-04-22  Alexandre Petit-Bianco  <apbianco@redhat.com>

	* jcf-parse.c: (yyparse): Don't prepend "./" to relative
	paths. Fixes PR java/2791.

2002-04-19  Andrew Haley  <aph@redhat.com>

	* jcf-write.c (push_long_const): lo, hi: New variables.
	Use rshift_double to extract the high part of a 64-bit long.
	Use WORD_TO_INT to extract the low part.

	* jcf-parse.c (get_constant): CONSTANT_Integer: Use an unsigned
	HOST_WIDE_INT for num.  Use JPOOL_UINT to get it.
	CONSTANT_Double: Use JPOOL_UINT to get both halve of a double.

2002-04-18  Neil Booth  <neil@daikokuya.demon.co.uk>

	* typeck.c (incomplete_type_error): Remove.

2002-04-18  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* class.c (make_class_data): Set DECL_ALIGN on static class data,
	for hash synchronization.
	* expr.c (java_expand_expr): Set DECL_ALIGN on static array objects.
	* decl.c (java_init_decl_processing): Don't set TYPE_ALIGN for
	class_type_node.

2002-04-16  Mark Wielaard  <mark@klomp.org>

	* jcf-write.c (generate_bytecode_insns): Only write const_0 if not
	negative zero.

2002-04-16  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	Fix for PR java/6294:
	* parse.h (INNER_INTERFACE_MODIFIERS): Allow ACC_PRIVATE for inner
	interfaces.

2002-04-15  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	Fix for PR java/6085:
	* parse.y (patch_method_invocation): Always use build_access_to_thisn
	to get enclosing "this" argument for inner-class constructor
	invocation. Pass correct arguments to build_access_to_thisn.

2002-04-10  Andreas Jaeger  <aj@suse.de>

	* gcj.texi (Input Options): Fix extdirs patch.

2002-04-10  Anthony Green  <green@redhat.com>

	* jcf-path.c (jcf_path_init) : Clean up local extdirs declaration.

2002-04-09  Anthony Green  <green@redhat.com>

	* gcj.texi (Input Options): Add --extdirs documentation.
	* jcf-dump.c (OPT_extdirs): New macro.
	(options): Add extdirs option.
	(help): Describe --extdirs.
	(main): Handle OPT_extdirs.
	* gjavah.c (OPT_extdirs): New macro.
	(options): Add extdirs option.
	(help): Describe --extdirs.
	(main): Handle OPT_extdirs.
	* jcf-path.c (jcf_path_init): Add extdirs support.
	(jcf_path_extdirs_arg): New function.
	(extensions): New variable to hold extensions path entries.
	* jvspec.c: Remove -fextdirs= when compiling main().
	* lang.c (java_decode_option): Handle -fextdirs=.
	* jcf.h (jcf_path_extdirs_arg): Declare new function.
	* Make-lang.in: Compile jcf-path with version info for use in
	identifying the appropriate libgcj.jar.

2002-04-08  Tom Tromey  <tromey@redhat.com>

	For PR libgcj/5303:
	* .cvsignore: Added rmic.1 and rmiregistry.1.
	* gcj.texi (Top): Link to new nodes.
	(Invoking rmic): New node.
	(Invoking rmiregistry): Likewise.
	* Make-lang.in (java.generated-manpages): Added rmic.1 and
	rmiregistry.1.
	(java.maintainer-clean): Likewise.
	($(srcdir)/java/rmic.1): New target.
	($(srcdir)/java/rmiregistry.1): Likewise.
	(java.install-man): Handle rmic.1 and rmiregistry.1.

2002-04-08  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* gcj.texi (Invocation): Update JvAttachCurrentThread documentation.
	Add note about handling uncaught exceptions. Add an exception handler
	to example.

2002-04-08  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* parse.y (resolve_qualified_expression_name): Clear "from_super" flag
	after using it to patch CALL_EXPR.

2002-04-08  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* gcj.texi (Invocation): Document CNI invocation API.

2002-04-04  Neil Booth  <neil@daikokuya.demon.co.uk>

	* expr.c (truthvalue_conversion): Rename.  Update.
	(expand_compare): Update.
	* java-tree.h (java_truthvalue_conversion): New.
	* lang.c (LANG_HOOKS_TRUTHVALUE_CONVERSION): Redefine.

2002-04-01  Neil Booth  <neil@daikokuya.demon.co.uk>

	* java-tree.h (java_mark_addressable): New.
	* lang.c (LANG_HOOKS_MARK_ADDRESSABLE): Redefine.
	* typeck.c (mark_addressable): Rename, update.

2002-04-01  Neil Booth  <neil@daikokuya.demon.co.uk>

	* expr.c (build_java_binop): Update.
	* java-tree.h (java_signed_type, java_unsigned_type,
	java_signed_or_unsigned_type): Update.
	* lang.c (LANG_HOOKS_SIGNED_TYPE, LANG_HOOKS_UNSIGNED_TYPE,
	LANG_HOOKS_SIGNED_OR_UNSIGNED_TYPE): New.
	* parse.y (patch_binop): Update.
	* typeck.c (signed_or_unsigned_type, unsigned_type,
	signed_type): Update.

2002-03-31  Neil Booth  <neil@daikokuya.demon.co.uk>

	* lang.c (LANG_HOOKS_PRINT_ERROR_FUNCTION): Redefine.
	(java_dummy_print): Remove.
	(lang_print_error): Rename.  Exit early if inhibiting output.
	(inhibit_error_printing_function): New.
	(java_init): Don't set hook.
	(lang_init_source): Use new boolean.

2002-03-29  Martin Kahlert  <martin.kahlert@infineon.com>

	* parse.y (do_resolve_class): Fix infinite recursion.

2002-03-29  Tom Tromey  <tromey@redhat.com>

	* parse.y (check_inner_circular_reference): Ignore incomplete
	types.

2002-03-29  Neil Booth  <neil@daikokuya.demon.co.uk>

	* Make-lang.in (builtins.o): Update.
	* boehm.c (get_boehm_type_descriptor): Update.
	* builtins.c: Include langhooks.h.
	* decl.c (java_init_decl_processing): Update.
	* java-tree.h (java_type_for_mode, java_type_for_size): New.
	* lang.c (LANG_HOOKS_TYPE_FOR_MODE, LANG_HOOKS_TYPE_FOR_SIaZE):
	Redefine.
	* typeck.c (type_for_mode, type_for_size): Update.

2002-03-29  Martin Kahlert  <martin.kahlert@infineon.com>

	* lex.c (java_new_lexer): Alias "646" to DEFAULT_ENCODING.

2002-03-28  Tom Tromey  <tromey@redhat.com>

	* except.c (expand_end_java_handler): If the handler type is NULL,
	use java.lang.Throwable.  Fixes PR java/5986.

2002-03-28  Alexandre Petit-Bianco  <apbianco@redhat.com>

	Fix for PR java/4715:
	* jcf-parse.c (parse_source_file_3): New function.
	(read_class): Call it.
	(java_parse_file): Likewise.

2002-03-28  Jan Hubicka  <jh@suse.cz>

	* java/lang.c (java_init_options): Set flag_trapping_math to 0.

2002-03-28  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	* parse.y (resolve_package): Initialize "decl".
	(lookup_package_type): Remove unused function.

2002-03-28  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	Fix for PR java/5993:
	* parse.y (resolve_package): Return the decl if resolution was
	successful. Don't special case "java.lang" and "java.lang.reflect"
	packages. Set type_name to the merged identifier.
	(resolved_qualified_expression_name): Print error using "name" if
	resolve_package returns NULL_TREE.

2002-03-27  Tom Tromey  <tromey@redhat.com>

	* expr.c (expand_invoke): Don't generate null pointer check if
	we're calling <init>.

2002-03-27  Neil Booth  <neil@daikokuya.demon.co.uk>

	* expr.c (java_lang_expand_expr): Rename java_expand_expr,
	fix prototype.
	* java-tree.h (java_lang_expand_expr): Similarly.
	* lang.c (LANG_HOOKS_EXPAND_EXPR): Redefine.
	(java_init): Don't set hook.

2002-03-27  Bryce McKinlay  <bryce@waitaki.otago.ac.nz>

	Fix for PR java/5850:
	* parse.y (lookup_field_wrapper): Call itself recursively for enclosing
	context if field was not found in the current scope.
	* expr.c (lookup_field): Don't look in enclosing contexts.

2002-03-26  Tom Tromey  <tromey@redhat.com>

	Fix for PR java/5942:
